<?php
trait WS_EmailTemplate
{
	public function Slot_EmailTemplate($SlotID, $HtmlTemplate="",$EmailTemplate="")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}
		
		$SlotKey = $this->GetSlotKey($SlotID);

		$this->ReadInputSlots($this->WS_Page->PageID, $SlotID,  "MAI");
	
		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$DdlVal = array("", "ssl", "tls");
			$Params = array();
			array_push($Params, new WS_ParamDef("Text", "Html Template:", 80, 10, "TXT", null));
			array_push($Params, new WS_ParamDef("Param0", "Email Template:", 80, 10, "TXT", null));
			array_push($Params, new WS_ParamDef("Param1", "Subject: ", 80, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param2", "Destination:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param3", "Smtp:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param4", "Smtp Port:", 5, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param5", "Smtp User:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param6", "Smtp Password:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param7", "From:", 25, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param8", "Secure:", 25, 1, "DDL", $DdlVal));
			array_push($Params, new WS_ParamDef("Param9", "CSS class:", 80, 1, "CLS",null));
			array_push($Params, new WS_ParamDef("Update", "Update", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null));
			$this->DrawConfigSlots($this->WS_Page->PageID, $SlotID,  $Params);
		}
		
		
		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			$HtmlTemplate = $this->WS_Page->Slots[$SlotKey]->Text;
			$EmailTemplate = $this->WS_Page->Slots[$SlotKey]->Param[0];
			$Subject = $this->WS_Page->Slots[$SlotKey]->Param[1];
			$To = $this->WS_Page->Slots[$SlotKey]->Param[2];
			$Host = $this->WS_Page->Slots[$SlotKey]->Param[3];
			$Port = $this->WS_Page->Slots[$SlotKey]->Param[4];
			$Username = $this->WS_Page->Slots[$SlotKey]->Param[5];
			$Password = $this->WS_Page->Slots[$SlotKey]->Param[6];
			$From = $this->WS_Page->Slots[$SlotKey]->Param[7];
			$SMTPSecure = $this->WS_Page->Slots[$SlotKey]->Param[8];
			$CssClass = $this->WS_Page->Slots[$SlotKey]->Param[9];
		}
		$CSS = "";
		
		// GET TEMPLATE KEYS
		$HtmlKeys =  WS::GetElementFromString($HtmlTemplate,"<@","@>");
		$EmailKeys =  WS::GetElementFromString($EmailTemplate,"<@","@>");
			
		if (filter_input(INPUT_POST, $SlotKey."_Send"))
		{
			// UPDATER
			$EmailTemplate = $this->EmailTemplate_Update($SlotKey,$EmailKeys, $EmailTemplate);
			try
			{
				$mail = new PHPMailer(true);
				$mail->SMTPDebug  = 0;
				$mail->IsSMTP();
				$mail->Host = $Host;
				$mail->Port = intval($Port);
				if ($Username != "")
				{
					$mail->SMTPAuth = true;
					$mail->Username = $Username;
					$mail->Password = $Password;
				}
				$mail->SMTPSecure = $SMTPSecure;
				$mail->AddReplyTo($To, $To);
				$mail->AddAddress($To, $To);
				$mail->SetFrom($From, $From);
				$mail->Subject = $Subject;
				$mail->isHTML(true);
				$mail->Body = $EmailTemplate;

				$mail->Send();
			}
			catch (Exception $ex)
			{
				echo $mail->ErrorInfo;
			}
		}
		
		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			$Slot = $this->WS_Page->Slots[$SlotKey];
			$Template = $Slot->Text;
			$TemplateHeader = $Slot->Param[0];
			$TemplateFooter = $Slot->Param[1];
			$Sql = $Slot->Param[2];
			$CSS = $Slot->Param[3];
			$RowsForPage = intval($Slot->Param[4]);
			$ConnectionProprety = $Slot->Param[5];
			$Link = $Slot->Link;
		}
		
		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver\">";
			echo $this->DrawEditButton($SlotKey, "Text", "Edit Template", "ws_btnedit-t ws_absolute",  $HtmlTemplate);
		}
		
		// SLOT DRAWER
		$this->EmailTemplate_Draw($SlotKey,$HtmlTemplate,$HtmlKeys);
		echo "<br/><br/><input class=\"ws_button\" name=\"".$SlotKey."_Send\" type=\"submit\" value=\"".$WS->GetTranslation("Send")."\"\">";
		// EDIT MODE CLOSE
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
		
	}

	private function EmailTemplate_Update($SlotKey,$Keys, $EmailTemplate)
	{
		global $WS;
		foreach ($Keys as $Key)
		{
			$Key = $this->EmailTemplate_ClearKey($Key);
			$Tag= $this->EmailTemplate_GetTag($Key);
			$Prop= $this->EmailTemplate_GetProperties($Key);
			
			switch($Tag)
			{
				case "output":

					// SetTemplate
					if (array_key_exists("name", $Prop)) 
					{
						$PostName = $SlotKey."_".$Prop["name"];
						$Value = filter_input(INPUT_POST, $PostName);
						$Value = str_replace("\n", "<br/>", $Value);
						$Value = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;", $Value);
						$EmailTemplate = str_replace("<@".$Key."@>", $Value, $EmailTemplate);
					}
					break;

				case "translate":
					$Value="";
					if (array_key_exists("text", $Prop)){$Value = $WS->GetTranslation($Prop["text"]);}
					$EmailTemplate = str_replace("<@".$Key."@>", trim($Value), $EmailTemplate);
					break;
					
				default:
					break ;
			}
		}
		return $EmailTemplate;
	}
	
	private function EmailTemplate_Draw($SlotKey,$Template,$Keys)
	{
		global $WS;
		
		foreach ($Keys as $Key)
		{
			$Key = $this->EmailTemplate_ClearKey($Key);
			$Tag= $this->EmailTemplate_GetTag($Key);
			$Prop= $this->EmailTemplate_GetProperties($Key);
			$Val="";
			switch ($Tag)
			{
				case "input":
					if (array_key_exists("name", $Prop)) 
					{
						$Name = " name=\"".$SlotKey."_".$Prop["name"]."\" ";
						$Par="";
						if (array_key_exists("size", $Prop)) {$Par .= " size=\"".$Prop["size"]."\" maxlength=\"".$Prop["size"]."\" ";}
						if (array_key_exists("rows", $Prop) && array_key_exists("size", $Prop)) 
						{
							$Value =  "<textarea ".$Name." value=\"\" rows=\"".$Prop["rows"]."\" cols=\"".$Prop["size"]."\"/></textarea>";
						}
						else
						{
							$Value =  "<input ".$Par.$Name." type=\"text\" value=\"\" />";
						}
						
						$Template = str_replace("<@".$Key."@>", $Value, $Template);
					}
					break;
					
				case "translate":
					$Value="";
					if (array_key_exists("text", $Prop)){$Value = $WS->GetTranslation($Prop["text"]);}
					$Template = str_replace("<@".$Key."@>", $Value, $Template);
					break;
					
				default:
					break ;
			}
			
		}
		echo $Template;
	}
	
	private function EmailTemplate_ClearKey($Key)
	{
		return substr(substr($Key,0,strlen($Key)-2),2);
	}
	
	private function EmailTemplate_GetTag($Key)
	{
		$Param = explode(" ",$Key);
		return $Param[0];
	} 
	
	private function EmailTemplate_GetProperties($Key)
	{
		$Tag = $this->EmailTemplate_GetTag($Key);
		$Key = trim(substr($Key,strlen($Tag)));
		
		$Properties = array();
		while (strpos($Key,'=') !== false)
		{
			$Name = trim(substr($Key,0, strpos($Key,"=")));
			$Key = substr($Key,strpos($Key,"\"")+1);
			$Value =  substr($Key,0,strpos($Key,"\""));
			$Key = trim(substr($Key,strpos($Key,"\"")+1));
			$Properties[strtolower($Name)] = $Value;
		}
		
		return $Properties;
	}
}
?>