<?php
include "../Config.php";

class ConnectDBSync extends mysqli
{
	public static $ClusterUrl="";
	public $DBServer="";
	public $User="";
	public $Password="";
	public $DbName="";
	public $NumOfRows = 0;
	private $Result=null;
	private $Rows=null;
	private $SyncPathOut="";
	private $SyncPathIn="";
		
	public function __construct($Server,$User,$Password,$DbName)
	{
		parent::__construct($Server,$User,$Password,$DbName); 
		$this->$DBServer=$Server;
		$this->User=$User;
		$this->Password=$Password;
		$this->DbName=$DbName;
		
		$this->SyncPathOut = $_SERVER['DOCUMENT_ROOT']."/SyncOut";
		if (!file_exists($this->SyncPathOut)) {mkdir($this->SyncPathOut);}
		
		$this->SyncPathIn = $_SERVER['DOCUMENT_ROOT']."/SyncIn";
		if (!file_exists($this->SyncPathIn)) {mkdir($this->SyncPathIn);}
	}
	
	public function query($sql,$NoSync=false)
	{
		$this->Result = parent::query($sql);
		if(isset($this->Result->num_rows)) {$this->NumOfRows=$this->Result->num_rows;}
		
		if ((!$NoSync)&&(ConnectDBSync::$ClusterUrl!=""))
		{
			$Enq=false;
			if (posstr(strtolower($sql),"insert") !== false){$Enq=true;}
			if (posstr(strtolower($sql),"update") !== false){$Enq=true;}
			if (posstr(strtolower($sql),"delete") !== false){$Enq=true;}
			if ($Enq)
			{
				$tmpfname = tempnam($this->SyncPathOut, "sql");
				$sql=crypt($sql);
				file_put_contents($tmpfname, $sql);
			}
			
			$this->Send();
		}
		return $this->Result;
	}
	
	public function UpdateFileSync($FilePath)
	{
		if (ConnectDBSync::$ClusterUrl!="")
		{
			$tmpfname = tempnam($this->SyncPathOut, "upd");
			file_put_contents($tmpfname, $FilePath);
			copy($FilePath,$tmpfname."dat");
		}
	}
	
	public function DeleteFileSync($FilePath)
	{
		if (ConnectDBSync::$ClusterUrl!="")
		{
			$tmpfname = tempnam($this->SyncPathOut, "del");
			file_put_contents($tmpfname, $FilePath);
		}
	}
	
	public function Send()
	{
		// FORK
		if (ConnectDBSync::$ClusterUrl!="")
		{
			$pid = pcntl_fork();
			if ($pid) 
			{
				 return;
			} 
			else 
			{
				 $Dir = Dir($this->SyncPathOut."*");
				 foreach($Dir as $F)
				 {
					 try
					 {
						 // SEND
						$params = array
						(
							'ws_sync' => '@' . realpath($F).';filename='.$F,
							'DestPath'=>$file
						);  
						 
						$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL, ConnectDBSync::$ClusterUrl);
						curl_setopt($ch, CURLOPT_POST,true);
						curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
						curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
						$response = curl_exec($ch);
						curl_close($ch); 
						
						unlink($F);
					}
					catch(Exception $e)
					{}
				 }
			}
		}
	}

	public function Sync()
	{
		foreach ($_FILES["ws_sync"]["error"] as $key => $error) 
		{
			if ($error == UPLOAD_ERR_OK) 
			{
				$tmpfname = $_FILES["ws_sync"]["tmp_name"][$key];
				$name = $_FILES["ws_sync"]["name"][$key];
				
				move_uploaded_file($tmp_name, $SyncPathIn."/".$name);
			}
		}
		
		$Dir = Dir($this->SyncPathOut."*");
		foreach($Dir as $F)
		{
			$info = new SplFileInfo($SyncPathIn."/".$name);
			
			if ($info->getExtension() == "sql")
			{
				$Sql = file_get_contents($SyncPathIn."/".$name);
				query(decrypt($Sql));
				unlink($SyncPathIn."/".$name);
			}
			if ($info->getExtension() == "del")
			{
				$Path = file_get_contents($SyncPathIn."/".$name);
				unlink($Path);
				unlink($SyncPathIn."/".$name);
			}
			if ($info->getExtension() == "upd")
			{
				if (file_exists($SyncPathIn."/".$name.".dat"))
				{
					$Path  = file_get_contents($SyncPathIn."/".$name);
					$Data  = file_get_contents($SyncPathIn."/".$name.".dat");
					file_put_contents($Path,$Data);
					unlink($SyncPathIn."/".$name);
					unlink($SyncPathIn."/".$name.".dat");
				}
			}
		}
	}
	
	public function Disconnect()
	{
		try {parent::close();}
		catch(Exception $Ex) {}
	}
	
	public static function FormatStr($Str)
	{
		return str_replace("'","''",$Str);
	}
}