<?php

class QueryPager
{
	private $ID;
	private static $PagerCount=0;
	
	public function __construct()
	{
		$this->ID = "_Pager_".str_replace(".php","",basename($_SERVER['PHP_SELF'])).QueryPager::$PagerCount++;
		if (QueryPager::$PagerCount>10000) {QueryPager::$PagerCount=0;}
	}

	public function Open($DB,$Sql,$Step=10)
	{
		$_SESSION["PagerStep".$this->ID] = $Step;
		if (!isset($_SESSION["PagerNREC".$this->ID])) {$_SESSION["PagerNREC".$this->ID] = 0;}
		if (!isset($_SESSION["PagerPOS".$this->ID])) {$_SESSION["PagerPOS".$this->ID] = 0;}
		
		$NRec = $_SESSION["PagerNREC".$this->ID];
		$Pos = $_SESSION["PagerPOS".$this->ID];
		$NPG =  $NRec / $Step;
		
		$Start = $Pos-6;
		if($Start<=1){$Start=1;}
		
		$End = $Pos+6;
		if($End>$NPG){$End=$NPG;}
		
		for ($N=$Start;$N<=$End;$N++)
		{
			if(isset($_POST['Pager'.$N]))
			{
				$_SESSION["PagerPOS".$this->ID] = ($N-1) * $Step;
			}
		}
		
		
		if(isset($_POST['PagerFirst']))
		{
			$_SESSION["PagerPOS".$this->ID] = 0;
		}
		
		if(isset($_POST['PagerPrev']))
		{
		if ($_SESSION["PagerPOS".$this->ID]-$Step >= 0) {$_SESSION["PagerPOS".$this->ID]-=$Step;}
		}
		
		if(isset($_POST['PagerNext']))
		{
			$Pos = $_SESSION["PagerPOS".$this->ID];
			$NRec=$_SESSION["PagerNREC".$this->ID];
			if ($Pos+$Step <= $NRec-1) {$_SESSION["PagerPOS".$this->ID]+=$Step;}
		}

		if(isset($_POST['PagerLast']))
		{
			$NRec=$_SESSION["PagerNREC".$this->ID];
			$Pos = (intval(($NRec-1)/$Step)*$Step)-$Step;
			if ($Pos <= $NRec-1) {$_SESSION["PagerPOS".$this->ID] = $Pos;}
			if ($Pos < 0) {$_SESSION["PagerPOS".$this->ID] = 0;}
		}
		
		$Result= $DB->query($Sql);
		$_SESSION["PagerNREC".$this->ID] = $Result->num_rows;
		
		$Sql .= " limit ".$this->GetPosition().",".$Step;
		$Result= $DB->query($Sql);
		return $Result;
	}
	
	public function GetPosition()
	{
	   return $_SESSION["PagerPOS".$this->ID];
	}
	
	public function Draw($ClassCSS="")
	{
		echo "<div class=\"".$ClassCSS."\">";
		echo "<input name=\"PagerFirst\" type=\"submit\" value=\"|<\">";
		echo "<input name=\"PagerPrev\" type=\"submit\" value=\"<<\">&nbsp;";
		echo ($_SESSION["PagerPOS".$this->ID]+1)." / ".$_SESSION["PagerNREC".$this->ID];
		echo "&nbsp;<input name=\"PagerNext\" type=\"submit\" value=\">>\">";
		echo "<input name=\"PagerLast\" type=\"submit\" value=\">|\">";
		echo "</div>";
	}
	
	public function DrawNumPager($ClassCSS="")
	{
		echo "<div class=\"".$ClassCSS."\">";
		echo "<input  style=\"cursor:pointer;background-color:transparent;border:none\" name=\"PagerFirst\" type=\"submit\" value=\"|<\">";
		
		$NRec = $_SESSION["PagerNREC".$this->ID];
		$Step = $_SESSION["PagerStep".$this->ID];
		$Pos = $_SESSION["PagerPOS".$this->ID];
		$NPG =  $NRec / $Step;
		$CurrPG = round(($Pos) / $Step + 1); 
		
		$Start = $Pos-6;
		if($Start<=1){$Start=1;}
		
		$End = $Pos+6;
		if($End>$NPG){$End=$NPG;}
		
		for ($N=$Start;$N<=$End;$N++)
		{
			if ($N==$CurrPG)
			{
				echo("<span style=\"background-color:orangered\"><b>".$N."</b></span>");
			}
			else
			{
				echo "<input style=\"cursor:pointer;background-color:transparent;border:none\" name=\"Pager".$N."\" type=\"submit\" value=\"".$N."\">&nbsp;";
			}
		}
		
		echo "<input style=\"cursor:pointer; background-color:transparent;border:none\" name=\"PagerLast\" type=\"submit\" value=\">|\">";
		echo "</div>";
	}
	
	public function Clear()
	{
		$_SESSION["PagerPOS".$this->ID] = null;
		$_SESSION["PagerNREC".$this->ID] = null;
	}
}