<?php
class DropDownViewer
{
	public $FieldPKeys=array();
	public $FieldsInfos = array();
	public $SelectedValue=null;
	public $Message="";
	public $CssSelect="";
	public $CssOption="";
	public $RowCount=0;
	public $AutoPostBack=false;
	public $NullValue=false;
	
	private static $DropDownViewerCount=0;
	private $DDLCount;
	private $DB;
	private $Sql="";
	private $IsEmpty;
	private $Result;
	private $SessionName;
	
	public function __construct($DB,$Sql)
	{
		// GET COULUMS
		$this->DDLCount = self::$DropDownViewerCount++;
		$this->DB = $DB;
		$this->Sql = $Sql;
		$this->Query();
		$this->SessionName = "DDL_".basename($_SERVER['PHP_SELF'])."_".$this->DDLCount;
		$this->ManagePostBack();
		if (isset($_SESSION[$this->SessionName])) $this->SelectedValue = $_SESSION[$this->SessionName];
	}
	
	private function ManagePostBack()
	{
		if (count($_POST)> 0) 
		{
			if (isset($_POST["DDL".$this->DDLCount]))
			{
				$this->SelectedValue = $_POST["DDL".$this->DDLCount];
				$_SESSION[$this->SessionName] = $this->SelectedValue;
			}
		}
	}
	
	private function Query()
	{
		$this->Result=$this->DB->query($this->Sql);
		if ($this->Result === false)
		{
			echo $this->DB->error;
		}
		if ($this->Result === false)
		{
			echo("SQL ERROR: Query error<br/>".$this->Sql."<br/>".$this->DB->error);
		}
		else
		{
			// GET INFO
			$this->RowCount = $this->Result->num_rows;
			$K=0;
			$this->FieldsInfos = array();
			for ($N=0;$N<$this->Result->field_count;$N++) 
			{
				$Info = $this->Result->fetch_field_direct($N);
				if (($Info->charsetnr == 33)&&(in_array($Info->type,$this->Type_Str))) 
					{$Info->length /= 3;}
				if (($Info->flags & 2) == 2)
				{
					array_push($this->FieldPKeys,$Info->orgname);
					$K++;
				}
				if ($Info->orgname!="")
					{array_push($this->FieldsInfos,$Info);}
				else
					{array_push($this->FieldsInfos,$Info);}
			}
		}
	}
	
	public function Draw()
	{
		$Class="";
		if($this->CssSelect != "") {$Class="class=\"".$this->CssSelect."\"";}
		
		$Submit="";
		if ($this->AutoPostBack)
		{
			$Submit = " onchange=\"document.forms[0].submit();\" ";
		}

		echo "<select ".$Class." name=\"DDL".$this->DDLCount."\" ".$Submit." >";

		$Class="";
		if($this->CssOption != "") {$Class="class=\"".$this->CssOption."\"";}
		if ($this->NullValue) {echo "<option " . $Class . " value=\"\"></option>";}
		
		
		if ($this->Result !== false)
		{
			for ($R=0;$R<$this->Result->num_rows;$R++)
			{
				$Class="";
				if($this->CssOption != "") {$Class="class=\"".$this->CssOption."\"";}

				$row = $this->Result->fetch_assoc();

				$C=0;
				foreach ($this->FieldsInfos as $Info)
				{
					if ($C==0)
					{
						$Val = $row[$Info->name];
						$Txt = $row[$Info->name];
					}
					if ($C==1)
					{
						$Txt = $row[$Info->name];
					}
					$C++;
				}
				
				$Select="";
				if (isset($_SESSION[$this->SessionName]) && ($_SESSION[$this->SessionName] == $Val)) {$Select = " selected ";}
				
				echo "<option " . $Select . $Class . " value=\"" . $Val . "\" >" . $Txt . "</option>";
			}
			
		}
		echo "</select>";
	}
	
	public function Requery()
	{
		$this->Query();
	}
	
}

