<?php

class GlobalObjField
{
	public $Name;
	public $Pos;
	public $PKey;
	public $Type;

	function ToXml()
	{
		$Ret = "<GlobalObjField>";
		$Ret .= "<Name>" . $this->$Name . "</Name>";
		$Ret .= "<Pos>" . $this->$Pos . "</Pos>";
		$Ret .= "<Type>" . $this->$Type . "</Type>";
		$Ret .= "<PKey>" . $this->$Pos . "</PKey>";
		$Ret .= "</GlobalObjField>";
		return $Ret;
	}
	function FromXml($XmlStr)
	{
		$Xml = new DOMDocument();
		$Xml->loadXML($XmlStr);
		$this->Name = $Xml->getElementsByTagName("Name")->nodeValue;
		$this->Pos = $Xml->getElementsByTagName("Pos")->nodeValue;
		$this->Type = $Xml->getElementsByTagName("Type")->nodeValue;
		$this->PKey = $Xml->getElementsByTagName("PKey")->nodeValue;
	}
}

class GlobalObjDesc
{
	private $SS_ID;
	private $S_ID;
	private $U_ID;
	private $O_ID;
	
	public $S_Name;
	public $U_Name;
	public $O_Name;
	public $Ext;
	public $Flds = array();
	private $GODB; 
	
	public function __construct($WSDB)
	{
		$this->WSDB = $WSDB;
	}
	function ToXml()
	{
		$Ret = "<GlobalObjDesc>";
		$Ret .= "<S_Name>" . $this->S_Name . "</S_Name>";
		$Ret .= "<U_Name>" . $this->U_Name . "</U_Name>";
		$Ret .= "<O_Name>" . $this->O_Name . "</O_Name>";
		$Ret .= "<Ext>" . $this->Ext . "</Ext>";
		$Ret .= "<Cols>";
		foreach($this->Cols as $Col) {$Ret .= $Col::ToXml();}
		$Ret .= "</Cols>";
		$Ret .= "</GlobalObjDesc>";
		return $Ret;
	}
	function FromXml($XmlStr)
	{
		$Xml = new DOMDocument();
		$Xml->loadXML($XmlStr);
		$this->S_Name = $Xml->getElementsByTagName("S_Name")->nodeValue;
		$this->U_Name = $Xml->getElementsByTagName("U_Name")->nodeValue;
		$this->O_Name = $Xml->getElementsByTagName("O_Name")->nodeValue;
		$this->Ext = $Xml->getElementsByTagName("Ext")->nodeValue;
		$N=0;
		foreach($Xml->getElementsByTagName("Cols") as $C)
		{
			$Col = new GlobalObjCol();
			$Col->FromXml($C-> saveXML());
			$this->Cols[$N] = $Col;
			$N++;
		}
	}
	function LoadIDs()
	{
		if (isset($this->S_Name) && (!isset($this->S_ID)))
		{
			$Sql = "SELECT SS_ID,S_ID FROM Serv WHERE S_Name='" . $this->S_Name . "'";
			$result = ConnectDB::Query($Sql);
			if ($result->num_rows != 0)
			{
				$row = $result->fetch_assoc();
				$this->SS_ID = $row["SS_ID"];
				$this->SS_ID = $row["S_ID"];
			}
		}
		
		if (isset($this->U_Name) && (!isset($this->U_ID)))
		{
			$Sql = "SELECT U_ID FROM Usr WHERE U_Name='" . $this->U_Name . "'";
			$result = $this->GODB->query($Sql);
			if ($result->num_rows != 0)
			{
				$row = $result->fetch_assoc();
				$this->U_ID = $row["U_ID"];
			}
		}
		
		if (isset($this->O_Name) && (!isset($this->O_ID)))
		{
			$Sql = "SELECT O_ID FROM WHERE O_Name='" . $this->O_Name . "'";
			$result = $this->GODB->query($Sql);
			if ($result->num_rows != 0)
			{
				$row = $result->fetch_assoc();
				$this->O_ID = $row["O_ID"];
			}
		}
	}
	function LoadNames()
	{
		if (isset($this->S_ID) && (!isset($this->S_Name)))
		{
			$Sql = "SELECT S_Name FROM Serv WHERE SS_ID=" . $this->SS_ID . " AND S_ID=" . $this->S_ID;
			$result = $this->GODB->query($Sql);
			if ($result->num_rows != 0)
			{
				$row = $result->fetch_assoc();
				$this->S_Name = $row["S_Name"];
			}
		}
		
		if (isset($this->U_ID) && (!isset($this->U_Name)))
		{
			$Sql = "SELECT U_Name FROM Usr WHERE U_ID=" . $this->U_ID;
			$result = $this->GODB->query($Sql);
			if ($result->num_rows != 0)
			{
				$row = $result->fetch_assoc();
				$this->U_Name = $row["U_Name"];
			}
		}
		
		if (isset($this->O_ID) && (!isset($this->O_Name)))
		{
			$Sql = "SELECT O_Name FROM WHERE O_ID='" . $this->O_ID . "'";
			$result = $this->GODB->query($Sql);
			if ($result->num_rows != 0)
			{
				$row = $result->fetch_assoc();
				$this->O_Name = $row["O_Name"];
			}
		}
	}
	function Load($SS_ID,$S_ID,$U_ID,$O_ID)
	{
		if (isset($this->S_ID) && (!isset($this->S_Name)))
		{
			$Sql = "SELECT * FROM Objs WHERE SS_ID=" . SS_ID . " AND S_ID=" . S_ID . " AND U_ID=" . U_ID . " AND U_ID=" . O_ID;
			$result = $this->GODB->query($Sql);
			if ($result->num_rows != 0)
			{
				$row = $result->fetch_assoc();
				$this->SS_ID=$SS_ID;
				$this->S_ID=$S_ID;
				$this->U_ID=$U_ID;
				$this->O_ID=$O_ID;
				$this->O_Name = $row["O_Name"];
				$this->Ext = $row["Ext"];
			}
			$Sql = "SELECT * FROM ObjFlds WHERE SS_ID=" . SS_ID . " AND S_ID=" . S_ID . " AND U_ID=" . U_ID . " AND U_ID=" . O_ID;
			$result = $this->GODB->query($Sql);
			$Row=$result->fetch_assoc();
			while($Row != null)
			{
				$Fld = new GlobalObjField();
				$Fld->SS_ID=$SS_ID;
				$Fld->S_ID=$S_ID;
				$Fld->U_ID=$U_ID;
				$Fld->O_ID=$O_ID;
				$Fld->F_ID=$Row["F_ID"];
				$Fld->F_Name=$Row["F_Name"];
				$Fld->F_Pos=$Row["F_Pos"];
				$Fld->F_Key=$Row["F_Key"];
				$Fld->F_Type=$Row["F_Type"];
				$this->Flds[$Fld->F_ID] = $Fld;
				$Row=$result->fetch_assoc();
			}
		}
	}
	function Save()
	{
		LoadIDs();
	
		$Sql = "SELECT O_ID FROM Objs ";
		$Sql .= "WHERE SS_ID=" . $this->SS_ID . " AND S_ID=" . $this->S_ID . " AND U_ID=" . $this->U_ID . " AND O_Name='" . $this->Obj . "'";
		$result = $this->GODB->query($Sql);
		if ($result->num_rows != 0)
		{
			// UPDATE Colums only ??
			
			SaveFlds();
		}
		else
		{
			// INSERT
			$Sql = "INSERT INTO Objs (SS_ID,S_ID,U_ID,O_ID,O_Name,O_FCount,O_Ext) VALUES ";
			$Sql .= "(" . $this->SS_ID . "," . $this->S_ID . "," . $this->U_ID  . "," . $this->O_ID  . ",'" . $this->O_Name . "'," . length($this->Cols) . ",'" . $this->Ext . "')";
			$this->GODB->query($Sql);
			SaveFlds();
		}
	}
	function SaveFlds()
	{
		$Sql = "DELETE FROM ObjFlds WHERE SS_ID=" . $this->SS_ID . " AND S_ID=" . $this->S_ID . " AND U_ID=" . $this->U_ID . " AND O_ID=" . $this->O_ID;
		$this->GODB->query($Sql);
		
		foreach($this->Flds as $Fld)
		{
			$Sql = "INSERT INTO Objs (	SS_ID,S_ID,U_ID,O_ID,F_ID,F_Name,F_Pos,F_Key,F_Type,F_Name) VALUES ";
			$Sql .= "(" . $this->SS_ID . "," . $this->S_ID . "," . $this->U_ID  . "," . $this->O_ID  . ",'" . $this->O_Name . "'," . length($this->Cols) . ",'" . $this->Ext . "')";
			$this->GODB->query($Sql);
		}
	}
}

class GlobalObjDatRow
{
	public $Dat = array();
	function ToXml()
	{
		$Ret = "<GlobalObjDatRow>";
		foreach($this->Dat as $D) {$Ret .= "<Dat>" . $D . "</Dat>";}
		$Ret .= "</GlobalObjDatRow>";
		return $Ret;
	}
	function FromXml($XmlStr)
	{
		$Xml = new DOMDocument();
		$Xml->loadXML($XmlStr);
		$N=0;
		foreach($Xml->getElementsByTagName("Dat") as $C)
		{
			$this->Dat[$N] = $C;
			$N++;
		}
	}
}

class GlobalObj
{
	public $GlobalObjDesc;
	public $GlobalObjDatRow;
	private $GODB; 
	
	public function __construct($WSDB)
	{
		$this->WSDB = $WSDB;
	}	
	function ToXml()
	{
		$Ret = "<GlobalObj>";
		$this->$GlobalObjDesc->ToXml();
		$this->$GlobalObjDatRow->ToXml();
		$Ret .= "</GlobalObj>";
	}
	function FromXml($XmlStr)
	{
		$Xml = new DOMDocument();
		$Xml->loadXML($XmlStr);
		
		$Node = $Xml->getElementsByTagName("GlobalObjDesc");	
		$this->$GlobalObjDesc->FromXml($Node->saveXML());
		
		$Node = $Xml->getElementsByTagName("GlobalObjDatRow");	
		$this->$GlobalObjDatRow->FromXml($Node->saveXML());
	}
	function SaveData()
	{
		$Sql = "SELECT O_ID FROM Objs ????";
		$Sql .= "WHERE SS_ID=" . $this->SS_ID . " AND S_ID=" . $this->S_ID . " AND U_ID=" . $this->U_ID . " AND O_Name='" . $this->Obj . "'";
		$result = $this->GODB->query($Sql);
		if ($result->num_rows != 0)
		{
			// UPDATE Colums only ??
			
			SaveFlds();
		}
		else
		{
			// INSERT
			$Sql = "INSERT INTO Objs (SS_ID,S_ID,U_ID,O_ID,O_Name,O_FCount,O_Ext) VALUES ";
			$Sql .= "(" . $this->SS_ID . "," . $this->S_ID . "," . $this->U_ID  . "," . $this->O_ID  . ",'" . $this->O_Name . "'," . length($this->Cols) . ",'" . $this->Ext . "')";
			$this->GODB->query($Sql);
			SaveFlds();
		}
	}
}

class GlobalObjs
{
	public $GlobalObjDesc;
	public $GlobalObjDatRows = array();
	private $GODB; 
	
	public function __construct($WSDB)
	{
		$this->WSDB = $WSDB;
	}
	function ToXml()
	{
		$Ret = "<GlobalObjs>";
		$this->GlobalObjDesc->ToXml();
		foreach($this->GlobalObjDatRows as $Row) {$Ret .= $Row::ToXml();}
		$Ret .= "</GlobalObjs>";
	}
	function FromXml($XmlStr)
	{
		$Xml = new DOMDocument();
		$Xml->loadXML($XmlStr);
		
		$Node = $Xml->getElementsByTagName("GlobalObjDesc");	
		$this->$GlobalObjDesc->FromXml($Node->saveXML());
		
		$Nodes = $Xml->getElementsByTagName("GlobalObjDatRows");
		$N=0;
		foreach($Nodes  as $Node)
		{		
			$this->$GlobalObjDatRows[$N]->FromXml($Node->saveXML());
		}
	}
	function Select($Obj)
	{
	
	}
}
?>
