CREATE TABLE IF NOT EXISTS `ws_menus` (
  `SiteID` int(11) NOT NULL DEFAULT 1,
  `MenuID` varchar(30) NOT NULL DEFAULT '',
  `Pos` int(11) NOT NULL DEFAULT 0,
  `SubPos` int(11) NOT NULL DEFAULT '0',
  `Lang` varchar(3) DEFAULT '',
  `DropDown` bit(1) NOT NULL DEFAULT b'0',
  `Text` varchar(50) DEFAULT '',
  `Tooltip` varchar(100) DEFAULT '',
  `Link` varchar(250) DEFAULT '',
  `Permisions` varchar(250) DEFAULT 'all',
  PRIMARY KEY (`SiteID`,`MenuID`,`Pos`,`SubPos`,`Lang`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `ws_pages` (
  `SiteID` int(11) NOT NULL DEFAULT 1,
  `PageID` int(11) NOT NULL DEFAULT 0,
  `Path` varchar(200) DEFAULT '',
  `Name` varchar(50) DEFAULT '',
  `MasterTemplate` varchar(50) NOT NULL DEFAULT '',
  `BodyTemplate0` varchar(50) NOT NULL DEFAULT '',
  `BodyTemplate1` varchar(50) NOT NULL DEFAULT '',
  `BodyTemplate2` varchar(50) NOT NULL DEFAULT '',
  `BodyTemplate3` varchar(50) NOT NULL  DEFAULT '',
  `BodyTemplate4` varchar(50) NOT NULL  DEFAULT '',
  `BodyTemplate5` varchar(50) NOT NULL  DEFAULT '',
  `BodyTemplate6` varchar(50) NOT NULL  DEFAULT '',
  `BodyTemplate7` varchar(50) NOT NULL  DEFAULT '',
  `BodyTemplate8` varchar(50) NOT NULL  DEFAULT '',
  `BodyTemplate9` varchar(50) NOT NULL  DEFAULT '',
  `MainPage` bit DEFAULT 0,
  `PermisionsR` varchar(200) DEFAULT 'all',
  `PermisionsW` varchar(200) DEFAULT '',
  `PermisionsE` varchar(200) DEFAULT 'admin',
  `CSS` varchar(50) DEFAULT 'default.css',
  `MenuBarCSS` varchar(50) DEFAULT 'default.css',
  `Title` varchar(200) DEFAULT '',
  `Description` text,
  PRIMARY KEY (`SiteID`,`PageID`),
  UNIQUE KEY `Name_UNIQUE` (`Name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `ws_properties` (
  `SiteID` int(11) NOT NULL DEFAULT 1,
  `Grp` varchar(20) NOT NULL DEFAULT '',
  `Name` varchar(20) NOT NULL DEFAULT '',
  `Text` text,
  `Num` int(11) DEFAULT 0,
  PRIMARY KEY (`SiteID`,`Grp`,`Name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `ws_slots` (
  `SiteID` int(11) NOT NULL DEFAULT 1,
  `PageID` int(11) NOT NULL DEFAULT 0,
  `SlotID` varchar(50) NOT NULL DEFAULT '',
  `BodyID` varchar(50) NOT NULL DEFAULT '',
  `PgUID` int(11) NOT NULL DEFAULT 0,
  `MasterPgUID` int(11) NOT NULL DEFAULT 0,
  `Lang` varchar(3) NOT NULL DEFAULT '',
  `ContType` varchar(3) NOT NULL DEFAULT '',
  `Text` text,
  `Param0` text ,
  `Param1` text ,
  `Param2` text ,
  `Param3` text ,
  `Param4` text ,
  `Param5` text ,
  `Param6` text ,
  `Param7` text ,
  `Param8` text ,
  `Param9` text ,
  `Param10` text ,
  `Param11` text ,
  `Param12` text ,
  `Param13` text ,
  `Param14` text ,
  `Param15` text ,
  `Param16` text ,
  `Param17` text ,
  `Param18` text ,
  `Param19` text ,
  `Link` text,
  PRIMARY KEY (`SiteID`,`PageID`,`SlotID`,`PgUID`,`Lang`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `ws_users` (
  `SiteID` int(11) NOT NULL DEFAULT 1,
  `UserID` int(11) NOT NULL DEFAULT 0,
  `UserName` varchar(25) DEFAULT '',
  `Password` varchar(45) DEFAULT '',
  `Permisions` varchar(100) DEFAULT '',
  `Photo` varchar(50) DEFAULT '',
  `FirstName` varchar(50) DEFAULT '',
  `LastName` varchar(50) DEFAULT '',
  `Organization` varchar(50) DEFAULT '',
  `Address` varchar(80)  DEFAULT '',
  `City` varchar(50)  DEFAULT '',
  `Region` varchar(50)  DEFAULT '',
  `State` varchar(50) DEFAULT '',
  `LocationLat` DECIMAL DEFAULT 0,
  `LocationLon` DECIMAL DEFAULT 0,
  `Zip` varchar(15) DEFAULT '',
  `Phone` varchar(50) DEFAULT '',
  `FiscalCode` varchar(50) DEFAULT '',
  `Email` varchar(80) DEFAULT '',
  `Notes` text,
  `RegistrationDT` timestamp NULL DEFAULT NOW(),
  `LastAccess` timestamp NULL,
  `Disabled` bit NULL DEFAULT 0,
  `Gender` varchar(1) DEFAULT '',
  `LookFor` varchar(1) DEFAULT '',
   PRIMARY KEY (`UserID`,`SiteID`),
  UNIQUE KEY `UserName_UNIQUE` (`UserName`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `ws_logs` (
		`UserID`	int(11) NOT NULL,
		`DT`		timestamp NOT NULL DEFAULT now(),
		`Grp`		varchar(8) DEFAULT '',
		`NumKey`	int DEFAULT 0,
		`Note`		varchar(32),
  PRIMARY KEY (`UserID`,`DT`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE IF NOT EXISTS `ws_pay` (
  `SiteID` int(11) NOT NULL DEFAULT '1',
  `DT` datetime NOT NULL,
  `TransactionID` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `PayAccount` varchar(100) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `UserID` int(11) NOT NULL DEFAULT '0',
  `Tag` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `Quantity` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Import` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Shipping` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Currency` varchar(3) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `ItemName` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Description` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Success` int(11) NOT NULL DEFAULT '0',
  `Ret_verify_sign` varchar(100) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_txn_type` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_txn_id` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_shipping` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Ret_residence_country` varchar(100) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_quantity` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Ret_protection_eligibility` varchar(50) CHARACTER SET utf8 NOT NULL,
  `Ret_pending_reason` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payment_type` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payment_status` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payment_gross` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Ret_payment_date` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payer_status` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payer_id` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payer_email` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_notify_version` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_mc_gross` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Ret_mc_currency` varchar(3) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_last_name` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_first_name` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_custom` varchar(20) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_business` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_zip` varchar(20) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_street` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_state` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_name` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_country_code` varchar(3) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_city` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  PRIMARY KEY (`SiteID`,`DT`,`TransactionID`),
  KEY `DT` (`DT`),
  KEY `UserID` (`UserID`),
  KEY `Tag` (`Tag`),
  KEY `PayerEmail` (`Ret_payer_email`),
  KEY `PayerName` (`Ret_last_name`,`Ret_first_name`),
  KEY `PayAccount` (`PayAccount`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `ws_search_keys` (
        `SiteID` int(11) NOT NULL DEFAULT '0',
        `DataKey` int(11) NOT NULL DEFAULT '0',
        `DataType` varchar(2) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'WS',
        `DataLang` varchar(2) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
        `ID_Dictionary` int(11) NOT NULL DEFAULT '0',
          PRIMARY KEY (`SiteID`,`DataType`,`DataLang`,`DataKey`,`ID_Dictionary`),
          KEY `ID_Dictionary` (`ID_Dictionary`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
        
CREATE TABLE IF NOT EXISTS `ws_search_dictionary` (
        `ID_Dictionary` int(11) NOT NULL DEFAULT '0',
        `KeyWord` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
        `SearchCount` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID_Dictionary`),
  KEY `KeyWord` (`KeyWord`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `ws_users`(`SiteID`,`UserID`,`UserName`,`Password`,`Permisions`,`FirstName`,`LastName`,`Email`,`Notes`) VALUES (@SiteIdNumber@,1,'@WSUser@','@WSPassword@','admin','','Admin','@EMail@','');    
INSERT INTO `ws_pages` (`SiteID`,`PageID`,`Path`,`Name`,`MasterTemplate`,`BodyTemplate0`,`BodyTemplate1`,`BodyTemplate2`,`BodyTemplate3`,`BodyTemplate4`,`BodyTemplate5`,`BodyTemplate6`,`BodyTemplate7`,`BodyTemplate8`,`BodyTemplate9`,`MainPage`,`PermisionsR`,`PermisionsW`,`PermisionsE`,`CSS`,`MenuBarCSS`,`Title`,`Description`) VALUES (@SiteIdNumber@,1,'Pages/Home.php','Home','Default.Master','Default.Template','','','','','','','','','',1,'all','','admin','default.css','default.css','Home','Home page');    
INSERT INTO `ws_slots` (`SiteID`,`PageID`,`SlotID`,`BodyID`,`Lang`,`ContType`,`Text`,`Param0`,`Param1`,`Param2`,`Param3`,`Param4`,`Param5`,`Param6`,`Param7`,`Param8`,`Param9`,`Link`) VALUES (@SiteIdNumber@,0,'Subtitle',0,'en','TXT','CMS','','','','','','','','','','','');
INSERT INTO `ws_slots` (`SiteID`,`PageID`,`SlotID`,`BodyID`,`Lang`,`ContType`,`Text`,`Param0`,`Param1`,`Param2`,`Param3`,`Param4`,`Param5`,`Param6`,`Param7`,`Param8`,`Param9`,`Link`) VALUES (@SiteIdNumber@,0,'Title',0,'en','TXT','Web Speedy','','','','','','','','','','','');
INSERT INTO `ws_slots` (`SiteID`,`PageID`,`SlotID`,`BodyID`,`Lang`,`ContType`,`Text`,`Param0`,`Param1`,`Param2`,`Param3`,`Param4`,`Param5`,`Param6`,`Param7`,`Param8`,`Param9`,`Link`) VALUES (@SiteIdNumber@,0,'TitleImgLeft',0,'en','IMG','','SpeedyRound.jpg','','','','','','','','','','');
INSERT INTO `ws_menus` (`SiteID`,`MenuID`,`Pos`,`SubPos`,`Lang`,`DropDown`,`Text`,`Tooltip`,`Link`,`Permisions`) VALUES (@SiteIdNumber@,'TopMenu',1,0,'en',0,'Home','Home Page','Home.php','all');
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('Version','Version','3.003',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('MetaTag','Tag','Web Speedy',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('MetaDesc','Tag','Web Speedy',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('PayPal','AccountEmail','@EMail@',0);	
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('MailSender','MailAdmin','@EMail@',0);	
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('MailSender','SmtpHost','@SmtpHost@',0);	
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('MailSender','SmtpFrom','@EMail@',0);	
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('MailSender','SmtpSecure','@SmtpSecure@',0);		
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('MailSender','SmtpPort','@SmtpPort@',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('MailSender','SmtpUser','@SmtpUser@',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('MailSender','SmtpPassword','@SmtpPassword@',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('FavIcon','Icon','../SysPages/WS_Icon.png',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('EmailTamplate','UserRegistationNotifyToAdmin','@Template1@',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('EmailTamplate','UserRegistationNotifyToUser','@Template2@',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('EmailTamplate','UserUpdateNotifyToAdmin','@Template3@',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('EmailTamplate','UserUpdateNotifyToUser','@Template4@',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('EmailTamplate','UserPwdChangeToUser','@Template5@',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('EmailTamplate','UserPwdChangeToAdmin','@Template6@',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('Registration','Enable','true',0);
INSERT INTO `ws_properties` (`Grp`,`Name`,`Text`,`Num`) VALUES ('Privacy','CookiesMessage','true',0);



