<?php
class TableListViewer
{
	public $Search="";
	public $Columns=array();

	public $ColsVisibility=array();
	public $ColsWordWrap=array();
	public $ColsWidth=array();
	public $CellMask = array();
	public $ColsCaption = array();
	
	public $FieldPKeys=array();
	public $FieldsInfos = array();
	public $Buttons = array();
	public $Message="";
	public $CssClassTable="";
	public $CssClassHeader="";
	public $CssClassBaseRow="";
	public $CssClassAlternateBaseRow="";
	public $CssClassRow="";
	public $CssClassAlternateRow="";
	public $CssClassButton="";
	public $CssClassPager="";
	public $CssClassPagerButtons="";
	public $Border="1";
	public $PagerSessionProgr=0;
	public $SelectedButton=null;
	public $SelectedArgs=null;
	public $ShowCaption=true;
	public $RowCount=0;
	
	private static $TableListViewerCount=0;
	private $TLVCount;
	private $DB;
	private $Sql="";
	private $IsEmpty;
	private $result;
	private $Pager;
	public $RowsForPage=10;
	private $Type_Str = array(252,253, 254);
	private $Type_Num = array(1,2,3,4,5,8,9,16,246);
	private $Type_DateTime = array(12);
	private $Type_Date = array(10);
	
	public function __construct($DB,$Sql,$Buttons=null,$RowsForPage=10)
	{
		// GET COULUMS
		$this->TLVCount = self::$TableListViewerCount++;
		$this->DB = $DB;
		$this->Sql = $Sql;
		$this->Buttons = $Buttons;
		$this->RowsForPage = $RowsForPage;
		$this->Pager = new TableListViewerPager();
		$this->Query();
		for($N=0;$N<count($this->FieldsInfos);$N++)
		{
			$Info = $this->FieldsInfos[$N];
			$this->Columns[$N] = new TableListViewerColumn();
			$this->Columns[$N]->Type = "Field";
			$this->Columns[$N]->Info = $Info;
			$this->Columns[$N]->Name = $Info->orgname;
			$this->Columns[$N]->Caption = $Info->orgname;
			$this->Columns[$N]->Button = null;
		}
		if ($Buttons!=null)
		{
			$N=count($this->FieldsInfos);
			for($B=0;$B<count($Buttons);$B++)
			{
				$this->Columns[$N+$B] = new TableListViewerColumn();
				$this->Columns[$N+$B]->Type = "Button";
				$this->Columns[$N+$B]->Info = null;
				$this->Columns[$N+$B]->Button = $Buttons[$B];
				//$this->Columns[$N+$B]->Name = $Buttons[$B]->Name;
				$this->Columns[$N+$B]->Caption = "";
			}
		}
		$this->ManagePostBack();
	}
	
	private function ManagePostBack()
	{
		if ((count($_POST)> 0) && (isset($this->Buttons)))
		{
			for ($R=0;$R<$this->RowsForPage;$R++)
			{
				foreach ($this->Buttons as $B)
				{
					if (isset($_POST["TLV".$this->TLVCount."_Btn_".$B->Name."_".$R]))
					{
						$this->SelectedButton = $B;
						$PKVals = array();
						foreach ($this->FieldsInfos as $FLD) 
						{
							if (isset($_POST["TLV".$this->TLVCount."_FLD_".$FLD->name."_".$R]))
								$PKVals[$FLD->name] = $_POST["TLV".$this->TLVCount."_FLD_".$FLD->name."_".$R];
						}
						$this->SelectedArgs = $PKVals;
					}
				}
			}
		}
	}
	
	private function Query()
	{
		$this->result = $this->Pager->Open("TLV".$this->TLVCount."_PAGER_".$this->PagerSessionProgr,$this->DB,$this->Sql, $this->RowsForPage);
		if ($this->result === false)
		{
			echo("SQL ERROR: Query error<br/>".$this->Sql."<br/>".$this->DB->error);
		}
		else
		{
			// GET INFO
			$this->RowCount = $this->result->num_rows;
			$K=0;
			$this->FieldsInfos = array();
			for ($N=0;$N<$this->result->field_count;$N++) 
			{
				$Info = $this->result->fetch_field_direct($N);
				if (($Info->charsetnr == 33)&&(in_array($Info->type,$this->Type_Str))) 
					{$Info->length /= 3;}
				if (($Info->flags & 2) == 2)
				{
					array_push($this->FieldPKeys,$Info->orgname);
					$K++;
				}
				if ($Info->orgname!="")
					{array_push($this->FieldsInfos,$Info);}
				else
					{array_push($this->FieldsInfos,$Info);}
			}
		}
	}
	
	public function Draw()
	{
		for($N=0;$N<count($this->Columns);$N++)
		{
				if ((isset($this->ColsVisibility[$N]))&&($this->ColsVisibility[$N] != ""))
					{$this->Columns[$N]->Visibility = settype($this->ColsVisibility[$N], 'boolean');}

				if ((isset($this->ColsWordWrap[$N]))&&($this->ColsWordWrap[$N] != ""))
					{$this->Columns[$N]->WordWrap=settype($this->ColsWordWrap[$N], 'boolean');}
			
				if ((isset($this->ColsWidth[$N]))&&($this->ColsWidth[$N] != ""))
					{$this->Columns[$N]->Width=$this->ColsWidth[$N];}
			
				if ((isset($this->ColsCellMask[$N]))&&($this->ColsCellMask[$N] != ""))
					{$this->Columns[$N]->CellMask=$this->ColsCellMask[$N];}
			
				if ((isset($this->ColsCaption[$N]))&&($this->ColsCaption[$N] != ""))
					{$this->Columns[$N]->Caption=$this->ColsCaption[$N];}
		}
		
		
		$Class="";
		if($this->CssClassTable != "") {$Class="class=\"".$this->CssClassTable."\"";}
		echo "<table ".$Class." cellspacing=\"".$this->Border."\" border=\"".$this->Border."\">";
		
		$C=0;
		$Class="";
		
		// HEADER
		if ($this->ShowCaption)
		{
			$ClassTr="";
			if($this->CssClassBaseRow != "") {$ClassTr="class=\"".$this->CssClassBaseRow."\"";}
			echo "<tr ".$ClassTr.">";
			
			if($this->CssClassHeader != "") {$Class="class=\"".$this->CssClassHeader."\"";}
			
			// HEADER FIELDS
			foreach ($this->Columns as $Col)
			{
				$Style="";
				if ((!isset($Col->Visibility)) || ($Col->Visibility))
				{
					$Caption="";
					
					if (isset($Col->Width))
					{
						if ($Col->Width!="")
							{$Style.="width:".$Col->Width;}
					}

					if ($Col->Type == "Button")
						{$Style.="min-width:25px;";}
					
					if ($Col->Type == "Field")
						{$Caption = $Col->Info->name;}
					
					if (isset($Col->Caption))
						{$Caption = $Col->Caption;}
					
					if (isset($Col->WordWrap))
					{
						if (!$Col->WordWrap)
						$Style .= "white-space:nowrap;";
					}
					
					echo "<th ".$Class." style=\"".$Style."\">".$Caption."</th>";
				}
			}
		
			echo "</tr>";
		}
				
		$PKTxt="";
		if ($this->CssClassAlternateRow=="") {$this->CssClassAlternateRow=$this->CssClassRow ;}
		if ($this->CssClassAlternateBaseRow=="") {$this->CssClassAlternateBaseRow=$this->CssClassBaseRow ;}
		$ClassBtn="";
		if($this->CssClassButton != "") {$ClassBtn="class=\"".$this->CssClassButton."\"";}
		
		$Class="";
		$AR=false;
		if ($this->result !== false)
		{
			// ROWS SCAN
			for ($R=0;$R<$this->result->num_rows;$R++)
			{
				$ClassTr = "";
				$Class="";
				if ($AR)
				{
					if($this->CssClassAlternateRow != "") {$Class="class=\"".$this->CssClassAlternateRow."\"";}
					if($this->CssClassAlternateBaseRow != "") {$ClassTr="class=\"".$this->CssClassAlternateBaseRow."\"";}
					$AR=false;
				}
				else
				{
					if($this->CssClassRow != "") {$Class="class=\"".$this->CssClassRow."\"";}
					if($this->CssClassBaseRow != "") {$ClassTr="class=\"".$this->CssClassBaseRow."\"";}
					$AR=true;
				}

				$row = $this->result->fetch_assoc();
				echo "<tr ".$ClassTr.">";

				// COLS SCAN
				$C=0;
				foreach ($this->Columns as $Col)
				{
					$Style="";
					$Info = $Col->Info;
					
					// FIELD
					if ($Col->Type=="Field")
					{
						if (isset($Col->Width))
						{
							if ($Col->Width!=""){$Style.="width:".$Col->Width.";";}
						}

						if (isset($Col->WordWrap))
						{
							if (strtolower($Col->WordWrap) == false)
							$Style .= "white-space:nowrap;";
						}
					
						// DATA
						if ((!isset($Col->Visibility)) || ($Col->Visibility))
						{
							if ($Col->Editable)
							{
								$Editor = ""; //"<input style=\"".$Style."\" type=\"text\" name=\"TLV".$this->TLVCount."_FLD_".$Info->name."_".$R."\" value=\"".$row[$Info->name]."\"/>";
							}
							else
							{
								$Hidden = "<input type=\"hidden\" name=\"TLV".$this->TLVCount."_FLD_".$Info->name."_".$R."\" value=\"".$row[$Info->name]."\"/>";
							}
							$Dat= $row[$Info->name];
							if (!isset($Dat)) {$Dat="";}
							if ((isset($Col->CellMask) && $Col->CellMask != ""))
							{
								$Dat=$Col->CellMask;
								foreach ($this->Colunms as $C)
								{
									$I = $C->Info;
									{$Dat=str_replace ("@".$I->name, $row[$I->name], $Dat);}
									{$Dat=  str_replace ("@row", $R, $Dat);}
								}
							}
							if (isset($Col->LookupQry))
							{
								echo "<select name=\"TLV".$this->TLVCount."_FLD_".$Info->name."_".$R."\">";
								$Result= $DB->query($Col->LookupQry);
								for ($RL=0;$RL<$Result->num_rows;$RL++)
								{
									$RowLook = $Result->fetch_assoc();
									if (count($RowLook)>1)
									{
										echo "<option value=\"".$RowLook[1]."\">".$RowLook[0]."</option>";
									}
									else
									{
										echo "<option value=\"".$RowLook[0]."\">".$RowLook[0]."</option>";
									}
								}
								echo "</select>";
							}
							else
							{
								if ($Col->Editable)
								{
									echo "<td ".$Class." style=\"".$Style."\">".$Editor."</td>";
								}
								else
								{
									echo "<td ".$Class." style=\"".$Style."\">".$Hidden.$Dat."</td>";
									
								}
							}
						}
						$PKTxt .= "<input type=\"hidden\" name=\"TLV".$this->TLVCount."_FLD_".$Info->name."_".$R."\" value=\"".$row[$Info->name]."\"/>";
						$C++;
					}

					// BUTTON
					if($Col->Type=="Button")
					{
						$Style="";
						$B=$Col->Button;
						if (isset($Col->Width))
						{
							$Style.="min-width:25px;";
							if ($Col->Width!=""){$Style.="width:".$Col->Width;}
						}

						$Script = "";
						if (($B->OnClick!= "") || ($B->ConfirmMessage != ""))
						{
							$Script = "onclick=\"";
							if ($B->ConfirmMessage != "")
								{$Script .= "return confirm('".$B->ConfirmMessage."');";}
							if ($B->OnClick!= "")
								{$Script .= $B->OnClick;}
							$Script .= "\"";

							// REPLACE PARAM
							foreach ($this->Columns as $C)
							{
								if ($C->Type == "Field")
								{ 
									$I = $C->Info;
									$Script = str_replace("@".$I->name,$row[$I->name],$Script);
								}
							}
						}
						if ((!isset($Col->Visibility) || ($Col->Visibility)))
						{
							echo "<td ".$Class." style=\"".$Style."\"><input ".$ClassBtn." style=\"width:100%\" type=\"".$B->ButtonType."\" name=\"TLV".$this->TLVCount."_Btn_".$B->Name."_".$R."\" value=\"".$B->Text."\" ".$Script."></td>";
						}
					}
				}
				echo "</tr>";
			}
		}

		if ($this->Pager->IsVisible($this->RowsForPage))
		{
			echo "<tr><td>";
			echo  "<table style=\"margin: auto\"><tr><td>";
		
			$this->Pager->Draw($this->RowsForPage,$this->CssClassPager,$this->CssClassPagerButtons);
			
			echo  "</td></tr></table>";
			echo "</td></tr>";
		}
		echo "</table>";
		echo $PKTxt;
	}
	
	public function DrawFlex()
	{
		for($N=0;$N<count($this->Columns);$N++)
		{
			if ($this->ColsVisibility[$N] != "")
				{$this->Columns[$N]->Visibility=settype(strtolower($ColsVisibility[$N]), 'boolean');}
				
			if ($this->ColsWordWrap[$N] != "")
				{$this->Columns[$N]->WordWrap=settype(strtolower($ColsWordWrap[$N]), 'boolean');}
				
			if ($this->ColsWidth[$N] != "")
				{$this->Columns[$N]->Width=$ColsWidth[$N];}
			
			if ($this->ColsCellMask[$N] != "")
				{$this->Columns[$N]->CellMask=$ColsCellMask[$N];}
			
			if ($this->ColsCaption[$N] != "")
				{$this->Columns[$N]->Caption=$ColsCaption[$N];}
		}
		
		$Class="";
		if($this->CssClassTable != "") {$Class="class=\"".$this->CssClassTable."\"";}
		echo "<div style=\"width:95%;flex-wrap:wrap;display:flex;justify-content:center;align-items:streth\" ".$Class." cellspacing=\"".$this->Border."\" border=\"".$this->Border."\">";
		
		$PKTxt="";
		if ($this->CssClassAlternateRow=="") {$this->CssClassAlternateRow=$this->CssClassRow ;}
		if ($this->CssClassAlternateBaseRow=="") {$this->CssClassAlternateBaseRow=$this->CssClassBaseRow ;}
		
		$ClassBtn="";
		if($this->CssClassButton != "") {$ClassBtn="class=\"".$this->CssClassButton."\"";}
		
		$Class="";
		$AR=false;
		if ($this->result !== false)
		{
			// ROWS SCAN
			for ($R=0;$R<$this->result->num_rows;$R++)
			{
				$ClassTr = "";
				$Class="";
				if ($AR)
				{
					if($this->CssClassAlternateRow != "") {$Class="class=\"".$this->CssClassAlternateRow."\"";}
					if($this->CssClassAlternateBaseRow != "") {$ClassTr="class=\"".$this->CssClassAlternateBaseRow."\"";}
					$AR=false;
				}
				else
				{
					if($this->CssClassRow != "") {$Class="class=\"".$this->CssClassRow."\"";}
					if($this->CssClassBaseRow != "") {$ClassTr="class=\"".$this->CssClassBaseRow."\"";}
					$AR=true;
				}

				$row = $this->result->fetch_assoc();
				echo "<div style=\"margin-bottom:50px;display:block;\" ".$ClassTr.">";

				foreach ($this->Columns as $Col)
				{
					// FIELD
					if ($Col->Type == "Field")
					{
						$Info=$Col->Info;
						$Style="";
						if (isset($Col->Width))
						{
							$Style="";
							if ($Col->Width!=""){$Style="width:".$Col->Width;}
						}

						// DATA
						if ($Col->Visibility)
						{
							$Hidden = "<input type=\"hidden\" name=\"TLV".$this->TLVCount."_FLD_".$Info->name."_".$R."\" value=\"".$row[$Info->name]."\">";
							$Dat= $row[$Info->name];
							if (!isset($Dat)) {$Dat="";}
							if ((isset($Col->CellMask) && $Col->CellMask != ""))
							{
								$Dat=$Col->CellMask;
								foreach ($this->Columns as $c)
								{
									$I = $C->Info;
									{$Dat=  str_replace ("@".$I->name, $row[$I->name], $Dat);}
									{$Dat=  str_replace ("@row", $R, $Dat);}
								}
							}
							echo "<div style=\"\" ".$Class." >".$Hidden.$Dat."</div>";
						}
						$PKTxt .= "<input type=\"hidden\" name=\"TLV".$this->TLVCount."_FLD_".$Info->name."_".$R."\" value=\"".$row[$Info->name]."\">";
					}
					
					// BUTTON
					if ($Col->Type == "Button")
					{
						$B = $Col->Button;
						
						$Style="min-width:25px;";
						if (isset($Col->Width))
						{
							$Style="";
							if ($Col->Width!=""){$Style.="width:".$Col->Width;}
						}

						$Script = "";
						if (($B->OnClick!= "") || ($B->ConfirmMessage != ""))
						{
							$Script = "onclick=\"";
							if ($B->ConfirmMessage != "")
								{$Script .= "return confirm('".$B->ConfirmMessage."');";}
							
							if ($B->OnClick!= "")
								{$Script .= $B->OnClick;}
							$Script .= "\"";

							// REPLACE PARAM
							foreach ($this->Columns as $C)
							$I = $C->Info;
							{
								$Script = str_replace("@".$I->name,$row[$I->name],$Script);
							}
						}
						if ($Col->Visibility)
						{
							echo "<div ".$Class." style=\"width:".strval(strlen($B->Text)*20).";display:inline-block;\"><input ".$ClassBtn." style=\"width:".strval(strlen($B->Text)*20)."px\" type=\"".$B->ButtonType."\" name=\"TLV".$this->TLVCount."_Btn_".$B->Name."_".$R."\" value=\"".$B->Text."\" ".$Script."></div>";
						}
					}
					$C++;
				}
				
				echo "</div>";
			}
		}
		echo "</div>";
		
		echo "<div style=\"display:block;margin:auto;margin-top:30px\">";
		echo  "<table style=\"margin: auto\"><tr><td>";
		$this->Pager->Draw($this->RowsForPage,$this->CssClassPager,$this->CssClassPagerButtons);
        echo  "</td></tr></table>";
		echo "<div>";
		echo $PKTxt;
	}
	
	public function Requery()
	{
		$this->Query();
	}
}

class TableListViewerPager
{
    private $ID;
	private $TableListViewer;
	
	public function __construct()
	{
	}
	
    public function Open($ID,$DB,$Sql,$Step)
    {
        $this->ID = "_".$ID."_".basename($_SERVER['PHP_SELF']);
        if (!isset($_SESSION[$this->ID."PagerNREC"])) $_SESSION[$this->ID."PagerNREC"] = 0;
        if (!isset($_SESSION[$this->ID."PagerPOS"])) $_SESSION[$this->ID."PagerPOS"] = 0;
        
        if(isset($_POST['PagerFirst']))
        {
            $_SESSION[$this->ID."PagerPOS"] = 0;
        }
        
        if(isset($_POST['PagerPrev']))
        {
            if ($_SESSION[$this->ID."PagerPOS"]-$Step >= 0) $_SESSION[$this->ID."PagerPOS"]-=$Step;
        }
        
        if(isset($_POST['PagerNext']))
        {
            $Pos = $_SESSION[$this->ID."PagerPOS"];
            $NRec=$_SESSION[$this->ID."PagerNREC"];
            if ($Pos+$Step <= $NRec-1) $_SESSION[$this->ID."PagerPOS"]+=$Step;
        }

        if(isset($_POST['PagerLast']))
        {
            $NRec=$_SESSION[$this->ID."PagerNREC"];
            $Pos = (intval(($NRec-1)/$Step)*$Step);
            if ($Pos <= $NRec-1) $_SESSION[$this->ID."PagerPOS"] = $Pos;
        }
        
        $Result=$DB->query($Sql);
		if ($Result !== false)
		{
			$_SESSION[$this->ID."PagerNREC"] = $Result->num_rows;
			$Pos = $_SESSION[$this->ID."PagerPOS"];
			if ($Pos>$Result->num_rows)
			{
				$Pos = 0;
				$_SESSION[$this->ID."PagerPOS"] = 0;
			}
			$Sql = $Sql." LIMIT ".$Pos.",".$Step;
			$Result= $DB->query($Sql);
		}
		else
		{
			echo $DB->error;
		}
        return $Result;
    }
    
    public function GetPosition()
    {
       return $_SESSION[$this->ID."PagerPOS"];
    }
    
	public function IsVisible($RowsForPage)
	{
		return (ceil($_SESSION[$this->ID."PagerNREC"] / $RowsForPage) > 1);
	}
	
    public function Draw($RowsForPage,$ClassPagerCSS="",$CssClassPagerButtons="")
    {
		if (ceil($_SESSION[$this->ID."PagerNREC"] / $RowsForPage) > 1)
		{
			echo "<div class=\"".$ClassPagerCSS."\">";
			echo "<input class=\"".$CssClassPagerButtons."\" name=\"PagerFirst\" type=\"submit\" value=\"|<\">";
			echo "<input class=\"".$CssClassPagerButtons."\" name=\"PagerPrev\" type=\"submit\" value=\"<<\">&nbsp;";
			if ($_SESSION[$this->ID."PagerNREC"]>0)
			{
				//echo ($_SESSION[$this->ID."PagerPOS"]+1)." / ".$_SESSION[$this->ID."PagerNREC"];
				echo (floor($_SESSION[$this->ID."PagerPOS"] / $RowsForPage)+1)." / ". (ceil($_SESSION[$this->ID."PagerNREC"] / $RowsForPage));
			}
			echo "&nbsp;<input class=\"".$CssClassPagerButtons."\" name=\"PagerNext\" type=\"submit\" value=\">>\">";
			echo "<input class=\"".$CssClassPagerButtons."\" name=\"PagerLast\" type=\"submit\" value=\">|\">";
			echo "</div>";
		}
    }
    
    public function Clear()
    {
        $_SESSION[$this->ID."PagerPOS"] = null;
        $_SESSION[$this->ID."PagerNREC"] = null;
    }
}

class TableListViewerButton
{
	public $Name="";
	public $Text="";
	public $Tooltip="";
	public $ConfirmMessage="";
	public $OnClick="";
	public $ButtonType="submit";
	
	public function __construct($Name,$Text,$Tooltip="",$ConfirmMessage="",$OnClick="",$ButtonType="submit")
	{
		$this->Name = $Name;						// BUTTON NAME
		$this->Text = $Text;						// BUTTON TEXT
		$this->Tooltip = $Tooltip;					// BUTTON TOOLTIP
		$this->ConfirmMessage = $ConfirmMessage;	// CONFIRMATION MESSAGE
		$this->OnClick = $OnClick;					// ON CLICK JAVA SCRIPT
		$this->ButtonType = $ButtonType;			// SET THE BUTTON TYPE submit/button
	}
}

class TableListViewerColumn
{
	public $Type ="";
	public $Name ="";
	public $Width = "";
	public $WordWrap = false;
	public $CellMask = "";
	public $Visibility  = true;
	public $Editable  = false;
	public $Caption = null;
	public $Info = null;
	public $Button = null;
	public $LookupQry = null;
}
?>