 <?php
class WS_Base
{
	private $Ver;
	private $CCEncode;
	private $ActPopup;
	
	private $PopupCode = "";
	private $PopupWidth = "";
	private $PopupHeight = "";
	private $PopupTitle = "";
	private $PopupHeaderClass = "";
	private $PopupBodyClass = "";
	private $PopupTop = "30px";
	
	private $MapLatitude = 0;
	private $MapLongitude = 0;
	private $CurrentBodyID=null;
	private $MaxBody=10;
	
	public $ScriptList = array();
	public $CssList= array();
	
	public $Timer = 250;
	public $MenuScript = false;
	public $TextAreaScript = false;
	public $PayScript = "";
	public $TextExpandibleScript = false;
	
	public static $WSBase;
	public $HomeSite;
	public $Host;
	public $Root;
	public $WS_Page;
	public $WSDB;
	public $Translator;
	public $Lang;
	public $Langs;
	public $ActLangs;
	public $BaseLang = "en";
	public $IsMobile = false;
	public $IsInFrame = false;
	

	public function __construct()
	{
		WS::$WSBase = $this;
		WS::$WSBase->Init();
	}

	//---------------------------------------------------
	// ---------------- TEMPPLATE FUNCTION --------------
	//---------------------------------------------------

	public function Slot_PagerSearch($Width)
	{
		$SlotKey = $this->GetSlotKey($SlotID);

		$S = "";
		if (isset($_SESSION["WS_PagSearch"]))
		{
			$S = $_SESSION["WS_PagSearch"];
		}
		echo "<input type=\"text\" style=\"width:" . $Width . "\" name=\"TxtPagSearch" . $SlotKey . "\" value=\"" . $S . "\">";
		echo "<input class=\"ws_button\" type=\"submit\" name=\"BtnPagSearch" . $SlotKey . "\" value=\"Search\">";
		if ($_SESSION["WS_PagSearch"] != "")
		{
			echo "<input class=\"ws_button\" type=\"submit\" name=\"BtnPagSearchClear" . $SlotKey . "\" value=\"Clear\">";
		}
	}

	// ------------------------
	// TEMPATE SLOT
	// ------------------------
	public function Slot_MasterTemplate()
	{
		$Template = WS::$WSBase->Root . "/Templates/Master/" . $this->WS_Page->MasterTemplate;
		$CSS = "../Templates/Master/" . $this->WS_Page->MasterTemplate . ".css";
		if(!file_exists($Template)) 
		{
			$Template = WS::$WSBase->Root . "/Templates/" . $this->WS_Page->MasterTemplate;
			$CSS = "../Templates/" . $this->WS_Page->MasterTemplate . ".css";
		}
		
		if(file_exists($CSS)) 
		{
			$this->DrawTemplate($Template, $CSS);
		}
		else
		{
			$this->DrawTemplate($Template);
		}
	}

	public function Slot_PreHeaderTemplate()
	{
		$Template = WS::$WSBase->Root . "/SysPages/PreHeader.php";
		$CSS = "../Styles/ws_preheader.css";
		$this->DrawTemplate($Template, $CSS);
	}

	public function Slot_BodyTemplate()
	{
		for ($B=0;$B<$this->MaxBody;$B++)
		{
			$this->CurrentBodyID = $B;
			if ($this->WS_Page->BodyTemplate[$B] != "")
			{
				$Template = WS::$WSBase->Root . "/Templates/Body/" . $this->WS_Page->BodyTemplate[$B];
				if (file_exists($Template))
				{
					$CSS = "../Templates/Body/" . $this->WS_Page->BodyTemplate[$B] . ".css";
					$this->DrawTemplate($Template, $CSS);
				}
				else
				{
					$Template = WS::$WSBase->Root . "/Templates/" . $this->WS_Page->BodyTemplate[$B];
					$CSS = "../Templates/" . $this->WS_Page->BodyTemplate[$B] . ".css";
					$this->DrawTemplate($Template, $CSS);
				}
			}
		}
		$this->CurrentBodyID = null;
	}
	
	public function Slot_FooterTemplate()
	{
		$WS = WS::$WSBase;
		$Template = WS::$WSBase->Root . "/SysPages/Footer.php";
		$CSS = "../Styles/ws_footer.css";

		$this->IncludeCss($CSS);

		if (file_exists($Template))
		{
			include($Template);
		}
		else
		{
			echo "<br/><div style=\"margin:auto;width:600px;color:red\"><b>Can't open template " . $this->WS_Page->Name . "</b></div>";
		}
	}

	public function Slot_PlugFile($PluginFile)
	{
		IncludeFile($PluginFile);
	}
	
	public function Slot_SubTemplate($SlotID, $Width = "", $Height = "", $Template = "")
	{
		global $WS;	
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$SlotKey = $this->GetSlotKey($SlotID);

		$this->ReadInputSlots($this->WS_Page->PageID, $SlotID,  "TEM");

		//GESTIONE CLIPBOARD PASTE
		if (filter_input(INPUT_POST, "BtnPASTE_" . $SlotKey))
		{
			$SourceSlot = json_decode($_SESSION["BLOCK_CLIPBOARD"]);

			if (isset($this->WS_Page->Slots[$SlotKey]))
			{
				$Slot = $this->WS_Page->Slots[$SlotKey];
				$Slot->Row = 1;
				$Slot->UpdRow = 1;
				for ($S = 0; $S < WS_Slot::$NumParams; $S++)
				{
					$Slot->Param[$S] = $SourceSlot->Param[$S];
				}

				$SubSlots = WS_Slot::GetSlots($Slot->PageID, $Slot->Row, null, $Slot->MasterPgUID);

				// DELETE THE SUB SLOTS
				foreach ($SubSlots as $SubSlot)
				{
					$SubSlot->Delete();
				}

				$Slot->Update();
				$this->WS_Page->Slots[$SlotKey] = $Slot;
			}
			else
			{
				$DestSlot = (json_decode($_SESSION["BLOCK_CLIPBOARD"]));
				$Slot = new WS_Slot();
				$Slot->PageID = $this->WS_Page->PageID;
				$Slot->SlotID = $SlotID;
				$Slot->Row = 1;
				$Slot->UpdRow = 1;
				$Slot->MasterPgUID = WS_Slot::GetMaxPgUID($this->WS_Page->PageID) + 1;
				$Slot->Lang = $DestSlot->Lang;
				$Slot->PgUID = $DestSlot->PgUID;
				$Slot->ContType = $DestSlot->ContType;
				$Slot->Text = $DestSlot->Text;
				$Slot->Link = $DestSlot->Link;
				for ($S = 0; $S < WS_Slot::$NumParams; $S++)
				{
					$Slot->Param[$S] = $DestSlot->Param[$S];
				}
				$Slot->Update();
			}

			$SubSlots = WS_Slot::GetSlots($SourceSlot->PageID,$SourceSlot->UpdRow,null,$SourceSlot->BodyID,null,$SourceSlot->MasterPgUID);
			foreach ($SubSlots as $SubSlot)
			{
				$SubSlot->PageID = $this->WS_Page->PageID;
				$SubSlot->BodyID = $Slot->BodyID;
				$SubSlot->Row = 1;
				$SubSlot->PgUID = $Slot->MasterPgUID;
				$SubSlot->Update();
			}

			$this->LoadSlots();
		}

		$Width = "";
		$Height = "";
		$this->PluginParam = "";
		$Template = "";
		$CssClass = "";		
		$MasterPgUID = 0;
		
		$WS->ReadInputSlots($WS->WS_Page->PageID, $SlotID, 0, "TEM");
		
		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			
			$Slot = $this->WS_Page->Slots[$SlotKey];
			if (isset($Slot->Param[0]))
			{
				$Template = $Slot->Param[0];
			}
			if (isset($Slot->Param[1]))
			{
				$Width = $Slot->Param[1];
			}
			if (isset($Slot->Param[2]))
			{
				$Height = $Slot->Param[2];
			}
			if (isset($Slot->Param[4]))
			{
				$CssClass = $Slot->Param[4];
			}
			if (isset($Slot->Param[3]))
			{
				$this->PluginParam = $Slot->Param[3];
			}

			if ($Slot->MasterPgUID == 0)
			{
				$Slot->MasterPgUID = WS_Slot::GetMaxPgUID($this->WS_Page->PageID, $this->CurrentBodyID) + 1;
				$Slot->UpdateMasterPgUID();
			}

			//GESTIONE CLIPBOARD COPY
			if (filter_input(INPUT_POST, "BtnCOPY_" . $SlotKey))
			{
				$_SESSION["BLOCK_CLIPBOARD"] = json_encode($Slot);
			}
		}

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (isset($_POST["Btn" . $SlotKey]))
		{
			$Templates = $this->GetSubTemplatesNames();
			$CurTmpl = str_replace(".Template", "", $Template);

			$ValTemplate= array();
			$SelTemplate = "";
			foreach ($Templates as $Tmpl)
			{
				if (($Template != "") && ($CurTmpl == "Sub/" . $Tmpl))
				{
					$SelTemplate = $Template;
				}
				array_push($ValTemplate, $Tmpl."=Sub/".$Tmpl.".Template" );  
			}
			
			$Params = array();
			array_push($Params, new WS_ParamDef("Param0", "Template:", 40, 1, "DDL", $ValTemplate, $SelTemplate));
			array_push($Params, new WS_ParamDef("Param1", "Width:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param2", "Height:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param3", "Params:", 90, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param4", "Css Class:", 90, 1, "CLS", null));
			array_push($Params, new WS_ParamDef("Update", "Update", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null));
			$this->DrawConfigSlots($this->WS_Page->PageID, $SlotID,  $Params);
		}

		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"min-height:35px;border:1px dashed silver;background-color:rgba(150, 150, 150, 0.3)\">";
			echo $this->DrawEditButton($SlotKey, "", "Insert a Sub Template", "ws_btnedit-sub", "");
			echo "&nbsp;" . $this->DrawEditButton("COPY_" . $SlotKey, "", "Copy block", "ws_btncopy-sub", "");
			echo "&nbsp;" . $this->DrawEditButton("PASTE_" . $SlotKey, "", "Paste block", "ws_btnpaste-sub",  "", "return confirm('Replace this block');");
			echo $SlotID;
		}

		$SWidth = "";
		$SHeight = "";
		if ($Width != ""){$SWidth = " width:" . $Width . ";";}
		if ($Height != ""){$SHeight = " height:" . $Height . ";";}
		
		if ($CssClass != "") 
			{$CssClass = " class=\"".$CssClass."\" ";}

		$Overflow = "";
		if ($SWidth != ""){$Overflow .= "overflow-x:auto;padding-bottom:4px;";}
		if ($SHeight != ""){$Overflow .= "overflow-y:auto;padding-right:4px;";}

		if (isset($this->WS_Page->Slots[$SlotKey]))
			{$this->WS_Page->PgUID = $Slot->MasterPgUID;}
		else
			{$this->WS_Page->PgUID = 0;}

		$WS = $this;
		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			$Style = $SWidth . $SHeight . $Overflow;
			if ($Style != "") {$Style= " style=\"".$Style."\ ";}
			echo "<div ".$Style.$CssClass.">";
			
			$CSS = "../Templates/" . $Template . ".css";
			if (file_exists($CSS)){$this->IncludeCss($CSS);}
			
			include WS::$WSBase->Root . "/Templates/" . $Template;
			echo "</div>";
		}
		else
		{
			if ($Template != "")
			{
				if (($SWidth != "") || ($SHeight != "") || ($Overflow != "")) {echo "<div style=\"" . $SWidth . $SHeight . $Overflow . "\">";}
				$CSS = str_replace(".Template", ".Template.css", $Template);
				$this->DrawTemplate($Template, $CSS);
				if (($SWidth != "") || ($SHeight != "") || ($Overflow != "")) {echo "</div>";}
			}
		}
		$this->PluginParam = "";

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}

		$this->WS_Page->PgUID = 0;
	}

	//-----------------------------------------
	//------------ PUBLIC FUNCTION ----------
	//-----------------------------------------

	public function DrawPageHeader()
	{
		try
		{
			echo "<meta charset=\"utf8\">";
			echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\" />\n";
			echo "<meta name=\"keywords\" content=\"" . $this->GetMetaTag() . "\">\n";
			
						if ($this->IsMobile)
			{
				echo "<meta name=\"viewport\" content=\"width=device-width/2, target-densitydpi=device-dpi/1.3, initial-scale=0.50, shrink-to-fit=no\"/>\n";
			}
			else
			{
				echo "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, shrink-to-fit=no\"/>\n";
			}	
			
			// SET CSS
			$this->SetPageCss();

			// SET PAGE ICON
			if (isset($this->WS_Page))
			{
				$Icon = $this->WS_Page->GetIcon();
				if (!empty($Icon))
				{
					echo "<link rel=\"icon\" type=\"image\" href=\"" . $Icon . "\"/>";
					echo "<link rel=\"shortcut icon\" type=\"image\" href=\"" . $Icon . "\"/>";
				}

				// SET PAGE TITLE
				echo "<title>" . str_replace(".php", "", $this->WS_Page->GetPageTitle()) . "</title>";
			}
		}
		catch (Exception $Ex)
		{
			echo $Ex->getMessage();
		}
	}

	public function BeforeMasterTemplate()
	{
		try
		{
			$this->DrawGoogleSpidersLinks();  // MAKE PAGES HIDDEN LINK FOR GOOGLE SPIDERS
			$this->DrawLeftScrollMenuBar();   // WS TOOLS MENU
			$this->Slot_BackgroundSetButton("WS_BodyBgColor"); // BACKGROUND COLOR BUTTON
		}
		catch (Exception $Ex)
		{
			echo $Ex->getMessage();
		}
	}

	public function AfterMasterTemplate()
	{
		try
		{
			$this->DrawPopup();
			$this->WSDB->Disconnect();

			if ($this->PayScript != "")
			{
				echo $this->PayScript;
				$this->PayScript = "";
			}
		}
		catch (Exception $Ex)
		{
			echo $Ex->getMessage();
		}
	}

	public function DrawPreHeaderButtons()
	{
		if (!IsLoggedin())
		{
			echo "<td style=\"width:1%;white-space:nowrap\"><a class=\"ws_pre_header_block_link\" href=\"../SysPages/SysBase.php?P=Login\">";
			$this->Translate("Login");
			echo "</a></td>";
		}
		else
		{
			echo "<td style=\"width:1%;white-space:nowrap\"><a class=\"ws_pre_header_block_link\" href=\"../SysPages/SysBase.php?P=Logout\">";
			$this->Translate("Logout");
			echo "</a></td>";
			if ($_SESSION["PERMISIONS"] == "admin")
			{
				echo "<td style=\"width:1%;white-space:nowrap\"><a class=\"ws_pre_header_block_link\" href=\"../SysPages/SysBase.php?P=ManageUsers\">";
				$this->Translate("Manage users");
				echo "</a></td>";
			}
		}

		if (IsLoggedin())
		{
			echo "<td style=\"width:1%;white-space:nowrap\"><a class=\"ws_pre_header_block_link\" href=\"../SysPages/SysBase.php?P=Pwd\">";
			$this->Translate("Change Password");
			echo "</a></td>";
		}

		echo "<td style=\"width:3%\"></td>";
	}

	public function DrawPreHeaderFlags()
	{
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			if (!isset($this->Langs))
			{
				$this->GetLangArray();
			}
			$Langs = $this->Langs;
		}
		else
		{
			if (!isset($this->ActLangs))
			{
				$this->GetActiveLangs();
			}
			$Langs = $this->ActLangs;
		}

		foreach ($Langs as $L)
		{
			if ($this->Lang == $L)
			{
				echo "<td class=\"ws_pre_header_block_link\" style=\"width:1%\"><img class=\"ws_pre_header_block ws_transparent\" src=\"../Lib/Images/" . $L . ".jpg\"></td>";
			}
			else
			{
				echo "<td class=\"ws_pre_header_block_link\" style=\"width:1%\"><a href=\"" . WS_Page::GetPageName() . "?Lang=" . $L . "\"><img class=\"ws_pre_header_block\" src=\"../Lib/Images/" . $L . ".jpg\"></a></td>";
			}
		}
	}

	public function DrawPreHeaderUser()
	{
		if (!isset($_SESSION["SS_INSERTIONIST_ID"]) && (!IsLoggedin()))
		{
			echo $this->Translator->Translate("Guest");
		}

		if (isset($_SESSION["SS_INSERTIONIST_ID"]))
		{
			echo $_SESSION['SS_INSERTIONIST_NAME'];
		}

		echo "&nbsp;";

		if (IsLoggedin())
		{
			echo $_SESSION['USER_NAME'];
		}
	}

	public function GetPagesRelativePath($Path)
	{
		$Ret = $Path;
		$P = strpos("Pages/", $Path);
		if ($P > 0)
		{
			$Path = substr($Path, "Pages/");
		}
		return WS::$WSBase->Root . "/" . $Path;
	}

	public function GetTranslation($Text, $FromLang = "", $ToLang = "", $Chacheing = true)
	{
		return $this->Translator->Translate($Text, $FromLang, $ToLang, $Chacheing);
	}

	public function Translate($Text)
	{
		echo str_replace("'", "\'", $this->Translator->Translate($Text));
	}

	public function SetPopup($InnerCode, $Width = "400px", $Height = "", $Title = "", $HeaderClass = "", $BodyClass = "", $Top = "")
	{
		$this->PopupCode = $InnerCode;
		$this->PopupWidth = $Width;
		$this->PopupHeight = $Height;
		$this->PopupTitle = $Title;
		$this->PopupHeaderClass = $HeaderClass;
		$this->PopupBodyClass = $BodyClass;
		if (isset($Top) && ($Top != ""))
		{
			$this->PopupTop = $Top;
		}
	}

	public function DrawPopup()
	{

		if ($this->PopupCode != "")
		{
			// BACKGROUND
			echo "<div id=\"PopupBG\" class=\"ws_popup_bg\">\n";

                        $Width = "";
                        if ($this->PopupWidth != "") $Width = "width:".$this->PopupWidth.";";
                        
                        $Height = "";
                        if ($this->PopupHeight != "") $Height = "height:".$this->PopupHeight.";";
                        
                        
                        
			// BAR
			echo "<div id=\"PopupBarCont\" class=\"ws_tab ws_popup_bar_cont ws_central ".$this->PopupHeaderClass."\" style=\"width:" . $this->PopupWidth . "\" ondrag=\"ws_popup_drag();\">";
				echo "<div class=\"ws_row ws_full_width ws_popup_bar\">";
					echo "<div class=\"ws_cell ws ws_v_top ws_padd_l_10\" style=\"width:" . $this->PopupWidth . "\" >" . $this->PopupTitle . "</div>";
					echo "<div class=\"ws_cell\"><input type=\"submit\" name=\"btnClose\" value=\"X\"></div>\n";
				echo "</div>\n";
			echo "</div>\n";
			
			// BODY
			echo "<div id=\"PopupFrm\" class=\"ws_popup_body\" style=\"" . $Width . $Height . "\"><div class=\"ws_padd_10 ws_full_height\">".$this->PopupCode."</div></div>\n";
			
			// BACKGROUND
			echo "</div>\n";
			
			echo "<script type=\"text/javascript\">\n";
			
			// SET BACK GROUND
			echo "var B = document.body;\n";
			echo "H = document.documentElement;\n";
			
			echo "var BG = document.getElementById('PopupBG');\n";
			echo "BG.style.height = (Math.max( B.scrollHeight, B.offsetHeight,H.clientHeight, H.scrollHeight, H.offsetHeight)) + 'px';\n";
			
			echo "var FRM = document.getElementById('PopupFrm');\n";
			echo "var BAR = document.getElementById('PopupBarCont');\n";
			
			echo "var MARGIN_TOP = 85;\n";
			echo "BAR.style.top = (MARGIN_TOP) + 'px';\n";
			echo "FRM.style.top = (BAR.style.height) + 'px';\n";
			echo "BAR.style.left = (FRM.style.left) + 'px';\n";
			
			echo "$('#PopupBarCont').draggable();\n";
			
			echo "</script>\n";
			
			// DISABLE DRAGGING IF CONTAINS MAP
			if ((strpos($this->PopupCode,"www.bing.com/api/maps") === false) )
			{
				echo "<script type=\"text/javascript\">\n";
				
				echo "function ws_popup_drag() {\n";
				echo "var offset = $('#PopupBarCont').offset();\n";
				echo "var Y = offset.top + 31;\n";
				echo "var X = offset.left;\n";
				echo "$('#PopupFrm').offset({top:Y,left:X});}\n";
				
				echo "ws_popup_drag();\n";
				echo "</script>\n";
			}
		}
	}

	public function DrawComboBox($Sql, $Attributes, $Value = "", $FirstRow = "")
	{
		$Result = $this->WSDB->query($Sql);
		
		if ($Result === false)
		{
			echo "ERROR in DrawComboBox: " . $Sql;
			return;
		}
		
		echo "<select " . $Attributes . ">";
		
		if ($FirstRow != "")
		{
			echo $FirstRow;
		}
		
		for ($M = 0; $M < $Result->num_rows; $M++)
		{
			$Row = $Result->fetch_assoc();
			$V = array_values($Row);
			if ($Value == $V[0])
			{
				echo "<option selected value=\"" . $V[0] . "\">" . $V[1] . "</option>";
			}
			else
			{
				echo "<option value=\"" . $V[0] . "\">" . $V[1] . "</option>";
			}
		}
		echo "</select>";
	}

	public function GetMetaTag()
	{
		$Tag = WS_Property::GetText("MetaTag", "Tag");
		if (isset($Tag))
		{
			return $Tag;
		}
		return "";
	}

	public function GetMetaDesc()
	{
		$Tag = WS_Property::GetText("MetaDesc", "Tag");
		if (isset($Tag))
		{
			return $Tag;
		}
		return "";
	}

	public function SetPageCss()
	 {
		try
		{
			if (isset($this->WS_Page))
			{
				if ($this->WS_Page->MenuBarCss != "") {$this->IncludeCss("../Styles/MenuBar/" . $this->WS_Page->MenuBarCss );}
				if ($this->WS_Page->Css != "") {$this->IncludeCss("../Styles/" . $this->WS_Page->Css  );}
			}
			else
			{
				$Pag = WS_Page::GetStartPage();
				if ($Pag->Css != "") {$this->IncludeCss("../Styles/MenuBar/" . $Pag->Css );}
				if ($Pag->MenuBarCss != "") {$this->IncludeCss("../Styles/" . $Pag->MenuBarCss );} 
			}
		}
		catch(Exception $ex)
		{
			echo 'ERROR: ', $ex->getMessage(), "\n";
		}
	}

	public function GotoPage($PageName, $Params = "")
	{
		$Url = "../Pages/" . $PageName;

		if (strpos($PageName, ".php") == 0)
		{
			$Url .= ".php";
		}

		if (!file_exists($Url))
		{
			$Url = $PageName;
		}

		if ($Params != "")
		{
			if (strpos($Params, "?") == 0)
			{
				$Url .= "?";
			}
			$Url .= $Params;
		}

		header("location: " . $Url);
		exit(0);
	}

	//-----------------------------------------
	//------------ PRIVATE FUNCTION ----------
	//-----------------------------------------

	private function Init()
	{
		global $WSDB;
		try
		{
			// INIT SESSION VARS
			$this->HomeSite = "http://webspeedy.dynu.com";
			$this->Host = $_SERVER["HTTP_HOST"];
			
			// GET WEB SITE ROOT
			$this->Root = getcwd();
			if (substr($this->Root, strlen($this->Root) - 1, 1) == "/")
			{
				$this->Root = substr($this->Root, 0, strlen($this->Root) - 1);
			}

			if (substr($this->Root, strlen($this->Root) - 12, 12) == "Lib/SysPages")
			{
				$this->Root = substr($this->Root, 0, strlen($this->Root) - 12);
			}
			if (substr($this->Root, strlen($this->Root) - 8, 8) == "SysPages")
			{
				$this->Root = substr($this->Root, 0, strlen($this->Root) - 8);
			}
			if (substr($this->Root, strlen($this->Root) - 5, 5) == "Pages")
			{
				$this->Root = substr($this->Root, 0, strlen($this->Root) - 5);
			}

			if (substr($this->Root, strlen($this->Root) - 1, 1) == "\\")
			{
				$this->Root = substr($this->Root, 0, strlen($this->Root) - 1);
			}
			if (substr($this->Root, strlen($this->Root) - 12, 12) == "Lib\SysPages")
			{
				$this->Root = substr($this->Root, 0, strlen($this->Root) - 12);
			}
			if (substr($this->Root, strlen($this->Root) - 8, 8) == "SysPages")
			{
				$this->Root = substr($this->Root, 0, strlen($this->Root) - 8);
			}
			if (substr($this->Root, strlen($this->Root) - 5, 5) == "Pages")
			{
				$this->Root = substr($this->Root, 0, strlen($this->Root) - 5);
			}
			
			// MOBILE DETECT
			$useragent = $_SERVER['HTTP_USER_AGENT'];
			if (preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i', $useragent) || preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i', substr($useragent, 0, 4)))
			{
				$this->IsMobile = true;
			}

			// FRAME DETECT
			if (isset($_SERVER['HTTP_REFERER']))
				$this->IsInFrame = true;

			$this->Ver = date("Y");
			$this->WSDB = $WSDB;

			if (!isset($_SESSION["VISIT_LOG"]))
			{
				WS_Log::Log("Visit", 0, $_SERVER['REMOTE_ADDR']);

				$Agent = $useragent;
				if (strlen($Agent) > 32)
				{
					$Agent = substr($Agent, 0, 32);
				}
				WS_Log::Log("VisitExt", 0, $Agent);

				$_SESSION["VISIT_LOG"] = true;
			}

			// USER PROTECTION
			if (!isset($_SESSION['LOGIN_SITE_ID']))
			{
				$_SESSION['NEED_LOGIN'] = false;
				$_SESSION['PERMISIONS'] = "";
				$_SESSION['USER_ID'] = "";
				$_SESSION['USER_NAME'] = "";
				$_SESSION['LOGIN_SITE_ID'] = 0;
			}

			if (!isset($_SESSION["PERMISIONS"]))
			{
				$_SESSION["PERMISIONS"] = "";
			}
			if ($_SESSION["PERMISIONS"] == "")
			{ 
				$_SESSION["PERMISIONS"] = "guest";
				$Upd = new WS_Updater();
			}

			//CHECK FOR AUTO LOGIN
			if (WS_Cookie::Is_Set('USR') && (WS_Cookie::Is_Set('PWD')) && (WS_Cookie::Get('USER_ID') == ""))
			{
				$username = WS_Cookie::Get('USR');
				$password = WS_Cookie::Get('PWD');
				if (!empty($username) && !empty($password))
				{
					$User = WS_User::GetUserByName($username);
					if (isset($User))
					{
						if ($User->Password == $password)
						{
							if (!$User->Disabled)
							{
								$_SESSION['USER_ID'] = $User->UserID;
								$_SESSION['USER_NAME'] = $User->UserName;
								$_SESSION['PERMISIONS'] = $User->Permisions;
								$_SESSION['LOGIN_SITE_ID'] = $_SESSION['SITE_ID'];
								$_SESSION["LastAccessMM"] =  null;
								$_SESSION["LastAccessCount"] = null;
								WS_Log::Log("UsrLog", $User->UserID, "Cookie " . $_SERVER["REMOTE_ADDR"]);
							}
						}
					}
				}
			}

			if (!isset($_SESSION["SLOTS_EDIT_MODE"]))
			{
				$_SESSION["SLOTS_EDIT_MODE"] = false;
			}

			// LIST OF SUPPORTED LANGS
			$this->GetLang();
			$this->GetLangArray();
			$_SESSION["LANGS"] = implode(",", $this->Langs);

			if (isset($_POST["WS_SlotsEditMode"]))
			{
				$_SESSION["SLOTS_EDIT_MODE"] = true;
				$this->Lang = $this->BaseLang;
				$_SESSION["LANG"] = $this->BaseLang;
			}
			if (isset($_POST["WS_SlotsViewMode"]))
			{
				$_SESSION["SLOTS_EDIT_MODE"] = false;
			}
			if (!isset($_SESSION["WS_RowOffset"]))
			{
				$_SESSION["WS_RowOffset"] = 1;
			}
			if (!isset($_SESSION["WS_RET_PAG"]))
			{
				$_SESSION["WS_RET_PAG"] = "";
			}
			if (WS_Page::GetPageName() != $_SESSION["WS_RET_PAG"])
			{
				$_SESSION["WS_RowOffset"] = 1;
			}
			if (strpos(WS_Page::GetPageRelativePath(), '/Pages/') !== false)
				$_SESSION["WS_RET_PAG"] = $PageUrl = basename($_SERVER['REQUEST_URI']);

			if ((($_SESSION['LOGIN_SITE_ID'] != $_SESSION['SITE_ID']) && ($_SESSION['USER_ID'] != "")))
			{
				$_SESSION['USER_ID'] = "";
				$_SESSION['USER_NAME'] = "";
				$_SESSION['PERMISIONS'] = "guest";
				$_SESSION['LOGIN_SITE_ID'] = 0;
			}
			if ($_SESSION['USER_ID'] == "")
			{
				$_SESSION["SLOTS_EDIT_MODE"] = false;
			}

			// INJCTION STOPPER
			$this->InjectionStopper();

			// LOAD LANGUAGES
			$this->Translator = WS_Translator::Init(WS::$WSBase->Root . "/SysPages/Dictionary.txt");
			$this->Lang = $_SESSION["LANG"];

			// LOAD PAGE
			$this->WS_Page = WS_Page::GetPage($_SERVER['SCRIPT_NAME']);
			$this->SearchManager();
			$this->LoadSlots();

			echo "<meta charset=\"utf8\">";
			echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\" />";
			echo "<meta name=\"keywords\" content=\"" . $this->GetMetaTag() . "\">";
			
			echo "<script type=\"text/javascript\" src=\"../Lib/js/jquery.js\"></script>";
			echo "<script type=\"text/javascript\" src=\"../Lib/js/jquery-ui.js\"></script>";
			echo "<script type=\"text/javascript\" src=\"../Lib/js/AllowTab.js\"></script>";
			
			echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"../Lib/Styles/ws_private.css\"/>";
			echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"../Styles/ws_global.css\"/>";
			echo "<script type=\"text/javascript\" src=\"../Lib/js/AllowTab.js\" ></script>";
			
			if ($this->IsMobile)
			{
				echo "<meta name=\"viewport\" content=\"width=device-width/2, target-densitydpi=device-dpi/1.3, initial-scale=0.50, shrink-to-fit=no\"/>";
			}
			else
			{
				echo "<meta name=\"viewport\" content=\"width=device-width, target-densitydpi=device-dpi, initial-scale=1.0, shrink-to-fit=no\"/>";
			}
		}
		catch (Exception $Ex)
		{
			echo $Ex->getMessage();
		}
	} 

	private function NotAllowPHP()
	{
		
	}

	private function PageAccessControl()
	{
		if (isset($this->WS_Page->PermisionsR) && ($this->WS_Page->PermisionsR != ""))
		{
			$Perm = "none";
			if (isset($_SESSION["PERMISIONS"]) && ($_SESSION["PERMISIONS"] != "guest"))
			{
				$Perm = $_SESSION["PERMISIONS"];
			}
			if (!((strpos($this->WS_Page->PermisionsR, "all") !== false) ||
					(strpos($this->WS_Page->PermisionsR, $Perm) !== false)))
			{
				echo "<div style=\"margin:auto;width:300px;color:red\"><br/><br/>&nbsp;&nbsp;&nbsp;&nbsp;Access deny to this page!<br/>You need a login permisions.</div>";
				return false;
			}
		}
		return true;
	}

	public function GetLangArray()
	{
		$this->Langs = array("en", "it", "es", "fr", "de");
		if ($this->Lang == "en")
		{
			$this->Langs = array("en", "de", "it", "es", "fr");
		}
		if ($this->Lang == "de")
		{
			$this->Langs = array("de", "en", "fr", "es", "it");
		}
		if ($this->Lang == "it")
		{
			$this->Langs = array("it", "en", "es", "fr", "de");
		}
		if ($this->Lang == "es")
		{
			$this->Langs = array("es", "en", "it", "fr", "de");
		}
		if ($this->Lang == "fr")
		{
			$this->Langs = array("fr", "en", "it", "es", "de");
		}
		return $this->Langs;
	}

	public function GetActiveLangs()
	{
		if (!isset($this->ActLangs))
		{
			if ($_SESSION['SLOTS_EDIT_MODE'])
			{
				$this->ActLangs = explode(",", $_SESSION['LANGS']);
			}
			else
			{
				$Langs = WS_Slot::GetLangs();
				$_SESSION['LANGS'] = $Langs;
				$this->ActLangs = explode(",", $Langs);
			}
		}
		return $this->ActLangs;
	}

	private function ClearLang()
	{
		$this->Lang = null;
		$_SESSION["LANG"] = null;
	}

	public function GetLang()
	{
		if (!isset($this->Lang))
		{
			if (!isset($_SESSION["LANG"]) || ($_SESSION["LANG"] == ""))
			{
				$_SESSION["LANG"] = "";
				if (!isset($this->ActLangs))
				{
					$this->GetActiveLangs();
				}
				if (!isset($this->Lang))
				{
					$this->Lang = $this->BaseLang;
				}
				if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE']))
				{
					$BrowserLang = strtolower(substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2));
				}
				if (in_array($BrowserLang, $this->ActLangs))
				{
					$this->Lang = $BrowserLang;
				}
				$_SESSION["LANG"] = $this->Lang;
			}
			else
			{
				$this->Lang = $_SESSION["LANG"];
			}
		}
		return $this->Lang;
	}

	private function DrawLeftScrollMenuBar()
	{
		$this->CookieCheck();

		if (strrpos($_SESSION["PERMISIONS"], "admin") !== false)
		{
			if (isset($_POST["btnCCEncode"]))
			{
				if (strlen($_POST["txtCCEncode"]) == 37)
				{
					$this->WriteCCEncode($_POST["txtCCEncode"]);
				}

				if (strlen($_POST["txtCCEncode"]) == 32)
				{
					$this->WriteCCEncode($_POST["txtCCEncode"]);
				}
			}

			$CCEncodes = $this->GetCCEncodes();
			if (isset($_POST["WS_EditCSS"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditCSS");
			}
			if (isset($_POST["WS_EditCSS"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditGlobalCSS");
			}
			if (isset($_POST["WS_EditMenuBarCSS"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditMenuBarCSS");
			}
			if (isset($_POST["WS_EditTemplate"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditTemplate");
			}
			if (isset($_POST["WS_EditMaster"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditMaster");
			}
			if (isset($_POST["WS_EditPreHeader"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditPreHeader");
			}
			if (isset($_POST["WS_EditFooter"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditFooter");
			}
			if (isset($_POST["WS_EditProperties"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditProperties");
			}
			if (isset($_POST["WS_EditFormTemplate"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditFormTemplate");
			}
			if (isset($_POST["WS_Media"]))
			{
				header("Location: ../SysPages/SysBase.php?P=Media");
			}
			if (isset($_POST["WS_EditMeta"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditMetaTag");
			}
			if (isset($_POST["WS_EditPage"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditPage");
			}
			if (isset($_POST["WS_EditColors"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditColors");
			}
			if (isset($_POST["WS_NavPagePopup"]))
			{
				$Pop = "<br/><select style=\"width:370px;height:330px;font-size:20px\" id=\"WS_cmbPage\" name=\"WS_cmbPage\" class=\"ws_scroll_menu_pglist\" size=\"25\">";
				$PageDir = WS_Page::GetPagesNames();
				foreach ($PageDir as $Entry)
				{
					$Pop .= "<option>" . $Entry . "</option>";
				}
				$Pop .= "</select><br/><br/><br/>";
				$Pop .= "<input class=\"ws_button ws_margin_5\" id=\"WS_NavPage\" name=\"WS_NavPage\" type=\"submit\" value=\"Goto Page\" title=\"Move to the selected page\" class=\"ws_scroll_menu_btn\"/><br/><br/>";
				$this->SetPopup($Pop, "400px", "450px");
			}
			if (isset($_POST["WS_NavPage"]))
			{
				header("Location: ../Pages/" . $_POST["WS_cmbPage"] . ".php");
			}
			if (isset($_POST["WS_EditDictionary"]))
			{
				header("Location: ../SysPages/SysBase.php?P=EditDictionary");
			}
			if (isset($_POST["WS_AutoTranslate"]))
			{
				header("Location: ../SysPages/SysBase.php?P=AutoTranslate");
			}
			if (isset($_POST["WS_Utils"]))
			{
				header("Location: ../SysPages/SysBase.php?P=Utils");
			}
			
			if (file_exists("../Lib/js/Base.js"))
				{echo "<script type=\"text/javascript\" src=\"../Lib/js/Base.js\"></script>";}
			else
				{echo "<script type=\"text/javascript\" src=\"" . $this->HomeSite . "/Lib/js/Base.js\"></script>";}
				
			if (($this->CheckCCEncodes($CCEncodes)) || ($this->Host == "localhost"))
			{
				if ($this->IsMobile)
				{
					echo "<script type=\"text/javascript\">";
					echo "var ws_scroll_menu_open = false;";
					echo "function ws_scroll_menu_click()";
					echo "{";
					echo "if (!ws_scroll_menu_open)";
					echo "	{";
					echo "		WS_ORM('WS_DivFlt', 'WS_DivFlt2', 135);";
					echo "		ws_scroll_menu_open = true;";
					echo "	} else";
					echo "	{";
					echo "		WS_CRM('WS_DivFlt', 'WS_DivFlt2', 3);";
					echo "		ws_scroll_menu_open = false;";
					echo "	}";
					echo "}";
					echo "</script>";
					echo "<div id=\"WS_DivFlt2\" class=\"ws_scroll_menu_frec\" onclick=\"ws_scroll_menu_click();\">";
					echo "	.<br/>.<br/>.<br/>.</div>echo";
					echo "<div id=\"WS_DivFlt\" class=\"ws_scroll_menu\" onclick=\"ws_scroll_menu_click();\">";
				}
				else
				{
					echo "<div id=\"WS_DivFlt2\" class=\"ws_scroll_menu_frec\" onmouseover=\"WS_ORM('WS_DivFlt', 'WS_DivFlt2', 140);\" onmousemove=\"WS_ORM('WS_DivFlt', 'WS_DivFlt2', 140);\" onmouseout=\"WS_CRM('WS_DivFlt', 'WS_DivFlt2', 5);\">";
					echo "	&lt;&nbsp;<br/>&lt;&nbsp;<br/>&lt;&nbsp;<br/>&lt;&nbsp;</div>";
					echo "<div id=\"WS_DivFlt\" class=\"ws_scroll_menu\" onmouseover=\"WS_ORM('WS_DivFlt', 'WS_DivFlt2', 140);\" onmousemove=\"WS_ORM('WS_DivFlt', 'WS_DivFlt2', 140);\" onmouseout=\"WS_CRM('WS_DivFlt', 'WS_DivFlt2', 5);\">";
				}

				echo "<div class=\"ws_scroll_menu_text\"><b>Web Speedy config<b/></div>";

				echo "<div class=\"ws_scroll_menu_text\">";
				if ($_SESSION["SLOTS_EDIT_MODE"])
				{
					echo "<input id=\"WS_SlotsViewMode\" name=\"WS_SlotsViewMode\" type=\"submit\" value=\"Returm to view mode\" title=\"Return in view mode\" class=\"ws_scroll_menu_btn\"/>";
				}
				else
				{
					echo "<input id=\"WS_SlotsViewMode\" name=\"WS_SlotsEditMode\" type=\"submit\" value=\"Switch to edit mode\" title=\"Enter in edit mode\" class=\"ws_scroll_menu_btn\"/>";
				}
				echo "</div>\r\n";

				echo "<div class=\"ws_scroll_menu_text\">Pages";
				echo "<input id=\"WS_EditPage\" name=\"WS_EditPage\" type=\"submit\" value=\"Edit pages\" title=\"Edit the pages\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_NavPagePopup\" name=\"WS_NavPagePopup\" type=\"submit\" value=\"Goto Page\" title=\"Move to the selected page\" class=\"ws_scroll_menu_btn\"/>";
				echo "</div>\r\n";

				echo "<div class=\"ws_scroll_menu_text\">Media files";
				echo "<input id=\"WS_Media\" name=\"WS_Media\" type=\"submit\" value=\"Upload the files\" title=\"Upload and manage the images files\" class=\"ws_scroll_menu_btn\"/>";
				echo "</div>\r\n";

				echo "<div class=\"ws_scroll_menu_text\">CSS styles";
				echo "<input id=\"WS_EditColors\" name=\"WS_EditColors\" type=\"submit\" value=\"Edit colors\" title=\"Edit default colors\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_EditMenuBarCSS\" name=\"WS_EditMenuBarCSS\" type=\"submit\" value=\"Menu Bar CSS\" title=\"Edit menu bar style sheet\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_EditCSS\" name=\"WS_EditCSS\" type=\"submit\" value=\"Personalize CSS\" title=\"Edit global style sheet\" class=\"ws_scroll_menu_btn\"/>";
				echo "</div>\r\n";

				echo "<div class=\"ws_scroll_menu_text\">Templates";
				echo "<input id=\"WS_EditMaster\" name=\"WS_EditMaster\" type=\"submit\" value=\"Master\" title=\"Edit the master tempates\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_EditTemplate\" name=\"WS_EditTemplate\" type=\"submit\" value=\"Body\" title=\"Edit the body templates\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_EditFooter\" name=\"WS_EditPreHeader\" type=\"submit\" value=\"Pre-Header\" title=\"Edit the pre-header template\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_EditFooter\" name=\"WS_EditFooter\" type=\"submit\" value=\"Footer\" title=\"Edit the footer template\" class=\"ws_scroll_menu_btn\"/>";
				echo "</div>\r\n";

				echo "<div class=\"ws_scroll_menu_text\">Utils & configs";
				echo "<input id=\"WS_EditColors\" name=\"WS_EditColors\" type=\"submit\" value=\"Edit colors\" title=\"Edit the basic css colors\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_EditMeta\" name=\"WS_EditMeta\" type=\"submit\" value=\"Search keywords\" title=\"Edit the meta tag for the search engines\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_EditProperties\" name=\"WS_EditProperties\" type=\"submit\" value=\"Properties\" title=\"Edit the properties\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_AutoTranslate\" name=\"WS_AutoTranslate\" type=\"submit\" value=\"Translate\" title=\"Automatic translation of the web side contents\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_EditDictionary\" name=\"WS_EditDictionary\" type=\"submit\" value=\"Dictionary\" title=\"Edit worlds translation dictionary\" class=\"ws_scroll_menu_btn\"/>";
				echo "<input id=\"WS_Utils\" name=\"WS_Utils\" type=\"submit\" value=\"Manage Utils\" title=\"Open utilities page\" class=\"ws_scroll_menu_btn\"/>";
				echo "</div>\r\n";

				echo "<div class=\"ws_scroll_menu_text\">Help";
				echo "<input id=\"WS_Help\" name=\"WS_Help\" type=\"button\" value=\"Help\" title=\"Open the on-line help\" class=\"ws_scroll_menu_btn\" onclick=\"window.open('../Lib/Docs/index.html');\">";
				echo "</div>\r\n";
				$this->ActPopup = "";
				foreach ($CCEncodes as $CCE)
				{
					if (strlen($CCE) == 37)
					{
						echo "<script type=\"text/javascript\" >WS_CCEncode('" . $this->Host . "','" . $this->ExplodeCCEncode_Code($CCE) . "');</script>\r\n";
					}
					if (strlen($CCE) == 32)
					{
						echo "<script type=\"text/javascript\" >WS_CCEncode('" . $this->Host . "','" . $CCE . "');</script>\r\n";
					}
				}
			}
			else
			{
				$this->ActPopup .= "<br/>&nbsp;&nbsp;Get your personal site encode on <a href=\"http://ramp.dynu.com/WebSpeedy/Pages/GetCode.php\">Web Speedy</a><br/><br/>";
				$this->ActPopup .= "<br/>&nbsp;&nbsp;Use this site name:&nbsp;<b>" . $this->Host . "</b><br/><br/>";
				$this->ActPopup .= "<br/>&nbsp;&nbsp;Insert the code:&nbsp;<input type=\"text\" name=\"txtCCEncode\" size=\"40\"><br/><br/><br/>";
				$this->ActPopup .= "&nbsp;&nbsp;<input class=\"ws_button\" style=\"margin-left:80px\" type=\"submit\" name=\"btnCCEncode\" value=\"Register\">";
				if ($this->ActPopup != "")
					$this->SetPopup($this->ActPopup, "400px", "250px");
			}
			echo "</div>\r\n";
		}
	}

	public function CheckForCodePHP($Txt)
	{
		if (strpos($Txt, "<?php") === false)
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	public function ProtectPHP($Txt)
	{
		$Txt = str_replace("<?php	\$WS->", "<?@", $Txt);
		$Txt = str_replace("<?php   \$WS->", "<?@", $Txt);
		$Txt = str_replace("<?php  \$WS->", "<?@", $Txt);
		$Txt = str_replace("<?php \$WS->", "<?@", $Txt);
		$Txt = str_replace(";   ?>", "@?>", $Txt);
		$Txt = str_replace(";  ?>", "@?>", $Txt);
		$Txt = str_replace("; ?>", "@?>", $Txt);
		$Txt = str_replace(";?>", "@?>", $Txt);
		return $Txt;
	}

	public function UnprotectPHP($Txt)
	{
		$Txt = str_replace("<?@   ", "<?php \$WS->", $Txt);
		$Txt = str_replace("<?@  ", "<?php \$WS->", $Txt);
		$Txt = str_replace("<?@ ", "<?php \$WS->", $Txt);
		$Txt = str_replace("<?@", "<?php \$WS->", $Txt);
		$Txt = str_replace("   @?>", ";?>", $Txt);
		$Txt = str_replace("  @?>", ";?>", $Txt);
		$Txt = str_replace(" @?>", ";?>", $Txt);
		$Txt = str_replace("@?>", ";?>", $Txt);
		return $Txt;
	}

	public function DrawGoogleSpidersLinks()
	{
		if (!isset($this->WS_Page))
		{
			return;
		}

		echo "<div style=\"display:none\"><h1>" . $_SERVER["SERVER_NAME"] . "</h1></div>";
		echo "<div style=\"display:none\"><h2>" . $this->GetMetaDesc() . "</h2></div>";
		echo "<div style=\"display:none\"><h1>" . $this->WS_Page->GetPageTitle() . "</h1></div>";
		echo "<div style=\"display:none\"><h2>" . $this->WS_Page->GetPageDescription() . "</h2></div>";

		if ($this->WS_Page->MainPage)
		{
			$PagesNam = WS_Page::GetPagesNames();
			foreach ($PagesNam as $PN)
			{
				if ($PN != $this->WS_Page->Name)
				{
					$Pag = WS_Page::GetPageByName($PN);
					if (isset($Pag))
					{
						echo "<a style=\"display:none\" href=\"" . $Pag->GetPageLink() . "\">" . $Pag->GetPageTitle() . "</a>";
					}
				}
			}
		}
	}

	// --------------------- STATIC ----------------------

	public function TableExists($Table)
	{
		$Exist = true;
		if ($result = WS::$WSBase->WSDB->query("SHOW TABLES LIKE '" . $Table . "'"))
		{
			if ($result->num_rows == 1)
			{
				return true;
			}
		}
		return false;
	}

	public static function GetElementFromString($Str,$Start,$End)
	{
		$Keys = array();
		do
		{
			$P1 = strpos($Str,$Start);
			$P2 = strpos($Str,$End);
			if (($P1!==false) && ($P2!==false))
			{
				$Key = substr($Str, $P1 , $P2-$P1+2);
				$Str = substr($Str, $P2+2);
				array_push($Keys,$Key);
			}

		} while (($P1!==false) && ($P2!==false));
		return $Keys;
	}
	
	public static function GetMediaNames($WS_Page = null)
	{
		$DirPath="";
		if ($WS_Page == null)
		{
			$DirPath = WS::$WSBase->Root . "/Media";
			$myDirectory = opendir($DirPath);
		}
		else
		{
			$DirPath = WS::$WSBase->Root . "/Media/" . $WS_Page->Name;
			if (!file_exists($DirPath))
			{
				return array();
			}
			$myDirectory = opendir($DirPath);
		}

		$dirArray = array();
		while ($entryName = readdir($myDirectory))
		{
			if (!is_dir($DirPath."/".$entryName))
			{
				$dirArray[] = $entryName;
			}
		}

		closedir($myDirectory);

		if (isset($dirArray))
		{
			sort($dirArray);
			return $dirArray;
		}
		else
		{
			return array();
		}
	}

	public static function GetMastersNames()
	{
		$Path = WS::$WSBase->Root . "/Templates/Master/";
		if (!file_exists($Path)){$Path = WS::$WSBase->Root . "/Templates";}
		$myDirectory = opendir($Path);
		while ($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName, '.Master') && (!strpos($entryName, '.css')))
				{
					$dirArray[] = str_replace('.Master', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);

		return $dirArray;
	}

	public static function GetTemplatesNames()
	{
		$Path = WS::$WSBase->Root . "/Templates/Body/";
		if (!file_exists($Path)) {$Path = WS::$WSBase->Root . "/Templates/";}
		$myDirectory = opendir($Path);
		while ($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName, '.Template') && (!strpos($entryName, '.css')))
				{
					$dirArray[] = str_replace('.Template', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);

		return $dirArray;
	}

	public static function GetSubTemplatesNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root . "/Templates/Sub");
		while ($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName, '.Template') && (!strpos($entryName, '.css')))
				{
					$dirArray[] = str_replace('.Template', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);

		return $dirArray;
	}

	public static function GetPluginsNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root . "/Plugin");
		while ($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName, '.plugin.php') !== false)
				{
					$dirArray[] = str_replace('.plugin.php', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);

		return $dirArray;
	}

	public static function GetCssNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root . "/Styles");
		while ($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName, '.css'))
				{
					$dirArray[] = str_replace('.css', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);

		return $dirArray;
	}

	public static function GetMenuBarCssNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root . "/Styles/MenuBar");
		while ($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName, '.css'))
				{
					$dirArray[] = str_replace('.css', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);

		return $dirArray;
	}

	public static function GetUser($UserID)
	{
		return WS_User::GetUserByID($UserID);
	}

	public static function getServerURL()
	{
		$url = ($_SERVER["HTTPS"] == "on") ? "https://" : "http://";
		$url .= $_SERVER["SERVER_NAME"]; // variável do servidor, $_SERVER["HTTP_HOST"] é equivalente
		if ($_SERVER["SERVER_PORT"] != "80" && $_SERVER["SERVER_PORT"] != "443")
			$url .= ":" . $_SERVER["SERVER_PORT"];
		return $url;
	}

	public static function getCompleteURL()
	{
		return getServerURL() . $_SERVER["REQUEST_URI"];
	}

	public static function BuildSelectList($List, $Name, $SelectedValue)
	{
		$Ret = "<select class=\"ws_text\" name=\"" . $Name . "\">";
		for ($N = 0; $N < count($List); $N++)
		{
			$Ret .= "<option ";
			if (strpos($List[$N],"=") !== false)
			{
				$Val = explode("=",$List[$N]);
				$Text = $Val[0];
				$Value = $Val[1];
			}
			else
			{
				$Text = $List[$N];
				$Value = $List[$N];
			}
				
			if ($Value == $SelectedValue)
				$Ret .= " selected ";
			$Ret .= "value=\"" . $Value . "\">" . $Text;
			$Ret .= "</option>";
		}
		return $Ret . "</select>";
	}

	public static function BuildNullableSelectList($List, $Name, $value)
	{
		$Ret = "<select name=\"" . $Name . "\">";
		$Ret .= "<option ";
		if ("" == $value)
			$Ret .= " selected ";
		$Ret .= "value=\"\">";
		$Ret .= "</option>";
		for ($N = 0; $N < count($List); $N++)
		{
			$Ret .= "<option ";
			if ($List[$N] == $value)
				$Ret .= " selected ";
			$Ret .= "value=\"" . $List[$N] . "\">" . $List[$N];
			$Ret .= "</option>";
		}
		return $Ret . "</select>";
	}

	public static function GetLangByPriority()
	{
		if ($_SESSION["LANG"] == "en")
		{
			$Ret = array('en', 'de', 'es', 'fr', 'it');
		}
		if ($_SESSION["LANG"] == "it")
		{
			$Ret = array('it', 'en', 'es', 'fr', 'de');
		}
		if ($_SESSION["LANG"] == "es")
		{
			$Ret = array('es', 'en', 'it', 'fr', 'de');
		}
		if ($_SESSION["LANG"] == "fr")
		{
			$Ret = array('fr', 'en', 'it', 'es', 'de');
		}
		if ($_SESSION["LANG"] == "de")
		{
			$Ret = array('de', 'en', 'fr', 'it', 'es');
		}

		return $Ret;
	}

	public static function FilePutContents($File, $Data)
	{
		if (file_exists($File))
		{
			file_put_contents($File, $Data);
		}
		else
		{
			file_put_contents($File, $Data);
			WS::FileSetPermisions($File);
		}
	}

	public static function FileSetPermisions($File, $Perms = "")
	{
		//$Own = fileowner(WS::$WSBase->Root."/Media/WS.php");
		//$Grp = filegroup(WS::$WSBase->Root."/Media/WS.php");
		if ($Perms == "")
		{
			$Perms = fileperms(WS::$WSBase->Root . "/Media");
		}

		try
		{
			chmod($File, $Perms);
			//chown($File,$Own);
			//chgrp($File,$Grp);
		}
		catch (Exception $e)
		{
			
		}
	}

	public static function GenerateAuthCode($Str = "")
	{
		$L = strlen($Str);
		if (($L < 5) || ($L > 20))
		{
			$Str = WS::RandomString();
			$L = 10;
		}
		return $Str . substr(md5($Str), 5, $L);
	}

	public static function CheckAuthCode($Code)
	{
		$L = strlen($Code) / 2;
		$Str = substr($Code, 0, $L);
		$Cod = substr($Code, $L, $L);
		if (substr(md5($Str), 5, $L) == $Cod)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	public static function RandomString($length = 10)
	{
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$charactersLength = strlen($characters);
		$randomString = '';
		for ($i = 0; $i < $length; $i++)
		{
			$randomString .= $characters[rand(0, $charactersLength - 1)];
		}
		return $randomString;
	}
	
	public function ManageMenu($SlotID, $Menus, $SubMenus, $AllMenu)
	{
		$RowOffset = 0;
		$SlotKey = $this->GetSlotKey($SlotID);

		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$_SESSION["EDIT_MENU_SLOT"] = $SlotKey;
		}

		if ((isset($_SESSION["EDIT_MENU_SLOT"])) && (filter_input(INPUT_POST, "BtnBack" . $SlotKey)))
		{
			$_SESSION["EDIT_MENU_SLOT"] = null;
		}

		if ((isset($_SESSION["EDIT_MENU_SLOT"])) && (filter_input(INPUT_POST, "btnClose")))
		{
			$_SESSION["EDIT_MENU_SLOT"] = null;
		}

		// NEW
		if (filter_input(INPUT_POST, "BtnNew" . $SlotKey))
		{
			if ($_POST["cmbMaster" . $SlotKey] != "0")
			{
				$Pos = filter_input(INPUT_POST, "cmbMaster" . $SlotKey);
				$SubMenus = WS_Menu::GetMenus($SlotID, $Pos, null, $this->Lang, false);
				$SubPos = count($SubMenus) + 1;
			}
			else
			{
				$Menus = WS_Menu::GetMenus($SlotID, null, 0, $this->Lang, null);
				$Pos = count($Menus) + 1;
				$SubPos = 0;
			}

			$Text = filter_input(INPUT_POST, "txtText" . $SlotKey);
			$Tooltip = filter_input(INPUT_POST, "txtTooltip" . $SlotKey);
			$Link = filter_input(INPUT_POST, "txtLink" . $SlotKey);
			$Permisions = filter_input(INPUT_POST, "txtPermisions" . $SlotKey);
			$Mn = new WS_Menu();
			$Mn->Init($SlotID, $Pos, $SubPos, $Text, $Tooltip, $Link, $Permisions, $_SESSION["LANG"], 0);
			$Mn->Update();
			$Mn->SetDropDownFlag();

			//$Sql = "select Pos from ws_menus where SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$SlotID."' and Pos=".$Pos." and SubPos>0";
			//$rr=$this->WSDB->query($Sql);
			//if ($rr->num_rows>0)
			//{
			//	$Sql = "update ws_menus set DropDown=1 where SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$SlotID."' and Pos=".$Pos;
			//	$this->WSDB->query($Sql);
			//}
			//else
			//{
			//	$Sql = "update ws_menus set DropDown=0 where SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$SlotID."' and Pos=".$Pos;
			//	$this->WSDB->query($Sql);
			//}
		}

		$EditMenuPos = 0;
		foreach ($AllMenu as $Menu)
		{
			// MOVE DOWN
			if (isset($_POST["btnDw_" . $SlotKey . "_" . $Menu->Pos . "_" . $Menu->SubPos]))
			{
				$Menu->MoveDown();
			}

			// MOVE UP
			if (isset($_POST["btnUp_" . $SlotKey . "_" . $Menu->Pos . "_" . $Menu->SubPos]))
			{
				$Menu->MoveUp();
			}

			// DELETE
			if (isset($_POST["btnDel_" . $SlotKey . "_" . $Menu->Pos . "_" . $Menu->SubPos]))
			{
				$Menu->Delete();
				$Menu->SetDropDownFlag();
			}

			// EDIT
			if (isset($_POST["btnEdit_" . $SlotKey . "_" . $Menu->Pos . "_" . $Menu->SubPos]))
			{
				$EditMenuPos = $Menu->Pos;
				$EditMenuSubPos = $Menu->SubPos;
			}

			// UPDATE
			if (isset($_POST["BtnUpdate_" . $SlotKey . "_" . $Menu->Pos . "_" . $Menu->SubPos]))
			{
				$Pos = (int) $Menu->Pos;
				$SubPos = (int) $Menu->SubPos;
				$DropDown = (int) $Menu->DropDown;
				$Text = filter_input(INPUT_POST, "txtText" . $SlotKey);
				$Tooltip = filter_input(INPUT_POST, "txtTooltip" . $SlotKey);
				$Link = filter_input(INPUT_POST, "txtLink" . $SlotKey);
				$Permisions = filter_input(INPUT_POST, "txtPermisions" . $SlotKey);
				$Mn = new WS_Menu();
				$Mn->Init($SlotID, $Pos, $SubPos, $Text, $Tooltip, $Link, $Permisions, $this->Lang, 0);
				$Mn->Update();
				$Mn->SetDropDownFlag();
			}
		}

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (isset($_SESSION["EDIT_MENU_SLOT"]))
		{
			$Pop = "<div style=\"overflow:auto;padding:5px;margin:auto;width:98%;height:300px;border:1px solid black;background-color:rgba(200, 200, 200, 1);\">";
			$Pop .= "<table border=\"1\" style=\"width:99%\">";
			$Pop .= "<tr>";
			$Pop .= "<th colspan=\"4\"></th>";
			$Pop .= "<th>Text</th><th>SubMenu</th><th>Tooltip</th><th>Link</th><th>Permisions</th>";
			$Pop .= "</tr>";

			// MENU
			$Menus = WS_Menu::GetMenus($SlotID, null, 0, $this->Lang, null);
			foreach ($Menus as $Menu)
			{
				$SubMenus = WS_Menu::GetMenus($SlotID, $Menu->Pos, null, $this->Lang, false);
				$Pop .= "<tr>";
				$Pop .= "<td style=\"width:1px\"><input class=\"ws_button\" type=\"submit\" name=\"btnDel_" . $SlotKey . "_" . $Menu->Pos . "_" . $Menu->SubPos . "\" value=\"Del\" title=\"Delete\"></td>";
				$Pop .= "<td style=\"width:1px\">";
				if ($Menu->Pos > 1)
				{
					$Pop .= "<input class=\"ws_button\" type=\"submit\" name=\"btnUp_" . $SlotKey . "_" . $Menu->Pos . "_" . $Menu->SubPos . "\" value=\"Up\" title=\"Move Up\">";
				}
				$Pop .= "</td>";
				$Pop .= "<td style=\"width:1px\">";
				if ($Menu->Pos < count($Menus))
				{
					$Pop .= "<input class=\"ws_button\" type=\"submit\" name=\"btnDw_" . $SlotKey . "_" . $Menu->Pos . "_" . $Menu->SubPos . "\" value=\"Down\" title=\"Move Down\">";
				}
				$Pop .= "</td>";
				$Pop .= "<td style=\"width:1px\">";
				$Pop .= "<input class=\"ws_button\" type=\"submit\" name=\"btnEdit_" . $SlotKey . "_" . $Menu->Pos . "_" . $Menu->SubPos . "\" value=\"Edit\" title=\"Edit\">";
				$Pop .= "</td>";
				$Pop .= "<td>" . $Menu->Text . "</td>";
				$Pop .= "<td></td>";
				$Pop .= "<td>" . $Menu->Tooltip . "</td>";
				$Pop .= "<td>" . $Menu->Link . "</td>";
				$Pop .= "<td>" . $Menu->Permisions . "</td>";
				$Pop .= "</tr>";
				//SUB MENU
				if ($Menu->DropDown)
				{
					//$SubMenus = WS_Menu::GetMenus($SlotID,$Menu->Pos,true);
					foreach ($SubMenus as $SM)
					{
						$Pop .= "<tr>";
						$Pop .= "<td style=\"width:1px\"><input class=\"ws_button\" type=\"submit\" name=\"btnDel_" . $SlotKey . "_" . $SM->Pos . "_" . $SM->SubPos . "\" value=\"Del\" title=\"Delete\"></td>";
						$Pop .= "<td style=\"width:1px\">";
						if ($SM->SubPos > 1)
						{
							$Pop .= "<input class=\"ws_button\" type=\"submit\" name=\"btnUp_" . $SlotKey . "_" . $SM->Pos . "_" . $SM->SubPos . "\" value=\"Up\" title=\"Move Up\">";
						}
						$Pop .= "</td>";
						$Pop .= "<td style=\"width:1px\">";
						if ($SM->SubPos < count($SubMenus))
						{
							$Pop .= "<input class=\"ws_button\" type=\"submit\" name=\"btnDw_" . $SlotKey . "_" . $SM->Pos . "_" . $SM->SubPos . "\" value=\"Down\" title=\"Move Down\">";
						}
						$Pop .= "</td>";
						$Pop .= "<td style=\"width:1px\">";
						$Pop .= "<input class=\"ws_button\" type=\"submit\" name=\"btnEdit_" . $SlotKey . "_" . $SM->Pos . "_" . $SM->SubPos . "\" value=\"Edit\" title=\"Edit\">";
						$Pop .= "</td>";
						$Pop .= "<td>&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;</td>";
						$Pop .= "<td style=\"width:1px;background-color:#aaaaaa\">" . $SM->Text . "</td>";
						$Pop .= "<td style=\"width:1px;background-color:#aaaaaa\">" . $SM->Tooltip . "</td>";
						$Pop .= "<td style=\"width:1px;background-color:#aaaaaa\">" . $SM->Link . "</td>";
						$Pop .= "<td style=\"width:1px;background-color:#aaaaaa\">" . $SM->Permisions . "</td>";
						$Pop .= "</tr>";
					}
				}
			}
			$Pop .= "</table><br/>";
			$Pop .= "</div><br/>";

			$Pop .= "<div style=\"padding:5px;margin:auto;width:98%;height:90px;border:1px solid black;background-color:rgba(200, 200, 200, 1);\">";
			$Pop .= "<table style=\"width:95%\"><tr>";
			$Pop .= "<td>Master Menu</td>";
			$Pop .= "<td>Text</td>";
			$Pop .= "<td>Tooltip</td>";
			$Pop .= "<td>Link</td>";
			$Pop .= "<td>Permisions</td>";
			$Pop .= "<td></td>";
			$Pop .= "</tr><tr>";

			$Pages = WS_Page::GetPagesNames();
			$Block = "<td><select style=\"width:99%\" id=\"ws_lstPage" . $SlotKey . "\" onchange=\"ws_SetMenuLink('" . $SlotKey . "');\">";
			$Block .= "<option value=\"\"></option>";
			foreach ($Pages as $P)
			{
				$Block .= "<option value=\"" . $P . ".php\">" . $P . "</option>";
			}
			$Block .= "</select></td><td></td><td></td>";

			if ($EditMenuPos == 0)
			{
				// NUOVO MENU
				$MenuList = WS_Menu::GetMenus($SlotID, null, 0, $this->Lang, null);
				$Pop .= "<td><select style=\"width:99%\" name=\"cmbMaster" . $SlotKey . "\">";
				$Pop .= "<option value=\"0\"></option>";
				foreach ($MenuList as $M)
				{
					$Pop .= "<option value=\"" . $M->Pos . "\">" . $M->Text . "</option>";
				}
				$Pop .= "</select></td>";

				$Pop .= "<td><input style=\"width:99%\" type=\"text\" name=\"txtText" . $SlotKey . "\"></td>";
				$Pop .= "<td><input style=\"width:99%\" type=\"text\" name=\"txtTooltip" . $SlotKey . "\"></td>";
				$Pop .= "<td><input style=\"width:99%\" type=\"text\" id=\"txtLink" . $SlotKey . "\" name=\"txtLink" . $SlotKey . "\"></td>";
				$Pop .= "<td><input style=\"width:99%\" type=\"text\" id=\"txtPermisions" . $SlotKey . "\" name=\"txtPermisions" . $SlotKey . "\" value=\"all\"></td>";
				$Pop .= "<td><input class=\"ws_button\" name=\"BtnNew" . $SlotKey . "\" type=\"submit\" value=\"New Voice\" /></td>";
				$Pop .= "<td></td>";
				$Pop .= "</tr><tr><td></td><td></td><td>" . $Block . "</td><td></td><td></td><td></td>";
			}
			else
			{
				// EDIT MODE
				if ($EditMenuSubPos == 0)
				{
					// PRIMARY MENU
					$Pop .= "<td></td>";
				}
				else
				{
					// SUB MENU
					$Menus = WS_Menu::GetMenus($SlotID, null, 0, $this->Lang);
					$Pop .= "<td><select name=\"cmbMaster" . $SlotKey . "\" onchange=\"SetMenuMaster();\">";
					$Pop .= "<option value=\"0\"></option>";
					foreach ($Menus as $M)
					{
						if ($M->Pos == $EditMenuPos)
						{
							$Pop .= "<option selected value=\"" . $M->Pos . "\">" . $M->Text . "</option>";
						}
						else
						{
							$Pop .= "<option value=\"" . $M->Pos . "\">" . $M->Text . "</option>";
						}
					}
					$Pop .= "</select></td>";
				}

				if ($EditMenuSubPos != 0)
				{
					$Menus = WS_Menu::GetMenus($SlotID, $EditMenuPos, $EditMenuSubPos, $this->Lang, false);
				}
				$ID = $EditMenuPos . "_" . $EditMenuSubPos;

				$Pop .= "<td><input style=\"width:99%\" type=\"text\" name=\"txtText" . $SlotKey . "\" value=\"" . $Menus[$ID]->Text . "\"></td>";
				$Pop .= "<td><input style=\"width:99%\" type=\"text\" name=\"txtTooltip" . $SlotKey . "\" value=\"" . $Menus[$ID]->Tooltip . "\"></td>";
				$Pop .= "<td><input style=\"width:99%\" type=\"text\" id=\"txtLink" . $SlotKey . "\" name=\"txtLink" . $SlotKey . "\" value=\"" . $Menus[$ID]->Link . "\"></td>";
				$Pop .= "<td><input style=\"width:99%\" type=\"text\" name=\"txtPermisions" . $SlotKey . "\" value=\"" . $Menus[$ID]->Permisions . "\"></td>";
				$Pop .= "<td><input class=\"ws_button\" name=\"BtnUpdate_" . $SlotKey . "_" . $EditMenuPos . "_" . $EditMenuSubPos . "\" type=\"submit\" value=\"Update\" /></td>";
				$Pop .= "<td><input class=\"ws_button\" name=\"BtnCanc_" . $SlotKey . "_" . $EditMenuPos . "_" . $EditMenuSubPos . "\" type=\"submit\" value=\"Cancel\" /></td>";
				$Pop .= "</tr><tr><td>(for sub menu)</td><td></td><td>" . $Block . "</td><td></td><td></td><td></td>";
			}
			$Pop .= "</tr></table><br/><br/>";
			$Pop .= "<input class=\"ws_button\" name=\"BtnBack" . $SlotKey . "\" type=\"submit\" value=\"Close\" />";
			$Pop .= "</div>";
			$this->SetPopup($Pop, "99%", "500px", "Edit Menu <span style=\"color:orangered\">(".$this->Lang.")</span>", "", "", "25px");
		}
	}

	public function GetDbConnectFromProperties($ConnectionProprety)
	{
		// DB CONNECTION
		if ($ConnectionProprety=="") 
		{
			$DBServer = $this->WSDB->DBServer;
			$User=$this->WSDB->User;
			$Password=$this->WSDB->Password;
			$DbName=$this->WSDB->DbName;
		}
		else
		{
			$ConnStr=WS_Property::Get("DBConnection", $ConnectionProprety);
			$Params=explode($ConnStr,";");
			foreach ($Params as $Parm)
			{
				$Dat = trim(explide($Parm,"="));
				if ($Dat[0]=="DBServer") {$DBServer = $Dat[1];}
				if ($Dat[0]=="DbName") {$DbName = $Dat[1];}
				if ($Dat[0]=="User") {$User = $Dat[1];}
				if ($Dat[0]=="Password") {$Password = $Dat[1];}
			}
		}
		try
		{
			$DB=new ConnectDB($DBServer,$User,$Password,$DbName);
			return $DB;
		}
		catch(Exception $Ex)
		{
			echo "Can't connect DB: DBServer=".$DBServer.";DbName=".$DbName.";User=".$User." (".$Ex->getMessage().")";
			return null;
		}
	}
	
	public function IncludeCss($CssFile)
	{
		if (!in_array($CssFile, $this->CssList))
		{
			if (file_exists($CssFile))
			{
				echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . $CssFile . "\" />";
				array_push($this->CssList,$CssFile);
				return true;
			}
		}
		return false;
	}
	
	public function IncludeScript($ScriptFile)
	{
		if (!in_array($ScriptFile, $this->ScriptList))
		{
			if (file_exists($ScriptFile))
			{
				echo "<script type=\"text/javascript\" src=\"" . $ScriptFile . "\"></script>";
				array_push($this->ScriptList,$ScriptFile);
				return true;
			}
		}
		return false;
	}
	
	public function IncludeFile($File)
	{
		if (file_exists($File))
		{
			$WS = self::$WSBase;
			include ($File);
		}
		else
		{
			echo "<br/>Error:<br/><br/>WS->PlugFile: File not found (" . $File . ")\n";
		}
	}
	
	public function GetHeaderSlotKey($SlotID)
	{
		return "0_0_" . $SlotID . "_" . $this->WS_Page->PgUID;
	}

	public function GetSlotKey($SlotID)
	{
		if (!isset($this->CurrentBodyID)) {return $this::GetHeaderSlotKey($SlotID);}
		return $this->WS_Page->PageID . "_" . strval($this->CurrentBodyID) ."_" . $SlotID . "_" . $this->WS_Page->PgUID;
	}
	
	public function LoadSlots()
	{
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($this->WS_Page->PageID)){return;}
		if ($this->WSDB == null){return;}

		$this->WS_Page->Slots = array();

		$Langs = WS::GetLangByPriority();
		$Langs = array_reverse($Langs);
		foreach ($Langs as $Lang)
		{
			$Slots = WS_Slot::GetSlots($this->WS_Page->PageID, $Lang);
			$this->LoadSlot($Slots);
			$Slots = WS_Slot::GetSlots(0,$Lang);
			$this->LoadSlot($Slots);
		}
	}

	public function LoadSlot($Slots)
	{
		if (count($Slots) != 0)
		{
			for ($N = 0; $N < count($Slots); $N++)
			{
				$Slot = $Slots[$N];
				$SlotKey = $Slot->PageID . "_" . $Slot->BodyID . "_" . $Slot->SlotID . "_" . $Slot->PgUID;
				$this->WS_Page->Slots[$SlotKey] = $Slot;
			}
		}
	}

	public function ReadInputSlots($PageID, $SlotID,  $ContType)
	{
		if (!$_SESSION["SLOTS_EDIT_MODE"])
		{
			return;
		}

		if (!isset($this->CurrentBodyID)){$PageID=0;}
		
		$PgUID = $this->WS_Page->PgUID;

		$SlotKey = $this->GetSlotKey($SlotID, $this->CurrentBodyID);
		

		if (filter_input(INPUT_POST, "WS_IN_BtnClear_" . $SlotKey))
		{
			$this->SlotDelete($PageID, $this->CurrentBodyID, $SlotID);
			$this->LoadSlots();
		}

		if (filter_input(INPUT_POST, "WS_IN_BtnUpdate_" . $SlotKey))
		{
			$Text = "";
			$Link = "";
			$Params = $this->InitParamsArray();

			if (isset($_POST["WS_IN_Text_" . $SlotKey]))
			{
				$Text = filter_input(INPUT_POST, "WS_IN_Text_" . $SlotKey);
				if ((substr($Text,0,3)=="<p>") && (substr($Text,strlen($Text)-4,4) =="</p>"))
				{
					$T= substr(substr($Text,3),0,strlen($Text)-7);
					if (! (strpos($T,"<p>")) > (strpos($T,"</p>")))
					{
						$Text = $T;
					}
				}
			}
			for ($N = 0; $N < WS_Slot::$NumParams; $N++)
			{
				if (isset($_POST["WS_IN_Param" . $N . "_" . $SlotKey]))
				{
					$Params[$N] = filter_input(INPUT_POST, "WS_IN_Param" . $N . "_" . $SlotKey);
				}
			}

			if (isset($_POST["WS_IN_Link_" . $SlotKey]))
				{$Link = filter_input(INPUT_POST, "WS_IN_Link_" . $SlotKey);}

			$Upd = false;
			if ($Text != ""){$Upd = true;}
			if ($Link != ""){$Upd = true;}
			for ($N = 0; $N < WS_Slot::$NumParams; $N++)
				{if ($Params[$N] != "") {$Upd = true;}}

			if ($Upd)
			{
				$this->SlotUpdate($PageID, $SlotID, $Text, $Params, $Link, $ContType);
				$this->LoadSlots();
			}
		}
	}
	
	public function InitParamsArray()
	{
		$Params = Array();
		for ($N = 0; $N < WS_Slot::$NumParams; $N++)
		{
			$Params[$N] = "";
		}
		return $Params;
	}

	public function SlotUpdate($PageID, $SlotID, $Text, $Params, $Link, $Type)
	{
		$PgUID = $this->WS_Page->PgUID;

		if (!isset($this->CurrentBodyID))
		{	
			$PageID =0;
			$BodyID = 0;
			$SlotKey = $this->GetHeaderSlotKey($SlotID);
		}
		else
		{
			$BodyID = $this->CurrentBodyID;
			$SlotKey = $this->GetSlotKey($SlotID);
		}

		$Lang = $this->Lang;
		if ($Type=="TEM"){$Lang=$this->BaseLang;}
		$Slot = WS_Slot::GetSlot($PageID, $BodyID, $SlotID, $PgUID, $Lang);
		
		if ($Slot == null)
		{
			$Slot = new WS_Slot($PageID,$BodyID, $SlotID, $PgUID, $Lang);
			$Slot->ContType = $Type;
			if ($Type=="TEM") {$Slot->MasterPgUID = WS_Slot::GetMaxPgUID($PageID)+1;}
		}
		
		$Slot->Text = $Text;
		for ($N = 0; $N < WS_Slot::$NumParams; $N++)
		{
			$Slot->Param[$N] = $Params[$N];
		}
		$Slot->Link = $Link;
		$Slot->Update();

		// GENERATE BASE LANGUAGE SLOT IF NOT EXISTS
		if ($this->Lang != $this->BaseLang)
		{
			$Slot = WS_Slot::GetSlot($PageID,$BodyID, $SlotID, $PgUID, $this->BaseLang);
			$Upd = false;
			if ($Slot == null)
			{
				$Upd = true;
			}
			else
			{
				if (($Slot->Text == "") && ($Text != "")){$Upd = true;}
			}

			// CREATE BASE LANGUAGE SLOT 
			if ($Upd)
			{
				$Slot = WS_Slot::GetSlot($PageID,$BodyID, $SlotID, $PgUID, $this->Lang);
				$Slot->Lang = $this->BaseLang;
				$Slot->Update();
			}
		}
	}
	
	public function DrawEditButton($SlotKey, $Text, $Title, $Class, $Value = "", $OnClick = "")
	{
		$Text = " ";
		if (($_SESSION["WS_PagSearch"] == "") || ($Value != ""))
		{
			if ($OnClick != "")
			{
				$OnClick = " onclick=\"" . $OnClick . "\" ";
			}
			return "<input name=\"Btn" . $SlotKey . "\" type=\"submit\" value=\"" . $Text . "\" title=\"" . $Title . "\" class=\"ws_btnedit " . $Class . "\" " . $OnClick . "/>";
		}
		return "";
	}

	public function DrawClassesComboBox($DestTextBoxID)
	{
		$Classes = array(
			"" => "",
			"ws_scroll" => "scroll",
			"ws_scroll-x" => "scroll-x",
			"ws_scroll-y" => "scroll-y",
			"ws_bordered" => "border",
			"ws_rounded" => "rounded border",
			"ws_central" => "central",
            "ws_v_top" => "vertical align top",
            "ws_v_central" => "vertical align central",
            "ws_v_bottom" => "vertical align bottom",
            
			"ws_full_width" => "width 100%",
			"ws_width_80p" => "width 80%",
			"ws_width_60p" => "width 60%",
			"ws_width_50p" => "width 50%",
			"ws_width_40p" => "width 40%",
			"ws_width_33p" => "width 33%",
			"ws_width_25p" => "width 25%",
            
            "ws_full_height" => "height 100%",
            "ws_height_75p" => "height 75%",
            "ws_height_50p" => "height 50%",
            "ws_height_25p" => "height 25%",
            
			"ws_padd_5" => "padding 5px",
			"ws_padd_10" => "padding 10px",
			"ws_padd_20" => "padding 20px",
			"ws_padd_30" => "padding 30px",
			"ws_padd_40" => "padding 40px",
            "ws_padd_50" => "padding 50px",
            "ws_padd_100" => "padding 100px",
            
			"ws_margin_5" => "margin 5px",
			"ws_margin_10" => "margin 10px",
			"ws_margin_20" => "margin 20px",
			"ws_margin_30" => "margin 30px",
			"ws_margin_40" => "margin 40px",
            "ws_margin_450" => "margin 50px",
            "ws_margin_100" => "margin 100px",
            
			"ws_font_8" => "font size 8px",
			"ws_font_10" => "font size 10px",
			"ws_font_12" => "font size 12px",
			"ws_font_15" => "font size 15px",
			"ws_font_20" => "font size 20px",
			"ws_font_25" => "font size 25px",
			"ws_font_30" => "font size 30px",
			"ws_font_40" => "font size 40px",
			"ws_font_50" => "font size 50px",
			"ws_font_60" => "font size 60px",
            
			"ws_txt_center" => "text center",
			"ws_txt_left" => "text left",
			"ws_txt_right" => "text right",
			"ws_txt_justify" => "text justify",

            "ws_bg_col_semi_transp" => "background color semi transp.",
            "ws_bg_col_transp" => "background color transp.",
            "ws_bg_col_white" => "background color white",
            "ws_bg_col_silver" => "background color silver",
            "ws_bg_col_gold" => "background color gold",
            "ws_bg_col_red" => "tbackground color red",
            "ws_bg_col_green" => "background color green",
            "ws_bg_col_blue" => "background color blue",
            "ws_bg_col_black" => "background color black"
            
		);

		
		$Ret = "<select class=\"ws_text\" style=\"height:26px\" onchange=\"$('#".$DestTextBoxID."').val($('#".$DestTextBoxID."').val() + ' ' + $(this).val())\">";
		foreach ($Classes as $key => $val )
		{
			$Ret .= "<option value=\"".$key."\">".$val."</option>";
		}
		$Ret .= "</select>";
		
		return $Ret;
	}
	
	public function DrawConfigSlots($PageID, $SlotID, $ParamDefs)
	 {			
		$SlotKey = $this->GetSlotKey($SlotID, $this->CurrentBodyID);
		
		$this->IncludeScript("../Lib/js/TextAreaSet.js");
		
		$Pop = "<div style=\"overflow-y:auto;height:80%;width:99%;margin:5px\"><br/>";

		$Pop .= "<table>";
		foreach ($ParamDefs as $Param)
		{
			$V = $Param->DefaultValue;
			if ($Param->Name == "Text")
			{
				if (isset($this->WS_Page->Slots[$SlotKey]))
				{
					$V = $this->WS_Page->Slots[$SlotKey]->Text;
				}

				if ($Param->Height < 2)
				{
					$Pop .= "<tr><td class=\"ws_text\" >&nbsp;" . $Param->Text . "</td><td class=\"ws_padd_5\"><input id=\"WS_IN_Text_" . $SlotKey . "\" name=\"WS_IN_Text_" . $SlotKey . "\" type=\"text\" size=\"" . $Param->Width . "\" value=\"" . $V . "\"></td></tr>";
				}
				else
				{	
					if (substr($V, 1, 1) == "\n")
					{
						$V = "\n" . $V;
					}
					$Pop .= "<tr><td class=\"ws_text\" >&nbsp;" . $Param->Text . "</td><td class=\"ws_padd_5 ws_text\">";
					//$Pop .= "<textarea id=\"WS_IN_Text_" . $SlotKey . "\" name=\"WS_IN_Text_" . $SlotKey . "\" cols=\"" . $Param->Width . "\" rows=\"" . $Param->Height . "\">" . $V . "</textarea>";					
					//$Pop .= "<script type=\"text/javascript\">$(document).ready(function() {\$('#WS_IN_Text_" . $SlotKey . "').summernote({height: 400});});</script>";
					$HE = new HtmlEditor("WS_IN_Text_" . $SlotKey);
					$Pop .= $HE->Build($V,strval(intval($Param->Width)*10)."px",strval(intval($Param->Height)*10)."px");
					$Pop .= "<script type=\"text/javascript\">AllowTab('WS_IN_Text_" . $SlotKey ."');</script>";
					$Pop .= "</td></tr>";
				}
			}

			for ($N = 0; $N < WS_Slot::$NumParams; $N++)
			{
				if ($Param->Name == "Param" . $N)
				{
					if ($Param->Type == "CLS")
					{
						if (isset($this->WS_Page->Slots[$SlotKey]))
						{
							$V = $this->WS_Page->Slots[$SlotKey]->Param[$N];
						}
						$Pop .= "<tr><td class=\"ws_text\" >&nbsp;" . $Param->Text . "</td><td  class=\"ws_padd_5\" ><input class=\"ws_text\" id=\"WS_IN_Param" . $N . "_" . $SlotKey . "\" name=\"WS_IN_Param" . $N . "_" . $SlotKey . "\" type=\"text\" size=\"" . strval(intval($Param->Width)-25) . "\" value=\"" . $V . "\">";
						$Pop .= $this->DrawClassesComboBox("WS_IN_Param" . $N . "_" . $SlotKey );
						$Pop .= "</td></tr>";
					}
					
					if ($Param->Type == "TXT")
					{
						if (isset($this->WS_Page->Slots[$SlotKey]))
						{
							$V = $this->WS_Page->Slots[$SlotKey]->Param[$N];
						}
						if ($Param->Height < 2)
						{
							$Pop .= "<tr><td class=\"ws_text\" >&nbsp;" . $Param->Text . "</td><td class=\"ws_padd_5\"><input class=\"ws_text\" name=\"WS_IN_Param" . $N . "_" . $SlotKey . "\" type=\"text\" size=\"" . $Param->Width . "\" value=\"" . $V . "\"></td></tr>";
						}
						else
						{
							$Pop .= "<tr><td class=\"ws_text\" style=\"color:black\">&nbsp;" . $Param->Text . "</td><td class=\" ws_margin_5\">";
							$Pop .= "<textarea wrap=\"off\" class=\"ws_text\" name=\"WS_IN_Param" . $N . "_" . $SlotKey . "\" type=\"text\" cols=\"" . $Param->Width . "\" rows=\"" . $Param->Height . "\">" . $V . "</textarea>";
							$Pop .= "<script type=\"text/javascript\">AllowTab('WS_IN_Text_" . $N . "_" . $SlotKey ."');</script>";
							$Pop .= "</td></tr>";
						}
					}
					if ($Param->Type == "DDL")
					{
						$V = $Param->Values[0];
						if (isset($this->WS_Page->Slots[$SlotKey])){$V = $this->WS_Page->Slots[$SlotKey]->Param[$N];}
						$Pop .= "<tr><td class=\"ws_text\">&nbsp;" . $Param->Text . "</td><td class=\"ws_padd_5\">";
						$Pop .= $this->BuildSelectList($Param->Values, "WS_IN_Param" . $N . "_" . $SlotKey, $V);
						$Pop .= "</td></tr>";
					}
					if ($Param->Type == "BOOL")
					{
						if ($V = "")
						{
							$V = $Param->Values[0];
						}
						if (isset($this->WS_Page->Slots[$SlotKey]))
						{
							$V = $this->WS_Page->Slots[$SlotKey]->Param[$N];
						}
						$Pop .= "<tr><td class=\"ws_text\" >&nbsp;" . $Param->Text . "</td><td class=\"ws_padd_5\">";
						$Values = array("true", "false");
						$Pop .= $this->BuildSelectList($Values, "WS_IN_Param" . $N . "_" . $SlotKey, $V);
						$Pop .= "</td></tr>";
					}
					if ($Param->Type == "NDDL")
					{
						if ($V = "")
						{
							$V = $Param->Values[0];
						}
						if (isset($this->WS_Page->Slots[$SlotKey]))
						{
							$V = $this->WS_Page->Slots[$SlotKey]->Param[$N];
						}
						$Pop .= "<tr><td class=\"ws_text\" >&nbsp;" . $Param->Text . "</td><td class=\"ws_padd_5\">";
						$Pop .= $this->BuildNullableSelectList($Param->Values, "WS_IN_Param" . $N . "_" . $SlotKey, $V);
						$Pop .= "</td></tr>";
					}

					if ($Param->Type == "COL")
					{
						if (isset($this->WS_Page->Slots[$SlotKey]))
						{
							$V = $this->WS_Page->Slots[$SlotKey]->Param[$N];
						}

						$Pop .= "<tr><td class=\"ws_text\" >&nbsp;" . $Param->Text . "</td><td class=\"ws_padd_5\"><input data-jscolor=\"\" id=\"WS_IN_Param" . $N . "_" . $SlotKey . "\" name=\"WS_IN_Param" . $N . "_" . $SlotKey . "\" style=\"width:80px\" value=\"" . $V . "\">";
						$Pop .= "<input type=\"button\" value=\"Transparent\" onclick=\"document.getElementById('WS_IN_Param" . $N . "_" . $SlotKey . "').value='transparent'\" ></td></tr>";
						$Pop .= "</tr>";
					}
				}
			}

			if ($Param->Name == "Link")
			{
				if (isset($this->WS_Page->Slots[$SlotKey]))
				{
					$V = $this->WS_Page->Slots[$SlotKey]->Link;
				}
				$Txt = $Param->Text;
				$Pop .= "<tr><td class=\"ws_text\">&nbsp;" . $Txt . "</td><td class\"ws_margin_5\"><input class=\"ws_text\" name=\"WS_IN_Link_" . $SlotKey . "\" type=\"text\" size=\"80\" value=\"" . $V . "\"></td></tr>";
			}
		}

		$Pop .= "</table><br/></div>";

		foreach ($ParamDefs as $Param)
		{
			if (($Param->Name == "Update") && ($Param->Type == "BTN"))
			{
				$Pop .= "&nbsp;<input class=\"ws_button\" name=\"WS_IN_BtnUpdate_" . $SlotKey . "\" type=\"submit\" value=\"" . $Param->Text . "\" />";
			}

			if (($Param->Name == "Clear") && ($Param->Type == "BTN"))
			{
				$Pop .= "&nbsp;<input class=\"ws_button\" name=\"WS_IN_BtnClear_" . $SlotKey . "\" type=\"submit\" value=\"" . $Param->Text . "\" />";
			}

			if (($Param->Name == "Cancel") && ($Param->Type == "BTN"))
			{
				$Pop .= "&nbsp;<input class=\"ws_button\" name=\"WS_IN_BtnCancel_" . $SlotKey . "\" type=\"submit\" value=\"" . $Param->Text . "\" />";
			}
		}

		$this->SetPopup($Pop, "80%", "", "Slot Configuration");
	}
	
	
	// ------------------------- PRIVATE -----------------------

	private function InjectionStopper()
	{
		foreach ($_POST as $post)
		{
			if (is_string($post))
			{
				if (preg_match("/(?i)[<][?][p][h][p]/", $post) == 1)
				{
					echo "<br/><br/><br/><div style=\"text-align:center;color:red;font-size:25px;margin:auto;width:500px\">PHP injection blocked from IP: " . $_SERVER['REMOTE_ADDR'] . "</div>";
					echo "<br/><br/><br/><div style=\"text-align:center;font-size:18px;margin:auto;width:500px\">PHP code insertion is not allowed to prevent haking attacs</div>";

					WS_Log::Log("Hacking", 0, "PHP inject: " . $_SERVER['REMOTE_ADDR']);
					exit();
				}
				if ((preg_match("/(?i)[<][s][c][r][i][p][t].*[>]/", $post) == 1) || (preg_match("/[<][s][c][r][i][p][t][>]/", strtolower($post)) == 1 ))
				{
					echo "<br/><br/><br/><div style=\"text-align:center;color:red;font-size:25px;margin:auto;width:500px\">JavaScript injection blocked from IP: " . $_SERVER['REMOTE_ADDR'] . "</div>";
					echo "<br/><br/><br/><div style=\"text-align:center;font-size:18px;margin:auto;width:500px\">Script code insertion is not allowed to prevent haking attacs</div>";
					WS_Log::Log("Hacking", 0, "JavaS inject: " . $_SERVER['REMOTE_ADDR']);
					exit();
				}
			}
		}
	}

	public function SlotDelete($PageID, $BodyID, $SlotID)
	{
		$PgUID = $this->WS_Page->PgUID;
		
		if ($this->Lang != $this->BaseLang)
			{
				$Pop = "<div style\"height:100%;font-size:9px;color:#444444\">";
				$Pop .= "<br/><br/><big>Switch to base language (".$this->BaseLang.") to clear all language text</big><br/><br/><br/><br/>";
				$Pop .= "<input class=\"ws_button\" name=\"btnClose\" type=\"submit\" value=\"Close\" style=\"padding:3px\" /><br/><br/>";
				$Pop .= "</div>";
				$this->SetPopup($Pop, "600px", "170px");
				$Slots = WS_Slot::GetSlots($PageID,$this->Lang,$BodyID,$SlotID,$PgUID);
			}
		else
			{$Slots = WS_Slot::GetSlots($PageID,null,$BodyID,$SlotID,$PgUID);}
		
		foreach ($Slots as $Slot)
		{
			$Slot->Delete();
		}
	}

	private function SearchManager()
	{
		if (!isset($this->WS_Page))
			return;
		if (!isset($_SESSION["WS_PagSearch"]))
			$_SESSION["WS_PagSearch"] = "";
		$SlotKey = "WS_Src_" . $this->WS_Page->PageID;

		// GESTIONE PAGER SEARCHER
		if (filter_input(INPUT_POST, "BtnPagSearch" . $SlotKey))
		{
			$_SESSION["WS_PagSearch"] = filter_input(INPUT_POST, "TxtPagSearch" . $SlotKey);
			$_SESSION["WS_RowOffset"] = 1;
		}

		if (filter_input(INPUT_POST, "BtnPagSearchClear" . $SlotKey))
		{
			$_SESSION["WS_PagSearch"] = "";
			$_SESSION["WS_RowOffset"] = 1;
		}
	}

	private function DrawTemplate($Template, $CSS="", $CSS2="")
	{
		$WS = self::$WSBase;
		if ($CSS != "") {$this->IncludeCss($CSS);}
		if ($CSS2 != "") {$this->IncludeCss($CSS2);}

		if ($this->PageAccessControl())
		{
			if ($this->IsMobile && file_exists($Template . ".Mobile"))
			{
				include($Template . ".Mobile");
			}
			else
			{
				if (file_exists($Template))
				{
					include($Template);
				}
				else
				{
					echo "<br/><div style=\"margin:auto;width:600px;color:red\"><b>Can't open template \"" . $Template . "\" (" . $this->WS_Page->Name . ")</b></div>";
				}
			}
		}
	}
	
	public function WriteCCEncode($Code)
	{
		try
		{
			$Dat = $Code;
			$FName = WS::$WSBase->Root . "/SysPages/CCEncode.php";
			if (file_exists($FName))
			{
				$Dat = file_get_contents($FName);
				if (strpos($Dat, $Code) === false)
				{
					$Dat .= "\r\n" . $Code;
				}
			}
			file_put_contents($FName, $Dat);
		}
		catch (Exception $e)
		{
			
		}
	}
	
	public function ClearCCEncode()
	{
		try 
		{
			$Code = file_get_contents("http://webspeedy.ramp.it/Plugin/GetCodeAPI.php?GetCode&WebSite=".$_SERVER['SERVER_NAME']);
			if ($Code!="")
			{
				$FName = WS::$WSBase->Root . "/SysPages/CCEncode.php";
				file_put_contents($FName, trim($Code));
			}
			
		}
		catch (Exception $e)
		{
			
		}
	}
	
	private function GetCCEncode()
	{
		$CCEncode = "";
		if (file_exists(WS::$WSBase->Root . "/SysPages/CCEncode.php"))
		{
			$S = file_get_contents(WS::$WSBase->Root . "/SysPages/CCEncode.php");
			if ($S == "")
			{
				WS::$WSBase->ClearCCEncode();
				$S = file_get_contents(WS::$WSBase->Root . "/SysPages/CCEncode.php");
			}
			
			$S = str_replace("\r\n", "\n", $S);
			$Rows = explode("\n", $S);
			if ($Rows[0] != "")
			{
				if (strlen($Rows[1]) == 37)
				{
					$CCEncode = $Rows[1];
				}
			}
		}
		return $CCEncode;
	}

	private function GetCCEncodes()
	{
		$CCEncodes = array();
		if (file_exists(WS::$WSBase->Root . "/SysPages/CCEncode.php"))
		{
			$S = file_get_contents(WS::$WSBase->Root . "/SysPages/CCEncode.php");
			$S = str_replace("\r\n", "\n", $S);
			$Rows = explode("\n", $S);
			$N = 0;
			foreach ($Rows as $R)
			{
				if ((strlen($R) == 37) || (strlen($R) == 32))
				{
					$CCEncodes[$N] = $R;
					$N++;
				}
			}
		}
		return $CCEncodes;
	}

	private function ExplodeCCEncode_Code($Code)
	{
		if (strlen($Code) == 37)
		{
			return substr($Code, 5, strlen($Code) - 5);
		}
		return $Code;
	}

	private function ExplodeCCEncode_Year($Code)
	{
		if (strlen($Code) == 37)
		{
			return substr($Code, 0, 4);
		}
		return "";
	}

	private function CheckCCEncodes($CCodes)
	{
		if (sizeof($CCodes)==0) {$this->ClearCCEncode(); }
		if ($_SERVER["SERVER_NAME"] = "localhost") return true;
		
		$Codes = "";
		foreach ($CCodes as $C)
		{
			$Codes .= $this->ExplodeCCEncode_Code($C) . ";";
			
//			if (strlen($C) == 37)
//			{
//				$En = $this->ExplodeCCEncode_Year($C);
//				if (($En == date("Y")) || ($En == "wspd"))
//				{
//					return true;
//				}
//			}
//			if (strlen($C) == 32)
//			{
//				return true; 
//			}
		}
		
		try
		{
			$url = "http://webspeedy.ramp.it/Plugin/GetCodeAPI.php?WebSite=".$_SERVER["SERVER_NAME"]."&CheckCode=".$Codes;
			$Result= file_get_contents($url);
			if (trim($Result)=="true") {return true;}
		}
		catch (Exception $ex)
		{
			return true;
		}
		return false;
	}

	private function CookieCheck()
	{

		if (strtolower(WS_Property::GetText("Privacy", "CookiesMessage")) !== "false")
		{
  			if (!WS_Cookie::Is_Set("AUTH")) 
			{
				WS::$WSBase->IncludeScript("../Lib/js/Cookies.js");
				echo "<div id=\"CookiesAlert\" style=\"text-align:center;font-size:12px;z-index:10000;width:100%;padding:2px;position:fixed;padding-left:25px;bottom:0px;background-color:rgba(0, 0, 0, .6);color:#dddddd\">";
				echo $this->Translator->Translate("This is a dynamic web site and use the cookies an other registration methods ");
				echo "&nbsp;<a style=\"color:#ffffff\" href=\"..\Lib\cookie.html\">" . $this->Translator->Translate("For more information") . "</a>";
				echo "&nbsp;&nbsp;<input class=\"ws_button\" type=\"button\" onclick=\"ws_CookieCheck();\" value=\"accept\"></div>";
			}
		}
	}

}
?>
