<?php
//  Webspeedy CMS LIB LIGHT BASE
//  Writen By Cristiano Rampoldi 
// (www.ramp.it -- webspeedy.dynu.com -- cristiano.rampoldi@gmail.com)
//  All right reserved
//  See WS.php for more 

include '../Lib/SessionCode.php';
include '../Lib/ConnectDB.php';
include '../Lib/ConnectQPager.php';
include '../Lib/WS_Translator.php';
include '../Lib/WS_Log.php';


try
{
	$WS = new WS();
}
catch(Exception $Ex)
{
	echo $Ex->getMessage();
}

class WS
{
	private $Ver;
	private $CCEncode;
	private $ActPopup;
	private $TextAreaScript = false;
	private $PayScript = "";
	private $PopupCode = "";
	private $PopupWidth = "";
	private $PopupHeight = "";
	private $PopupTitle = "";
	private $PopupHeaderClass = "";
	private $PopupBodyClass = "";
	private $PopupTop = "50px";
	private $Timer = 250;
	private $MapLatitude=0;
	private $MapLongitude=0;
	
	public $ScriptList = array();
	public $CssList= array();
	
	public static $WSBase;
	public $HomeSite;
	public $Host;
	public $Root;
	public $WS_Page;
	public $WSDB;
	public $Translator;
	public $Lang;
	public $Langs;
	public $ActLangs;
	public $BaseLang="en";
	public $IsMobile=false;
        public $IsInFrame=false;
	
	public function __construct()
	{
		WS::$WSBase = $this;
		WS::$WSBase->Init();
	}
	

	//-----------------------------------------
	//------------ PUBLIC FUNCTION ----------
	//-----------------------------------------
	
	public function IncludeCss($Css)
	{
                if (! in_array($Css,  $this->CssList)) 
                {
                        array_push($this->CssList,$Css);
                        echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"".$Css."\">";
                }
	}
        
	public function IncludeFile($File)
	{
		if (file_exists($File))
		{
			$WS = self::$WSBase;
			include ($File);
		}
		else
		{
			echo "<br/>Error:<br/><br/>WS->PlugFile: File not found (".$File.")\n";
		}
	}

	public function GetRootRelativePath()
	{
		$Path = $_SERVER['DOCUMENT_ROOT'];
		$Ps = explode("/", $_SERVER['PHP_SELF']);
		
		$Pos=0;
		while(!file_exists($Path."/SysPages"))
		{
			$Pos++;
			if ($Ps[$Pos]!="")
				{$Path.="/".$Ps[$Pos];}
		}	
		return $Path;
		
//		$Ret = $Path;
//		$P = strpos("Pages/", $Path);
//		if ($P>0) {$Path=substr($Path,"Pages/");}
//		return WS::$WSBase->Root."/".$Path;
	}
	
	public function GetTranslation($Text,$FromLang="",$ToLang="",$Chacheing=true)
	{
		return $this->Translator->Translate($Text,$FromLang,$ToLang,$Chacheing);
	}
	
	public function Translate($Text)
	{
		echo $this->Translator->Translate($Text);
	}
	
	public function DrawComboBox($Sql,$Attributes,$Value="",$FirstRow="")
	{
		$Result=$this->WSDB->query($Sql);
		if ($FirstRow=="") {echo "<select ".$Attributes.">";}
		
		echo $FirstRow;
		for ($M=0;$M<$Result->num_rows;$M++)
		{
			$Row = $Result->fetch_assoc();
			$V = array_values($Row);
			if($Value==$V[0])
			{
				echo "<option selected value=\"".$V[0]."\">".$V[1]."</option>";
			}
			else
			{
				echo "<option value=\"".$V[0]."\">".$V[1]."</option>";
			}
		}
		echo "</select>";
	}
	
	public function SetPageCss()
	{
		if(isset($this->WS_Page))
		{
			//echo "<link href=\"../Styles/" . $this->WS_Page->Css . "\" rel=\"stylesheet\" type=\"text/css\"/>";
			echo "<link href=\"../Styles/MenuBar/" . $this->WS_Page->MenuBarCss . "\" rel=\"stylesheet\" type=\"text/css\"/>";
		}
		else
		{
			$Pag = WS_Page::GetStartPage();
			echo "<link href=\"../Styles/".$Pag->Css."\" rel=\"stylesheet\" type=\"text/css\"/>";
			echo "<link href=\"../Styles/MenuBar/".$Pag->MenuBarCss."\" rel=\"stylesheet\" type=\"text/css\"/>";
		}
	}
	
	
	//-----------------------------------------
	//------------ PRIVATE FUNCTION ----------
	//-----------------------------------------
	
	private function Init()
	{
		global $WSDB;
		try
		{
			// INIT SESSION VARS
			$this->HomeSite="http://webspeedy.dynu.com";
			$this->Host=$_SERVER["HTTP_HOST"];
			
			// GET WEB SITE ROOT
			$this->Root=getcwd();

			// MOBILE DETECT
//			if (isset($_SERVER['HTTP_USER_AGENT']))
//			{
//				$useragent=$_SERVER['HTTP_USER_AGENT'];
//				if(preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i',$useragent)||preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i',substr($useragent,0,4))){$this->IsMobile = true;}
//			}
			
			// FRAME DETECT
			if (isset($_SERVER['HTTP_REFERER'])) $this->IsInFrame = true;
                        
			$this->Ver= date("Y");
			$this->WSDB=$WSDB;

			// USER PROTECTION
			if (!isset($_SESSION['LOGIN_SITE_ID']))
			{
				$_SESSION['NEED_LOGIN'] = false;
				$_SESSION['PERMISIONS'] = "";
				$_SESSION['USER_ID'] = "";
				$_SESSION['USER_NAME'] = "";
				$_SESSION['LOGIN_SITE_ID'] = 0;
			}

			if (!isset($_SESSION["PERMISIONS"])) {$_SESSION["PERMISIONS"] = "";}
			if ($_SESSION["PERMISIONS"]=="")
			{
				$_SESSION["PERMISIONS"] = "guest";
			}

			if (!isset($_SESSION["SLOTS_EDIT_MODE"])) {$_SESSION["SLOTS_EDIT_MODE"]=false;}
			
			// LIST OF SUPPORTED LANGS
			$this->GetLang();
			$this->GetLangArray();
			$_SESSION["LANGS"]=implode(",",$this->Langs);
			
			if (isset($_POST["WS_SlotsEditMode"])) {$_SESSION["SLOTS_EDIT_MODE"]=true;}
			if (isset($_POST["WS_SlotsViewMode"])) {$_SESSION["SLOTS_EDIT_MODE"]=false;}
			if (!isset($_SESSION["WS_RowOffset"])) {$_SESSION["WS_RowOffset"] = 1;}
			if (!isset($_SESSION["WS_RET_PAG"])) {$_SESSION["WS_RET_PAG"] = "";}

			if ((($_SESSION['LOGIN_SITE_ID'] != $_SESSION['SITE_ID']) && ($_SESSION['USER_ID'] != "")))
			{
				$_SESSION['USER_ID'] = "";
				$_SESSION['USER_NAME'] = "";
				$_SESSION['PERMISIONS'] = "guest";
				$_SESSION['LOGIN_SITE_ID'] = 0;
			}
			if ($_SESSION['USER_ID'] == "")
				{$_SESSION["SLOTS_EDIT_MODE"] = false;}
			
			// LOAD LANGUAGES
			$this->Translator=WS_Translator::Init($this->GetRootRelativePath()."/SysPages/Dictionary.txt");
			$this->Lang = $_SESSION["LANG"];
		}
		catch(Exception $Ex)
		{
			echo $Ex->getMessage();
		}
	}
	
	private function GetLangArray()
	{
		$this->Langs = array("en","it","es","fr","de");
		if ($this->Lang == "en") {$this->Langs = array("en","de","it","es","fr");}
		if ($this->Lang == "de") {$this->Langs = array("de","en","fr","es","it");}
		if ($this->Lang == "it") {$this->Langs = array("it","en","es","fr","de");}
		if ($this->Lang == "es") {$this->Langs = array("es","en","it","fr","de");}
		if ($this->Lang == "fr") {$this->Langs = array("fr","en","it","es","de");}
		return $this->Langs;
	}
	
	private function GetActiveLangs()
	{
		if (!isset($this->ActLangs))
		{
			if ($_SESSION['SLOTS_EDIT_MODE'])
			{
				$this->ActLangs=explode(",",$_SESSION['LANGS']);
			}
			else
			{
				$Langs = "en,it,es,de,fr";
				$_SESSION['LANGS']=$Langs;
				$this->ActLangs=explode(",",$Langs);
			}
		}
		return $this->ActLangs;
	}
	
	private function ClearLang()
	{
		$this->Lang=null;
		$_SESSION["LANG"]=null;
	}
	
	private function GetLang()
	{
		if (!isset($this->Lang))
		{
			if (!isset($_SESSION["LANG"]) || ($_SESSION["LANG"]==""))
			{
				$_SESSION["LANG"]="";
				if (!isset($this->ActLangs)) {$this->GetActiveLangs();}
				if (!isset($this->Lang)) {$this->Lang = $this->BaseLang;}
				$BrowserLang = "en";
				if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {$BrowserLang = strtolower(substr($_SERVER['HTTP_ACCEPT_LANGUAGE'],0,2));}
				if (in_array($BrowserLang,$this->ActLangs)) {$this->Lang=$BrowserLang;}
				$_SESSION["LANG"]=$this->Lang;
			}
			else
			{
				$this->Lang=$_SESSION["LANG"];
			}
		}
		return $this->Lang;
	}
	
	// --------------------- STATIC ----------------------

        public function TableExists($Table)
        {
                $Exist=true;
                if ($result = WS::$WSBase->WSDB->query("SHOW TABLES LIKE '".$Table."'")) 
                {
                    if($result->num_rows == 1) 
                    {
                        return true;
                    }
                }
                return false;
        }
        
	public static function GetMediaNames($WS_Page=null)
	{		
		if ($WS_Page == null)
			{$myDirectory = opendir(WS::$WSBase->Root."/Media");}
		else
		{
			if (!file_exists(WS::$WSBase->Root."/Media/".$WS_Page->Name)) {return array();}
			$myDirectory = opendir(WS::$WSBase->Root."/Media/".$WS_Page->Name);
		}
		
		$dirArray=array();
		while($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				$dirArray[] = $entryName;
			}
		}
		
		closedir($myDirectory);
		
		if (isset($dirArray))
		{
			sort($dirArray);
			return $dirArray;
		}
		else
		{
			return array();
		}
	}
	
	public static function GetMastersNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root."/Templates");
		while($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName,'.Master') && (!strpos($entryName,'.css')))
				{
					$dirArray[] = str_replace('.Master', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);
		
		return $dirArray;
	}
	
	public static function GetTemplatesNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root."/Templates");
		while($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
			if (strpos($entryName,'.Template') && (!strpos($entryName,'.css')))
				{
					$dirArray[] = str_replace('.Template', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);
		
		return $dirArray;
	}	 
	
        public static function GetSubTemplatesNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root."/Templates/Sub");
		while($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
			if (strpos($entryName,'.Template') && (!strpos($entryName,'.css')))
				{
					$dirArray[] = str_replace('.Template', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);
		
		return $dirArray;
	}
        
	public static function GetPluginsNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root."/Plugin");
		while($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName,'.plugin.php') !== false)
				{
					$dirArray[] = str_replace('.plugin.php', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);
		
		return $dirArray;
	}
	
	public static function GetCssNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root."/Styles");
		while($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName,'.css'))
				{
					$dirArray[] = str_replace('.css', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);
		
		return $dirArray;
	}
	
	public static function GetMenuBarCssNames()
	{
		$myDirectory = opendir(WS::$WSBase->Root."/Styles/MenuBar");
		while($entryName = readdir($myDirectory))
		{
			if (!is_dir($entryName))
			{
				if (strpos($entryName,'.css'))
				{
					$dirArray[] = str_replace('.css', '', $entryName);
				}
			}
		}
		sort($dirArray);
		closedir($myDirectory);
		
		return $dirArray;
	}
	
	public static function GetUser($UserID)
	{
		return WS_User::GetUserByID($UserID);
	}
	
	public static function getServerURL()
	{
		$url = ($_SERVER["HTTPS"] == "on")?"https://":"http://";
		$url .= $_SERVER["SERVER_NAME"]; // variável do servidor, $_SERVER["HTTP_HOST"] é equivalente
		if ($_SERVER["SERVER_PORT"] != "80" && $_SERVER["SERVER_PORT"] != "443") $url .= ":".$_SERVER["SERVER_PORT"];
		return $url;
	}
	
	public static function getCompleteURL()
	{
		return getServerURL().$_SERVER["REQUEST_URI"];
	}
	
	public static function BuildSelectList($List, $Name, $value)
	{
		$Ret = "<select name=\"" . $Name . "\">";
		for ($N = 0; $N < count($List); $N++)
		{
			$Ret .= "<option ";
			if ($List[$N] == $value)
				$Ret .= " selected ";
			$Ret .= "value=\"" . $List[$N] . "\">" . $List[$N];
			$Ret .= "</option>";
		}
		return $Ret . "</select>";
	}
	
	public static function BuildNullableSelectList($List, $Name, $value)
	{
		$Ret = "<select name=\"" . $Name . "\">";
			$Ret .= "<option ";
			if ("" == $value)
				$Ret .= " selected ";
			$Ret .= "value=\"\">";
			$Ret .= "</option>";
		for ($N = 0; $N < count($List); $N++)
		{
			$Ret .= "<option ";
			if ($List[$N] == $value)
				$Ret .= " selected ";
			$Ret .= "value=\"" . $List[$N] . "\">" . $List[$N];
			$Ret .= "</option>";
		}
		return $Ret . "</select>";
	}
	
	public static function GetLangByPriority()
	{
		if ($_SESSION["LANG"]=="en")
			{$Ret=array('en','de','es','fr','it');}
		if ($_SESSION["LANG"]=="it")
			{$Ret=array('it','en','es','fr','de');}
		if ($_SESSION["LANG"]=="es")
			{$Ret=array('es','en','it','fr','de');}
		if ($_SESSION["LANG"]=="fr")
			{$Ret=array('fr','en','it','es','de');}
		if ($_SESSION["LANG"]=="de")
			{$Ret=array('de','en','fr','it','es');}
		
		return $Ret;
	}
	
	public static function FilePutContents($File, $Data)
	{
		if (file_exists($File))
		{
			file_put_contents($File,$Data);
		}
		else
		{
			file_put_contents($File,$Data);
			WS::FileSetPermisions($File);
		}
	}
	
	public static function FileSetPermisions($File,$Perms="")
	{
		//$Own = fileowner(WS::$WSBase->Root."/Media/WS.php");
		//$Grp = filegroup(WS::$WSBase->Root."/Media/WS.php");
        if  ($Perms == "") {$Perms = fileperms(WS::$WSBase->Root."/Media");}
		
		try
		{
             chmod($File,$Perms);
			//chown($File,$Own);
			//chgrp($File,$Grp);
		}
		catch(Exception $e){}
	}
	
	public static function GenerateAuthCode($Str="") 
	{
		$L=strlen($Str);
		if (($L<5)||($L>20)) {$Str=WS::RandomString();$L=10;}
		return $Str.substr(md5($Str),5,$L);
	}
	
	public static function CheckAuthCode($Code) 
	{
		$L=strlen($Code)/2;
		$Str = substr($Code,0,$L);
		$Cod = substr($Code,$L,$L);
		if (substr(md5($Str),5,$L)==$Cod)
			{return true;}
		else
			{return false;}
	}
	
	public static function RandomString($length = 10) 
	{
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$charactersLength = strlen($characters);
		$randomString = '';
		for ($i = 0; $i < $length; $i++) 
			{$randomString .= $characters[rand(0, $charactersLength - 1)];}
		return $randomString;
	}
	
	// ------------------------- PRIVATE -----------------------
	
	private function GetHeaderSlotKey($SlotID)
	{
		return "0_".$SlotID."_".$this->WS_Page->PgUID."_0";
	}
	
	private function GetSlotKey($SlotID,$RowOffset=0)
	{
		return $this->WS_Page->PageID."_".$SlotID ."_".$this->WS_Page->PgUID."_".($_SESSION["WS_RowOffset"] + $RowOffset);
	}
}

class WS_Property
{
	private $WSDB;
	public $Group = "";
	public $Name = "";
	public $Text = "";
	public $Num = 0;
	
	public function __construct($DB=null)
	{
		if (isset($DB))
			{$this->WSDB=$DB;}
		else
			{$this->WSDB=WS::$WSBase->WSDB;}
	}

	public function Update()
	{
		try
		{
			$Prop=WS_Property::Get($this->Group,$this->Name);
			if($this->Num==null){$this->Num=0;}
			if (!isset($Prop))
					{$SQL="INSERT INTO ws_properties(SiteID,Grp,Name,Text,Num) VALUES (".$_SESSION["SITE_ID"].",'" . $this->Group . "','" . $this->Name . "','" . $this->Text . "','" . $this->Num . "')";}
			else
					{$SQL="UPDATE ws_properties SET Text='".$this->Text."',Num=".$this->Num." where SiteID=".$_SESSION["SITE_ID"]." and Grp='" . $this->Group . "' and Name='" . $this->Name . "'";}

			$this->WSDB->query($SQL);
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Delete()
	{
		try
		{
			$SQL="DELETE FROM ws_properties where SiteID=".$_SESSION["SITE_ID"]." and Grp='" . $this->Group . "' and Name='" . $this->Name . "'";
			$this->WSDB->query($SQL);
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Load($Group,$Name)
	{
		try
		{
			$SQL="select * from ws_properties where SiteID=".$_SESSION["SITE_ID"]." and Grp='" . $Group . "' and Name='" . $Name . "'";
			$Res = $this->WSDB->query($SQL);
			if($Res->num_rows != 0)
			{
				$Row = $Res->fetch_assoc();
				$this->Group = $Row["Grp"];
				$this->Name = $Row["Name"];
				$this->Text = $Row["Text"];
				$this->Num = $Row["Num"];
			}
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function Get($Group,$Name,$DB=null)
	{
		$P=new WS_Property($DB);
		$P->Load($Group,$Name);
		if ($P->Group=="") {return null;}
		return $P;
	}
	
	public static function GetText($Group,$Name,$DB=null)
	{
		$P=WS_Property::Get($Group,$Name,$DB);
		if ($P==null) {return null;}
		return $P->Text;
	}
	
	public static function GetNum($Group,$Name,$DB=null)
	{
		$P=WS_Property::Get($Group,$Name,$DB);
		if ($P==null) {return null;}
		return $P->Num;
	}
	
	public static function SetText($Group,$Name,$Text,$DB=null)
	{
		$Prop=WS_Property::Get($Group,$Name);
		if (!isset($Prop))
		{
			$Prop=new WS_Property($DB);
			$Prop->Name=$Name;
			$Prop->Group=$Group;
		}
		$Prop->Text=$Text;
		$Prop->Update();
	}
	
	public static function SetNum($Group,$Name,$Num,$DB=null)
	{
		$Prop=WS_Property::Get($Group,$Name);
		if (!isset($Prop))
		{
			$Prop=new WS_Property($DB);
			$Prop->Name=$Name;
			$Prop->Group=$Group;
		}
		$Prop->Num=$Num;
		$Prop->Update();
	}
	
	public static function GetAll($DB=null)
	{
		try
		{
			if (!isset($DB))
				{$DB=WS::$WSBase->WSDB;}

			$Props = array();
			$SQL="select Grp,Name,Num,Text from ws_properties order by Grp,Name";
			$Res = $DB->query($SQL);
			for ($R=0;$R<$Res->num_rows;$R++)
			{
				$Row = $Res->fetch_assoc();
				$P = new WS_Property($DB);
				$P->Group = $Row["Grp"];
				$P->Name = $Row["Name"];
				$P->Text = $Row["Text"];
				$P->Num = $Row["Num"];
				array_push($Props,$P);
			}
			return $Props;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
}
?>