<?php

class WS_Updater
{
	private $VersionsList = array("2.000","2.001","2.002","2.003","2.004","2.005","2.006","2.007","2.008","2.009","2.010","2.011","2.012","2.013","3.000","3.001","3.002","3.003");
	private $WSDB;
	
	public function __construct()
	{
		// READ DB VERSION
		$this->WSDB=WS::$WSBase->WSDB;
		$Res = null;
		try
		{
			$SQL="select * from ws_properties where SiteID=".$_SESSION["SITE_ID"]." and Grp='Version' and Name='Version'";
			$Res = $this->WSDB->query($SQL);
		}
		catch(Exception $ex)
		{}
		
		if (!$Res)
		{
			try
			{
				$SQL="select * from properties where SiteID=".$_SESSION["SITE_ID"]." and Grp='Version' and Name='Version'";
				$Res = $this->WSDB->query($SQL);
			} 
			catch (Exception $e)
			{}
		}
		
		if($Res->num_rows != 0)
		{
			$Row = $Res->fetch_assoc();
			$DbVers = $Row["Text"];
		}
		
		if (!isset($DbVers)){$DbVers="1.000";}
		
		$Res=true;
		foreach($this->VersionsList as $Ver)
		{
			// CONVERT VERSION TO NUMBER
			$DbV = intval(str_replace(".", "", $DbVers));
			$VV = intval(str_replace(".", "", $Ver));
			
			if ($DbV < $VV)
			{
				if (!$this->ExecSqlFile($this->WSDB,WS::$WSBase->Root."/Lib/SQL/Upd_".$VV.".sql"))
				{
					$Res=false;
				}
			}
			
			// REPAIR TEMPLATES AND PLUGIN
			if (($Ver=="2.005")&&($DbVers<"2.005"))
			{
				$myDirectory = opendir(WS::$WSBase->Root."/Templates");
				while($File = readdir($myDirectory))
				{
					if ((!is_dir($File)) && (strpos(".css",$File) === false) && ($File != "Sub"))
					{
						$Dat = file_get_contents(WS::$WSBase->Root."/Templates/".$File);
						$Dat=$this->ReplaceSlotCall($Dat);
						file_put_contents(WS::$WSBase->Root."/Templates/".$File,$Dat);
					}
				}
				$myDirectory = opendir(WS::$WSBase->Root."/Plugin");
				while($File = readdir($myDirectory))
				{
					if ((strpos(".Template",$File) !== false) && (strpos(".Master",$File) !== false) && (strpos(".css",$File) === false) )
					{
						try
						{
							$Dat = file_get_contents(WS::$WSBase->Root."/Plugin/".$File);
							$Dat=$this->ReplaceSlotCall($Dat);
							file_put_contents(WS::$WSBase->Root."/Plugin/".$File,$Dat);
						}
						catch (Exception $ex)
						{
						}
					}
				}
			}
			
			if (($Ver=="2.010")&&($DbVers<"2.010"))
			{
				$this->PatchFolder();
				$Res=true;
			}
		}
		
		if ($Res)
		{
			WS_Property::SetText("Version", "Version", $Ver, $this->WSDB);
			$DbVers = $Ver;
		}
	}
	
	function PatchFolder()
	{
        if (!file_exists(WS::$WSBase->Root."/Templates/Sub"))
        {
			mkdir(WS::$WSBase->Root."/Templates/Sub");
			$myDirectory = opendir(WS::$WSBase->Root."/Templates");
			while($entryName = readdir($myDirectory))
			{
				if ((!is_dir($entryName)) && (strpos("..",$entryName) === false))
				{
					if (strpos($entryName,"Sub_") !== false)
					{
							$TemplOrigin = WS::$WSBase->Root."/Templates/" . basename($entryName);
							$TemplDest = WS::$WSBase->Root."/Templates/Sub/". str_replace("Sub_", "",basename($entryName));
							copy($TemplOrigin,$TemplDest);
							unlink($TemplOrigin);
					}
				}
			}
		        
			$Slots = WS_Slot::GetSlots(null);
			foreach ($Slots as $Slot)
			{
				if ($Slot->ContType == "TEM")
				{
					if (strpos($Slot->Param[0],"Sub_")!== false)
					{
						$Slot->Param[0] =str_replace( "Sub_","Sub/",$Slot->Param[0]);
						$Slot->Update();
					}
				}
			}
                
		}
	}
	
	private function ExecSqlFile($DB,$File)
	{
		if (!file_exists($File)) {return;}
		$f = fopen($File, "r+");
		$sqlFile = fread($f, filesize($File));
		fclose($f);
		$sqlArray = explode(';', $sqlFile);
		foreach ($sqlArray as $stmt)
		{
			if (strlen(trim($stmt))>3 && substr(ltrim($stmt), 0, 2) != '/*')
			{
				try
				{
					$result = $this->WSDB->query($stmt);
				} 
				catch (Exception $e)
				{
					echo 'ERROR: ', $e->getMessage(), "\n";
				}
			}
		}
		return true;
	}
	
	private function ReplaceSlotCall($Dat)
	{
		$Dat=str_replace("->MenuBar("                ,"->Slot_MenuBar("            ,$Dat);
		$Dat=str_replace("->ImageTitle("             ,"->Slot_ImageTitle("         ,$Dat);
		$Dat=str_replace("->TextTitle("              ,"->Slot_TextTitle("          ,$Dat);
		$Dat=str_replace("->TableSlot("              ,"->Slot_Table("              ,$Dat);
		$Dat=str_replace("->ImageSlot("              ,"->Slot_Image("              ,$Dat);
		$Dat=str_replace("->YouTubeSlot("            ,"->Slot_YouTube("            ,$Dat);
		$Dat=str_replace("->TextSlot("               ,"->Slot_Text("               ,$Dat);
		$Dat=str_replace("->TextExpandibleSlot("     ,"->Slot_TextExpandible("     ,$Dat);
		$Dat=str_replace("->InputSlot("              ,"->Slot_Input("              ,$Dat);
		$Dat=str_replace("->InputAreaSlot("          ,"->Slot_InputArea("          ,$Dat);
		$Dat=str_replace("->SaverDbSlot("            ,"->Slot_SaverDb("            ,$Dat);
		$Dat=str_replace("->SaverEmailSlot("         ,"->Slot_SaverEmail("         ,$Dat);
		$Dat=str_replace("->PluginSlot("             ,"->Slot_Plugin("             ,$Dat);
		$Dat=str_replace("->SubTemplateSlot("        ,"->Slot_SubTemplate("        ,$Dat);
		$Dat=str_replace("->PayPalSlot("             ,"->Slot_PayPal("             ,$Dat);
		$Dat=str_replace("->ImageSliderSlot("        ,"->Slot_ImageSlider("        ,$Dat);
		$Dat=str_replace("->TextSliderSlot("         ,"->Slot_TextSlider("         ,$Dat);
		$Dat=str_replace("->MapSlot("                ,"->Slot_Map("                ,$Dat);
		$Dat=str_replace("->BackgroundSetSlotButton(","->Slot_BackgroundSetButton(",$Dat);
		$Dat=str_replace("->BackgroundSlot("         ,"->Slot_BackgroundSet("      ,$Dat);
		$Dat=str_replace("->Pager("                  ,"->Slot_Pager("              ,$Dat);
		$Dat=str_replace("->PagerSearch("            ,"->Slot_PagerSearch("        ,$Dat);
		$Dat=str_replace("->SlotIsSet("              ,"->Slot_IsSet("              ,$Dat);
		$Dat=str_replace("->MasterTemplateSlot("     ,"->Slot_MasterTemplate("     ,$Dat);
		$Dat=str_replace("->PreHeaderTemplateSlot("  ,"->Slot_PreHeaderTemplate("  ,$Dat);
		$Dat=str_replace("->BodyTempaleSlot("        ,"->Slot_BodyTempale("        ,$Dat);
		$Dat=str_replace("->FooterTemplateSlot("     ,"->Slot_FooterTemplate("     ,$Dat);
		$Dat=str_replace("->PlugFile("               ,"->Slot_PlugFile("           ,$Dat);
		return $Dat;
	}
}

class WS_Searcher
{
	private $unwanted_array;
	public $Results;
	
	public function __construct()
	{
		$this->unwanted_array = array( 
		','=>' ',';'=>' ',':'=>' ','.'=>' ','-'=>' ','+'=>' ','?'=>' ',
		'\''=>' ','^'=>' ','='=>' ','/'=>' ','!'=>' ','\\'=>' ','|'=>' ',
		'<'=>' ','>'=>' ','>'=>'\"','*'=>' ','['=>' ',']'=>' ','('=>' ' ,
		')'=>' ','"'=>' ','\n'=>' ','\r'=>' ','\t'=>' ');
	}
	
	public function GetSearchKeyWords($SearchStr)
	{
		$Text=$SearchStr;
		foreach($this->unwanted_array as $K => $V)
			{$Text = str_replace($K, $V, $Text);}
		
		while (strpos($Text,"  ")!==false)
		{
			$Text = str_replace("  ", " ", $Text);
		}
		
		$Words = explode(' ',strtolower($Text));
		
		for($N=0;$N<count($Words);$N++)
		{
			if (strlen($Words[$N])>25)
				{$Words[$N]=substr($Words[$N],0,25);}
				
			if (strlen($Words[$N])<4) 
				{unset($Words[$N]);}
		}
		return $Words;
	}
	
	public function CountKeyWords($Text,$KeyWords)
	{
		$N=0;
		foreach($KeyWords as $KeyWord)
		{
			if (strpos($Text,$KeyWord)!==false) {$N++;}
		}
		return $N;
	}
	
	public function KeyWordsSort($Slots,$KeyWord)
	{
		$SortSlots = array();
		foreach($Slots as $Slot)
		{
			$ID = $Slot->PageID."-".$Slot->SlotID."-".$Slot->Row;
			$SortSlots[$ID]=$Slot;
		}
		
		$Results = array();
		do
		{
			$MaxN=0;
			$BestSlot=null;
			foreach($SortSlots as $Slot)
			{
				$N = $this->CountKeyWords($Slot->Text,$KeyWords);
				if ($N>$MaxN)
				{
					$MaxN=$N;
					$BestSlot=$Slot;
				}
			}

			$ID = $BestSlot->PageID."-".$BestSlot->SlotID."-".$BestSlot->Row;	
			unset($SortSlots[$ID]);
			array_push($Results,$BestSlot);
				
		}
		while (count($Slots)>0);
		
		return $Results;
	}
	
	public function Search($SearchString,$Limit=50)
	{
		try
		{
			$Slots = array();
			if ($SearchString=="") {return $Slots;}

			// SEACH STRING TO KEYWORD ARRAY
			$KeyWords = $this->GetSearchKeyWords($SearchString);
			if(count($KeyWords)==0) return $Slots;

			// CREA LIKE EXPRESION
			$SQL = "SELECT * FROM ws_slots WHERE SiteID=".$_SESSION["SITE_ID"]." and (";
			$SQLK="";
			foreach($KeyWords as $KeyWord)
			{
				if ($SQLK!="") {$SQLK .= " or ";}
				$SQLK.= " text like '%".$KeyWord."%'";

			}
			$SQL.=$SQLK.")";

			// CARICA GLI SLOT TROVATI
			$Result=WS::$WSBase->WSDB->query($SQL);
			$Max = $Result->num_rows;
			if ($Max>$Limit) {$Max=$Limit;}
			for($NR=0;$NR<$Max;$NR++)
			{
				$Row=$Result->fetch_assoc();
				$Slot = WS_Slot::CreateFromDbRow($Row);
				array_push($Slots,$Slot);
			}

			//$Slots = $this->KeyWordsSort($Slots,$KeyWord);

			return $Slots;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
}

class WS_MailNotifier
{
	private $mail;
	private $MailAdmin;
	
	public function __construct()
	{
		$this->MailAdmin=WS_Property::GetText("MailSender","MailAdmin");
		$this->mail = new PHPMailer(true);
		//$mail->SMTPDebug  = 2;
		$this->mail->IsSMTP();
		$this->mail->Host = WS_Property::GetText("MailSender","SmtpHost");
		$this->mail->Port = intval(WS_Property::GetText("MailSender","SmtpPort")); 
		if (WS_Property::GetText("MailSender","SmtpUser")!="")
		{
			$this->mail->SMTPAuth = true;
			$this->mail->Username = WS_Property::GetText("MailSender","SmtpUser");
			$this->mail->Password = WS_Property::GetText("MailSender","SmtpPassword");
		}
		$this->mail->SMTPSecure = WS_Property::GetText("MailSender","SmtpSecure");
		$From=WS_Property::GetText("MailSender","SmtpFrom");
		if (!empty($From))
		{
			$this->mail->AddReplyTo($From);
			$this->mail->SetFrom($From);
		}
	}
	
	public function TranslateTemplate($Template)
	{
		$WS = WS::$WSBase;
		$Ret="";
		$Txt="";
		$Translate=false;
		for ($N=0;$N<strlen($Template);$N++)
		{
			$C = substr($Template,$N,1);
			if ($C=="$")
			{
				if ($Translate)
				{
					// CLOSE AND INSERT TRANSLATION
					$Translate=false;
					$Ret.=$WS->GetTranslation($Txt);
					$Txt="";
				}
				else
				{
					// START TRANSLATION
					$Translate=true;
				}
			}
			else
			{
				if($Translate)
				{
					$Txt.=$C;
				}
				else
				{
					$Ret.=$C;
				}
			}
		}
		return $Ret;
	}
	
	public function BodyFromTemplateFile($TemplateFile,$Params)
	{
		$Body = file_get_contents($TemplateFile);
		$Body = $this->TranslateTemplate($Body);
		foreach ($Params as $Key => $Value)
		{
			$Body = str_replace("@".$Key."@", $Value, $Body);
		}
		return $Body;
	}
	
	public function BodyFromPropertyTemplate($PropGroup,$PropName,$Params)
	{
		$WS = WS::$WSBase;
		$Body = WS_Property::GetText($PropGroup,$PropName);
		$Body = $this->TranslateTemplate($Body);
		foreach ($Params as $Key => $Value)
		{
			$Body = str_replace("@".$Key."@", $Value, $Body);
		}
		return $Body;
	}
	
	public function SendFromPropertyTemplate($To,$Subject,$PropGroup,$PropName,$Params)
	{
		return $this->Send($To,$Subject,$this->BodyFromPropertyTemplate($PropGroup,$PropName,$Params));
	}
	
	public function SendFromTemplateFile($To,$Subject,$TemplateFile,$Params)
	{
		try
		{
			return $this->Send($To,$Subject,$this->BodyFromTemplateFile($TemplateFile,$Params));
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Send($To,$Subject,$Body)
	{
		$Mes="";
		$this->mail->Subject = $Subject;
		$this->mail->isHTML(true);
		$this->mail->Body = $Body;
		$Tos = explode(";",$To);
		foreach ($Tos as $T)
		{
			$this->mail->clearAddresses();
			$this->mail->AddAddress($T);
			try
			{
				$this->mail->Send();
			}
			catch(Exception $ex)
			{
				return $this->mail->ErrorInfo;
			}
		}
		return true;
	}
	
	public function GetMailAdmin()
	{
		return $this->MailAdmin;
	}
}

class WS_Page
{
	private $MAX_BODY=10;
	public $PageID=0;
	public $Name;
	public $Path;
	public $MasterTemplate;
	public $BodyTemplate;
	public $MainPage;
	public $PermisionsR;
	public $PermisionsW;
	public $PermisionsE;
	public $Css;
	public $MenuBarCss;
	public $Title;
	public $Description;
	public $Slots = array();
	public $PgUID=0;
	public $Row = 0;
	public $MaxPagerRows = 1;
	
	public function __construct()
	{
		$this->BodyTemplate = array();
	}
	
	public function GetPgUID()
	{
		return $this->PgUID;
	}
	
	public function GetPageLink()
	{
		return "../Pages/" . $this->Name . ".php";
	}
	
	public function GetPageTitle()
	{
		if (isset($this->Title))
		{
			if ($this->Title != "") 
				{return $this->Title;}
		}
		return $this->Name;
	}
	
	public function GetPageDescription()
	{
		if (isset($this->Description))
			{return $this->Description;}
		else
			{return "";}
	}
	
	public static function GetPage($Path)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			if ($WSDB == null) {return;}
			if (!isset($_SESSION["SITE_ID"])) {return;}
			if (strpos($Path, "/SysPages/") !== false) {return;}

			$Pag = new WS_Page();

			$NewPath="Pages/".basename($Path);
			$Sql = "SELECT * FROM ws_pages WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND Path = '" . $NewPath . "'";

			//?????????????? OLD DATA PAGES REPAIR ?????????????????
			if ($Path != $NewPath)
			{
				$Sql = "update ws_pages set Path='".$NewPath."' where Path='".$Path."'";
				$WSDB->query($Sql);
				$Path = $NewPath;
				$Sql = "SELECT * FROM ws_pages WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND Path ='" . $NewPath . "'";
			}
			// ??????????????????????????????????????????????????????


			$result = $WSDB->query($Sql);
			if ($result->num_rows == 0)
			{
				$Sql = "SELECT MAX(PageID) as PID FROM ws_pages WHERE SiteID=" . $_SESSION["SITE_ID"];
				$result = $WSDB->query($Sql);
				$Pag->PageID = 0;
				$row = $result->fetch_assoc();
				if ($row["PID"] != null) {$Pag->PageID = $row["PID"];}
				$Pag->PageID ++;
				$Pag->Row = 0;
				$Pag->Name = WS_Page::GetPageName();
				$Pag->Path = WS_Page::GetPageRelativePath();
				$Pag->MasterTemplate = "Default.Master";
				$Pag->BodyTemplate[0] = "Default.Template";
				for ($B=0;$B<$this->MAX_BODY;$B++)
				{
					$Pag->BodyTemplate[$B] = "";
				}
				$Pag->MainPage = 0;
				$Pag->PermisionsR = "all";
				$Pag->PermisionsW = "";
				$Pag->PermisionsE = "admin";
				$Pag->Css = "default.css";
				$Pag->MenuBarCss = "default.css";
				$Pag->Update();
			} 
			else
			{
				$row = $result->fetch_assoc();
				$Pag = new WS_Page();
				$Pag->LoadPageRecord($row);
			}
			return $Pag;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetStartPage()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$Ret = null;
			$Sql = "SELECT * FROM ws_pages WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MainPage=1";
			$result = $WSDB->query($Sql);
			if ($result->num_rows > 0)
			{
				$row = $result->fetch_assoc();
				$Ret= new WS_Page();
				$Ret->LoadPageRecord($row);
			}
			return $Ret;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}

	public static function GetPageByName($Name)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$Ret = null;
			$Sql = "SELECT * FROM ws_pages WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND Name='" . $Name . "'";
			$result = $WSDB->query($Sql);
			if ($result->num_rows > 0)
			{
				$row = $result->fetch_assoc();
				$Ret= new WS_Page();
				$Ret->LoadPageRecord($row);
			}
			return $Ret;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetPageById($ID)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$Ret = null;
			$Sql = "SELECT * FROM ws_pages WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND PageID=" . $ID;
			$result = $WSDB->query($Sql);
			if ($result->num_rows > 0)
			{
				$row = $result->fetch_assoc();
				$Ret= new WS_Page();
				$Ret->LoadPageRecord($row);
			}
			return $Ret;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetPageFromPugin($PluginName)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$Ret = null;
			$Sql = "SELECT distinct p.* FROM ws_slots s inner join ws_pages p on s.PageID = p.PageID and s.SiteID = p.SiteID ";
			$Sql .= " where s.ContType='PLG' and Param0='".$PluginName."'";
			$Sql .= " and p.SiteID=".$_SESSION["SITE_ID"];
			$result = $WSDB->query($Sql);
			if ($result->num_rows > 0)
			{
				$row = $result->fetch_assoc();
				$Ret= new WS_Page();
				$Ret->LoadPageRecord($row);
			}
			return $Ret;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetPagesNames()
	{
		$dirArray = array();
		$myDirectory = opendir(WS::$WSBase->Root."/Pages");
		while($entryName = readdir($myDirectory))
		{
			if ((!is_dir($entryName)) && (strpos("..",$entryName) === false))
			{
				array_push($dirArray,str_replace('.php', '', $entryName));
			}
		}
		sort($dirArray);
		closedir($myDirectory);
		return $dirArray;
	}
	
	private function LoadPageRecord($row)
	{
		$this->PageID = $row["PageID"];
		$this->Name = $row["Name"];
		$this->Path = $row["Path"];
		$this->MasterTemplate = $row["MasterTemplate"];
		for ($B=0;$B<$this->MAX_BODY;$B++)
		{
			$this->BodyTemplate[$B] = $row["BodyTemplate".$B];
		}
		$this->MainPage = $row["MainPage"];
		$this->PermisionsR = $row["PermisionsR"];
		$this->PermisionsW = $row["PermisionsW"];
		$this->PermisionsE = $row["PermisionsE"];
		$this->Title = $row["Title"];
		$this->Description = $row["Description"];
		$this->Css = $row["CSS"];
		$this->MenuBarCss = $row["MenuBarCSS"];
	}
	
	public static function GetPageName()
	{
		return basename($_SERVER['SCRIPT_NAME']);
	}
	
	public static function GetPageRelativePath()
	{
		return $_SERVER['SCRIPT_NAME'];
	}
	
	public function GetIcon()
	{
		$Icon="";
		if (file_exists(WS::$WSBase->Root."/Media/".$this->Name."/WS_Icon.png")){return "../Media/".$this->Name."/WS_Icon.png";}
		if (file_exists(WS::$WSBase->Root."/Media/".$this->Name."/WS_Icon.gif")){return "../Media/".$this->Name."/WS_Icon.gif";}
		if (file_exists(WS::$WSBase->Root."/Media/".$this->Name."/WS_Icon.jpg")){return "../Media/".$this->Name."/WS_Icon.jpg";}
		
		if (file_exists(WS::$WSBase->Root."/Media/WS_Icon.png")) {return "../Media/WS_Icon.png";}
		if (file_exists(WS::$WSBase->Root."/Media/WS_Icon.gif")) {return "../Media/WS_Icon.gif";}
		if (file_exists(WS::$WSBase->Root."/Media/WS_Icon.jpg")) {return "../Media/WS_Icon.jpg";}
		
		if ($Icon=="") {return WS_Property::GetText("FavIcon","Icon");}
		
		return "";
	}
	
	public function GetImage()
	{
		if (file_exists(WS::$WSBase->Root."/Media/".$this->Name."/WS_Image.png"))
			{return "../Media/".$this->Name."/WS_Image.png";}
		if (file_exists(WS::$WSBase->Root."/Media/".$this->Name."/WS_Image.jpg"))
			{return "../Media/".$this->Name."/WS_Image.jpg";}
		if (file_exists(WS::$WSBase->Root."/Media/".$this->Name."/WS_Image.gif"))
			{return "../Media/".$this->Name."/WS_Image.gif";}
			
		if (file_exists(WS::$WSBase->Root."/Media/".$this->Name)) 
		{
			$myDirectory = opendir(WS::$WSBase->Root."/Media/".$this->Name);
			while($entryName = readdir($myDirectory))
			{
				if (!is_dir($entryName))
				{
					if (str_pos($entryName,".WS_Icon")===false)
					{
						if (str_pos(strtolower($entryName),".png")!==false) {closedir($myDirectory);return $entryName;}
						if (str_pos(strtolower($entryName),".jpg")!==false) {closedir($myDirectory);return $entryName;}
						if (str_pos(strtolower($entryName),".gif")!==false) {closedir($myDirectory);return $entryName;}
					}
				}
			}
		}
		
		return GetIcon();
	}
	
	public function GetPageImages()
	{
		$dirArray = array();
		if (!file_exists(WS::$WSBase->Root."/Media/".$this->Name)) {return $dirArray;}
		$myDirectory = opendir(WS::$WSBase->Root."/Media/".$this->Name);
		while($entryName = readdir($myDirectory))
		{
			if ((strpos(strtolower($entryName),".png") !== false) || (strpos(strtolower($entryName),".jpg") !== false) || (strpos(strtolower($entryName),".gif") !== false))
			{
				array_push($dirArray,$entryName);
			}
		}
		sort($dirArray);
		closedir($myDirectory);
		return $dirArray;
	}
	
	public function GetGlobalImages()
	{
		$dirArray = array();
		if (!file_exists(WS::$WSBase->Root."/Media")) {return $dirArray;}
		$myDirectory = opendir(WS::$WSBase->Root."/Media");
		while($entryName = readdir($myDirectory))
		{
			if ((strpos(strtolower($entryName),".png") !== false) || (strpos(strtolower($entryName),".jpg") !== false) || (strpos(strtolower($entryName),".gif") !== false))
			{
				array_push($dirArray,$entryName);
			}
		}
		sort($dirArray);
		closedir($myDirectory);
		return $dirArray;
	}
	
	public function Update()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			
			$Sql = "SELECT * FROM ws_pages WHERE MainPage=1 AND SiteID=" . $_SESSION["SITE_ID"];
			$result = $WSDB->query($Sql);
			if ($result->num_rows == 0)
			{
				if ($this->MainPage == 0) {$this->MainPage = 1;}
			}
			else
			{
				if ($this->MainPage == 1)
				{
					$Sql = "UPDATE ws_pages SET MainPage=0 WHERE MainPage=1 and SiteID="  . $_SESSION["SITE_ID"];
					$WSDB->query($Sql);
				}
			}
			
			if ($this->PageID>0)
			{
				$sql = "UPDATE ws_pages SET ";
				$sql .= "Name='" . ConnectDB::FormatStr($this->Name) . "',";
				$sql .= "Path='" . ConnectDB::FormatStr($this->Path) . "',";
				$sql .= "MasterTemplate='" . ConnectDB::FormatStr($this->MasterTemplate) . "',";
				
				for ($B=0;$B<$this->MAX_BODY;$B++)
				{
					$sql .= "BodyTemplate".$B."='" . ConnectDB::FormatStr($this->BodyTemplate[$B]) . "',";
				}

				if ($this->MainPage==1)
					{$sql .= "MainPage=true,";}
				else
					{$sql .= "MainPage=false,";}
				$sql .= "PermisionsR='" . ConnectDB::FormatStr($this->PermisionsR) . "',";
				$sql .= "PermisionsW='" . ConnectDB::FormatStr($this->PermisionsW) . "',";
				$sql .= "PermisionsE='" . ConnectDB::FormatStr($this->PermisionsE) . "',";
				$sql .= "Css='" . ConnectDB::FormatStr($this->Css) . "',";
				$sql .= "MenuBarCss='" . ConnectDB::FormatStr($this->MenuBarCss). "',";
				$sql .= "Title='" . ConnectDB::FormatStr($this->Title) . "',";
				$sql .= "Description='" . ConnectDB::FormatStr($this->Description) . "'";
				$sql .= " WHERE SiteID=".$_SESSION["SITE_ID"]." and PageID=".$this->PageID;
				$WSDB->query($sql);	
			}
			else
			{
				$sql="SELECT MAX(PageID) as PageID FROM ws_pages";
				$result = $WSDB->query($sql) or die(mysql_error()); 
				$row = $result->fetch_assoc();
				$this->PageID=$row["PageID"] + 1;

				$sql = "INSERT INTO ws_pages (SiteID,PageID,Name,Path,MasterTemplate,";
				for ($B=0;$B<$this->MAX_BODY;$B++)
				{
					$sql .= "BodyTemplate".$B.",";
				}
				$sql .= "MainPage,PermisionsR,PermisionsW,PermisionsE,Css,MenuBarCss,Title,Description) values (";
				$sql .= $_SESSION["SITE_ID"] . ",";
				$sql .= $this->PageID . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->Name) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Path) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->MasterTemplate)."',";
				for ($B=0;$B<$this->MAX_BODY;$B++)
				{
					$sql .= "'" . ConnectDB::FormatStr($this->BodyTemplate[$B]) . "',";
				}
				if ($this->MainPage)
					{$sql .= "true,";}
				else
					{$sql .= "false,";}
				$sql .= "'" . ConnectDB::FormatStr($this->PermisionsR) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->PermisionsW) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->PermisionsE). "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Css) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->MenuBarCss) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Title) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Description) . "')";
				$WSDB->query($sql);	
			}
		
			{
				$MainPage = 0;
				$Sql = "SELECT * FROM ws_pages WHERE MainPage=1 AND SiteID=" . $_SESSION["SITE_ID"];
				$result = $WSDB->query($Sql);
				if ($result->num_rows == 0){$MainPage = 1;}
			}
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Delete()
	{
		try
		{
			if (!$this->MainPage)
			{
				$WSDB=WS::$WSBase->WSDB;
				$SQL = "delete from ws_pages where SiteID=".$_SESSION["SITE_ID"]." and PageID=".$this->PageID;
				$WSDB->query($SQL);
				$SQL = "delete from ws_slots where SiteID=".$_SESSION["SITE_ID"]." and PageID=".$this->PageID;
				$WSDB->query($SQL);
				unlink(WS::$WSBase->Root."/Pages/" . $this->Name . ".php");
			}

			// ?????????????? REMOVE PAGE FILES ??????????????
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	
}

class WS_Menu
{
	public $MenuID=0;
	public $Pos;
	public $SubPos;
	public $DropDown;
	public $Text="";
	public $Tooltip="";
	public $Link="";
	public $Permisions="all";
	
	public function __constructor()
	{
	}
	
	public function Init($MenuID,$Pos,$SubPos,$Text,$Tooltip,$Link,$Permisions,$Lang,$DropDown) 
	{
		 $this->SiteID=$_SESSION["SITE_ID"];
		 $this->MenuID=$MenuID;
		 $this->Pos=$Pos;
		 $this->SubPos=$SubPos;
		 $this->Text=$Text;
		 $this->Tooltip=$Tooltip;
		 $this->Link=$Link;
		 $this->Permisions=$Permisions;
		 $this->Lang=$Lang;
		 $this->DropDown=$DropDown;
	 }
	
	public static function GetMenu($MenuID,$Pos,$SubPos,$Lang)
	{
		try
		{
			$Menu = null;
			$WSDB=WS::$WSBase->WSDB;
			$SQL = "SELECT * FROM ws_menus WHERE SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$MenuID."' AND Pos=".$Pos." AND SubPos=".$SubPos." AND Lang=".$Lang;
			$Res = $WSDB->query($SQL);
			if($result->num_rows == 1)
			{
				$row = $result->fetch_assoc();
				$Menu = new WS_Menu();
				$Menu->MenuID = $row["MenuID"];
				$Menu->Pos = $row["Pos"];
				$Menu->SubPos = $row["SubPos"];
				$Menu->DropDown = $row["DropDown"];
				$Menu->Text = $row["Text"];
				$Menu->Tooltip = $row["Tooltip"];
				$Menu->Link = $row["Link"];
				$Menu->Permisions = $row["Permisions"];
			}
			return $Menu;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetMenus($MenuID,$Pos=null,$SubPos=null,$Lang=null,$DropDown=null)
	{
		try
		{
			$Menu = null;
			$WSDB=WS::$WSBase->WSDB;
			$SQL = "SELECT * FROM ws_menus WHERE SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$MenuID."'"; 
			if (isset($Pos)) {$SQL .= " AND Pos=".$Pos;} 
			if (isset($SubPos)) {$SQL .= " AND SubPos=".$SubPos;} 
			if (isset($Lang)) {$SQL .= " AND Lang='".$Lang."'";}
			if (isset($DropDown)) 
			{
				if ($DropDown)
				{
					$SQL .= " AND DropDown=true";
				}
				else
				{
					$SQL .= " AND DropDown=false";
				}
			}
			$Res = $WSDB->query($SQL);
			$Menus=array();
			for ($R=0;$R<$Res->num_rows;$R++)
			{
				$row = $Res->fetch_assoc();
				$Menu = new WS_Menu();
				$Menu->MenuID = $row["MenuID"];
				$Menu->Pos = $row["Pos"];
				$Menu->SubPos = $row["SubPos"];
				$Menu->DropDown = $row["DropDown"];
				$Menu->Text = $row["Text"];
				$Menu->Tooltip = $row["Tooltip"];
				$Menu->Link = $row["Link"];
				$Menu->Permisions = $row["Permisions"];
				$Menus[$Menu->Pos."_".$Menu->SubPos] = $Menu;
			}
			return $Menus;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetMultiLangMenus($MenuID,$Pos="",$SubMenu=false)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$M="";
			if ($Pos!="")
				{$M.=" and Pos=".$Pos;}

			if ($SubMenu)
				{$M.=" and SubPos>0 ";}
			else
				{$M.=" and SubPos=0 ";}

			$Langs = WS::GetLangByPriority();
			$Langs = array_reverse($Langs);
			$MenuArray = array();

			foreach($Langs as $Lang)
			{
				$Sql = "SELECT * FROM ws_menus WHERE SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$MenuID."' ".$M." AND Lang='" . $Lang . "' ORDER BY Pos ";
				$result = $WSDB->query($Sql);
				if ($result->num_rows != 0)
				{
					for ($N=0;$N<$result->num_rows;$N++)
					{
						$row = $result->fetch_assoc();
						$Menu = new WS_Menu();
						$Menu->MenuID = $row["MenuID"];
						$Menu->Pos = $row["Pos"];
						$Menu->SubPos = $row["SubPos"];
						$Menu->DropDown = $row["DropDown"];
						$Menu->Text = $row["Text"];
						$Menu->Link = $row["Link"];
						$Menu->Tooltip = $row["Tooltip"];
						$Menu->Permisions = $row["Permisions"];
						if ($SubMenu)
							{$MenuArray[$Menu->Pos."_".$Menu->SubPos] = $Menu;}
						else
							{$MenuArray[$Menu->Pos] = $Menu;}
					}
				}
			}
			return $MenuArray;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetLangs()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$resultRow = $WSDB->query('select distinct Lang from ws_menus');
			$Langs = "";
			for ($M=0;$M<$resultRow->num_rows;$M++)
			{
				$R = $resultRow->fetch_assoc();
				if($Langs!=""){$Langs.=",";}
				$Langs.=$R["Lang"];
			}
			if ($Langs=="") {$Langs="en";}
			return $Langs;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function MoveUp()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			if ($this->SubPos==0)
			{
					$Sql = "UPDATE ws_menus SET Pos=-1 WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' AND Pos=" . (string)(((int)$this->Pos)-1);
					$WSDB->query($Sql);

					$Sql = "UPDATE ws_menus SET Pos=Pos-1 WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' AND Pos=" . $this->Pos ;
					$WSDB->query($Sql);

					$Sql = "UPDATE ws_menus SET Pos=" . $this->Pos . " WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' AND Pos=-1";
					$WSDB->query($Sql);
			}
			else
			{
				$Sql = "UPDATE ws_menus SET SubPos=-1 WHERE SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$this->MenuID."' and Pos=".$this->Pos." and SubPos=".(string)(((int)$this->SubPos)-1);
				$WSDB->query($Sql);

				$Sql = "UPDATE ws_menus SET SubPos=SubPos-1 WHERE SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$this->MenuID."' AND Pos=".$this->Pos." and SubPos=".$this->SubPos;
				$WSDB->query($Sql);

				$Sql = "UPDATE ws_menus SET SubPos=" . $this->SubPos . " WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' and Pos=".$this->Pos." AND SubPos=-1";
				$WSDB->query($Sql);
			}
		} 
		catch (Exception $ex) 
		{
			echo $ex->getMessage();
		}
	}
	
	public function MoveDown()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			if ($this->SubPos==0)
			{
				$Sql = "UPDATE ws_menus SET Pos=-1 WHERE SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$this->MenuID."' AND Pos=".(string)(((int)$this->Pos)+1);
				$WSDB->query($Sql);

				$Sql = "UPDATE ws_menus SET Pos=Pos+1 WHERE SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$this->MenuID."' AND Pos=".$this->Pos;
				$WSDB->query($Sql);

				$Sql = "UPDATE ws_menus SET Pos=" . $this->Pos . " WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' AND Pos=-1";
				$WSDB->query($Sql);
			}
			else 
			{
				$Sql = "UPDATE ws_menus SET SubPos=-1 WHERE SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$this->MenuID."' and Pos=".$Menu->Pos." and SubPos=".(string)(((int)$this->SubPos)+1);
				$WSDB->query($Sql);

				$Sql = "UPDATE ws_menus SET SubPos=SubPos+1 WHERE SiteID=".$_SESSION["SITE_ID"]." AND MenuID='".$this->MenuID."' AND Pos=".$Menu->Pos." and SubPos=".$this->SubPos;
				$WSDB->query($Sql);

				 $Sql = "UPDATE ws_menus SET SubPos=" . $this->SubPos . " WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' and Pos=".$this->Pos." AND SubPos=-1";
				$WSDB->query($Sql);
			}
		} 
		catch (Exception $ex) 
		{
			echo $ex->getMessage();
		}
	}
	
	public function SetDropDownFlag()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$Sql = "select Pos from ws_menus where SiteID=".$_SESSION["SITE_ID"]." and MenuID='".$this->MenuID."' and Pos=".$this->Pos." and SubPos<>0";
			$rr=$WSDB->query($Sql);
			if ($rr->num_rows>0)
			{
				$Sql = "update ws_menus set DropDown=true where SiteID=".$_SESSION["SITE_ID"]." and MenuID='".$this->MenuID."' and Pos=".$this->Pos." and SubPos=0";
			}
			else
			{
				$Sql = "update ws_menus set DropDown=false where SiteID=".$_SESSION["SITE_ID"]." and MenuID='".$this->MenuID."' and Pos=".$this->Pos;
			}
			$WSDB->query($Sql);
		}
		catch (Exception $ex)
		{
			echo $ex->getMessage();
		}
	}
	
	public function Update()
	{
		$WhereLang="";
		if (WS::$WSBase->Lang != WS::$WSBase->BaseLang)
			{$WhereLang = " and Lang='".WS::$WSBase->Lang."' ";}
		
		$WSDB=WS::$WSBase->WSDB;
		$sql = "SELECT * from ws_menus WHERE SiteID=".$_SESSION["SITE_ID"]." and MenuID='".$this->MenuID."' and Pos=".$this->Pos." and SubPos=".$this->SubPos." and Lang='".$this->Lang."'";
		$Result = $WSDB->query($sql);
		if ($Result->num_rows>0)
		{
			$sql = "UPDATE ws_menus SET ";
			if ($this->DropDown)
				{$sql .= "DropDown=true,";}
			else
				{$sql .= "DropDown=false,";}
			$sql .= "Link='" . ConnectDB::FormatStr($this->Link) . "',";
			$sql .= "Permisions='" . ConnectDB::FormatStr($this->Permisions) . "'";
			$sql .= " WHERE SiteID=".$_SESSION["SITE_ID"]." and MenuID='".$this->MenuID. "' and Pos=" . $this->Pos . " and SubPos=" . $this->SubPos . $WhereLang;
			$WSDB->query($sql);
			
			$sql = "UPDATE ws_menus SET ";
			$sql .= "Text='" . ConnectDB::FormatStr($this->Text) . "',";
			$sql .= "Tooltip='" . ConnectDB::FormatStr($this->Tooltip) . "',";
			$sql .= " WHERE SiteID=".$_SESSION["SITE_ID"]." and MenuID='".$this->MenuID. "' and Pos=" . $this->Pos . " and SubPos=" . $this->SubPos . " AND Lang='" . $this->Lang . "'";
			$WSDB->query($sql);
		}
		else
		{
			$sql = "INSERT INTO ws_menus (SiteID,MenuID,Pos,SubPos,Lang,DropDown,Text,Tooltip,Link,Permisions) values (";
			$sql .= $_SESSION["SITE_ID"] . ",";
			$sql .= "'" . $this->MenuID . "',";
			$sql .= $this->Pos . ",";
			$sql .= $this->SubPos . ",";
			$sql .= "'" . $this->Lang . "',";
			if ($this->DropDown)
				{$sql .= "true,";}
			else
				{$sql .= "false,";}
			$sql .= "'" . ConnectDB::FormatStr($this->Text)."',";
			$sql .= "'" . ConnectDB::FormatStr($this->Tooltip) . "',";
			$sql .= "'" . ConnectDB::FormatStr($this->Link) . "',";
			$sql .= "'" . ConnectDB::FormatStr($this->Permisions) . "')";
			$WSDB->query($sql);
		}
	}
	
	public function Delete()
	{
		$WSDB=WS::$WSBase->WSDB;
		
		$WhereLang ="";
		if (WS::$WSBase->Lang != WS::$WSBase->BaseLang)
			{$WhereLang = " and Lang='".WS::$WSBase->Lang."' ";}
		
		if ($this->SubPos==0)
		{
			$Sql = "DELETE FROM ws_menus WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' AND Pos=" . $this->Pos . $WhereLang;
			$WSDB->query($Sql);
			
			$Sql = "UPDATE ws_menus SET Pos=Pos-1 WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' AND Pos>" . $this->Pos ;
			$WSDB->query($Sql);
		}
		else
		{
			$Sql = "DELETE FROM ws_menus WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' AND Pos=" . $this->Pos." AND SubPos=" . $this->SubPos . $WhereLang;
			$WSDB->query($Sql);

			$Sql = "UPDATE ws_menus SET SubPos=SubPos-1 WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND MenuID='" . $this->MenuID . "' AND Pos=" . $this->Pos." AND SubPos>" . $this->SubPos;
			$WSDB->query($Sql);
		}
	}
}

class WS_User
{
	public $SiteID=0;
	public $UserID=0;
	public $UserName="";
	public $Password="";
	public $Permisions="";
	public $FirstName="";
	public $LastName="";
	public $Organization="";
	public $State="";
	public $Region="";
	public $City="";
	public $Address="";
	public $LocationLat=0;
	public $LocationLon=0;
	public $Zip="";
	public $Phone="";
	public $FiscalCode="";
	public $Email="";
	public $Notes="";
	public $Photo="";
	public $Disabled=0;
	public $Gender=0;
	public $LookFor=0;
	public $LastAccess=null;
	public $RegistrationDT=null;
	
	public static function GetUserByID($UserID)
	{
		$WSDB=WS::$WSBase->WSDB;
		$User=null;
		$SQL = "SELECT * FROM ws_users WHERE SiteID=".$_SESSION["SITE_ID"]." AND UserID=".$UserID;
		$result = $WSDB->query($SQL);
		if($result->num_rows == 1)
		{
			$row = $result->fetch_assoc();
			$User = new WS_User();
			$User->SiteID=$row["SiteID"];
			$User->UserID=$row["UserID"];
			$User->UserName=$row["UserName"];
			$User->Password=$row["Password"];
			$User->Permisions=$row["Permisions"];
			$User->FirstName=$row["FirstName"];
			$User->LastName=$row["LastName"];
			$User->Photo=$row["Photo"];
			if (isset($row["Organization"])) {$User->Organization=$row["Organization"];}
			$User->State=$row["State"];
			$User->Region=$row["Region"];
			$User->City=$row["City"];
			$User->Address=$row["Address"];
			$User->LocationLat=$row["LocationLat"];
			$User->LocationLon=$row["LocationLon"];
			$User->Zip=$row["Zip"];
			$User->Phone=$row["Phone"];
			$User->FiscalCode=$row["FiscalCode"];
			$User->Email=$row["Email"];
			$User->Notes=$row["Notes"];
			$User->Disabled=boolval($row["Disabled"]);
			$User->Gender=$row["Gender"];
			$User->LookFor=$row["LookFor"];
			$User->LastAccess=$row["LastAccess"];
			$User->RegistrationDT=$row["RegistrationDT"];
		}
		return $User;
	}
	
	public static function GetUserByName($UserName)
	{
		$WSDB=WS::$WSBase->WSDB;
		$User=null;
		$SQL="SELECT * FROM ws_users WHERE SiteID=".$_SESSION["SITE_ID"]." AND UserName ='".ConnectDB::FormatStr($UserName)."'";
		$result = $WSDB->query($SQL); 
		if($result->num_rows == 1)
		{
			$row = $result->fetch_assoc();
			$User = new WS_User();
			$User->SiteID=$row["SiteID"];
			$User->UserID=$row["UserID"];
			$User->UserName=$row["UserName"];
			$User->Password=$row["Password"];
			$User->Permisions=$row["Permisions"];
			$User->FirstName=$row["FirstName"];
			$User->LastName=$row["LastName"];
			$User->Photo=$row["Photo"];
			if (isset($row["Organization"])) {$User->Organization=$row["Organization"];}
			$User->State=$row["State"];
			$User->Region=$row["Region"];
			$User->City=$row["City"];
			$User->Address=$row["Address"];
			$User->LocationLat=$row["LocationLat"];
			$User->LocationLon=$row["LocationLon"];
			$User->Zip=$row["Zip"];
			$User->Phone=$row["Phone"];
			$User->FiscalCode=$row["FiscalCode"];
			$User->Email=$row["Email"];
			$User->Notes=$row["Notes"];
			$User->Disabled=$row["Disabled"];
			$User->Gender=$row["Gender"];
			$User->LookFor=$row["LookFor"];
			$User->LastAccess=$row["LastAccess"];
			$User->RegistrationDT=$row["RegistrationDT"];
		}
		return $User;
	}
	
	public static function GetUserByEmail($Email)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$User=null;
			$SQL="SELECT * FROM ws_users WHERE SiteID=".$_SESSION["SITE_ID"]." AND Email ='".ConnectDB::FormatStr($Email)."'";
			$result = $WSDB->query($SQL); 
			if($result->num_rows == 1)
			{
				$row = $result->fetch_assoc();
				$User = new WS_User();
				$User->SiteID=$row["SiteID"];
				$User->UserID=$row["UserID"];
				$User->UserName=$row["UserName"];
				$User->Password=$row["Password"];
				$User->Permisions=$row["Permisions"];
				$User->FirstName=$row["FirstName"];
				$User->LastName=$row["LastName"];
				$User->Photo=$row["Photo"];
				if (isset($row["Organization"])) {$User->Organization=$row["Organization"];}
				$User->State=$row["State"];
				$User->Region=$row["Region"];
				$User->City=$row["City"];
				$User->Address=$row["Address"];
				$User->LocationLat=$row["LocationLat"];
				$User->LocationLon=$row["LocationLon"];
				$User->Zip=$row["Zip"];
				$User->Phone=$row["Phone"];
				$User->FiscalCode=$row["FiscalCode"];
				$User->Email=$row["Email"];
				$User->Notes=$row["Notes"];
				$User->Disabled=$row["Disabled"];
			}
			return $User;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Update()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			if ($this->UserID>0)
			{
				$sql = "UPDATE ws_users SET ";
				$sql .= "UserName='" . ConnectDB::FormatStr($this->UserName) . "',";
				$sql .= "Password='" . ConnectDB::FormatStr($this->Password) . "',";
				$sql .= "Permisions='" . ConnectDB::FormatStr($this->Permisions) . "',";
				$sql .= "FirstName='" . ConnectDB::FormatStr($this->FirstName) . "',";
				$sql .= "LastName='" . ConnectDB::FormatStr($this->LastName) . "',";
				$sql .= "Photo='" . ConnectDB::FormatStr($this->Photo) . "',";
				$sql .= "Organization='" . ConnectDB::FormatStr($this->Organization) . "',";
				$sql .= "Email='" . ConnectDB::FormatStr($this->Email) . "',";
				$sql .= "State='" . ConnectDB::FormatStr($this->State) . "',";
				$sql .= "Region='" . ConnectDB::FormatStr($this->Region). "',";
				$sql .= "City='" . ConnectDB::FormatStr($this->City). "',";
				$sql .= "Address='" . ConnectDB::FormatStr($this->Address) . "',";
				$sql .= "LocationLat='" . ConnectDB::FormatStr($this->LocationLat) . "',";
				$sql .= "LocationLon='" . ConnectDB::FormatStr($this->LocationLon) . "',";
				$sql .= "Zip='" . ConnectDB::FormatStr($this->Zip) . "',";
				$sql .= "Phone='" . ConnectDB::FormatStr($this->Phone) . "',";
				$sql .= "FiscalCode='" . ConnectDB::FormatStr($this->FiscalCode) . "',";
				$sql .= "Notes='" . ConnectDB::FormatStr($this->Notes) . "',";
				if (isset($this->LastAccess))
					{$sql .= "LastAccess='" . $this->LastAccess . "',";}
					
				if ($this->Disabled)
					{$sql .= "Disabled=true,";}
				else
					{$sql .= "Disabled=false,";}

				$sql .= "Gender='" . ConnectDB::FormatStr($this->Gender) . "',";
				$sql .= "LookFor='" . ConnectDB::FormatStr($this->LookFor) . "'";

				$sql .= " WHERE SiteID=".$_SESSION["SITE_ID"]." and UserID=".$this->UserID;
				$WSDB->query($sql);	
			}
			else
			{
				$sql="SELECT MAX(UserID) as UserID FROM ws_users";
				$result = $WSDB->query($sql) or die(mysql_error()); 
				$row = $result->fetch_assoc();
				$this->UserID=$row["UserID"] + 1;

				$sql = "INSERT INTO ws_users (SiteID,UserID,UserName,Password,Permisions,FirstName,LastName,Photo,Organization,Email,Address,City,State,Zip,Phone,FiscalCode,Notes,Gender,LookFor,Disabled,LastAccess,RegistrationDT) values (";
				$sql .= $_SESSION["SITE_ID"] . ",";
				$sql .= $this->UserID . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->UserName) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Password) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Permisions)."',";
				$sql .= "'" . ConnectDB::FormatStr($this->FirstName) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->LastName) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Photo) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Organization) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Email). "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Address) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->City) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->State) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Zip) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Phone) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->FiscalCode). "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Notes). "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Gender ). "',";
				$sql .= "'" . ConnectDB::FormatStr($this->LookFor). "',";
				if ($this->Disabled)
					{$sql .= "true,";}
				else
					{$sql .= "false,";}
 				$sql .= "'" . date('Y-m-d h:i:s') . "',";
				$sql .= "'" . date('Y-m-d h:i:s') . "')";
				$WSDB->query($sql);	
			}
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Delete()
	{
		try
		{
			if ($this->UserID==1) {return;}
			$WSDB=WS::$WSBase->WSDB;
			$SQL = "delete from ws_users where SiteID=".$_SESSION["SITE_ID"]." and  UserID=".$this->UserID;
			$WSDB->query($SQL);
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function CheckEmailExists()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$sql="SELECT * FROM ws_users WHERE Email ='".ConnectDB::FormatStr($this->Email)."'";
			$result = $WSDB->query($sql); 
			if($result->num_rows == 1)
				{return true;}
			else
				{return false;}
		} catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
}

class WS_Slot
{
	public static $NumParams=20;
	public $PageID;
	public $BodyID=0;
	public $SlotID;
	public $PgUID=0;
	public $Row=0;
	public $MasterPgUID=0;
	public $UpdRow=0;
	public $Lang;
	public $ContType;
	public $Text;
	public $Param;
	public $Link;
	
	public function __construct($PageID=0,$BodyID=0,$SlotID="",$PgUID=0,$Lang='en')
	{
		$this->PageID=$PageID;
		$this->BodyID=$BodyID;
		$this->SlotID=$SlotID;
		$this->PgUID=$PgUID;
		$this->Lang=$Lang;
		$this->ContType="";
		$this->Text="";
		for ($N=0;$N<self::$NumParams;$N++){$this->Param[$N]="";}
		$this->Link="";
	}
	
	// CHECK IF SLOTS EXIST
	public static function Exists($PageID,$BodyID,$SlotID,$PgUID,$Lang=null)
	{
		try
		{
			if ($PageID == 0 ){$BodyID=0;}
			if (!isset($BodyID)){$BodyID=0;}
			$WSDB=WS::$WSBase->WSDB;
			$SQL = "SELECT PageID FROM ws_slots WHERE SiteID=".$_SESSION["SITE_ID"]." AND PageID=".$PageID." AND BodyID=".$BodyID." AND SlotID='".ConnectDB::FormatStr($SlotID)."'";
			if ($PgUID!=null) $SQL .= " AND PgUID=".$PgUID;
			if ($Lang!=null) $SQL .= " AND Lang='".$Lang."'";
			$rr = $WSDB->query($SQL);
			if($rr->num_rows == 1)
				{return true;}
			else
				{return false;}
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	// RETURN A SINGLE SLOT OBJECT
	public static function GetSlot($PageID,$BodyID,$SlotID,$PgUID,$Lang=null)
	{
		try
		{
			if ($PageID == 0 ){$BodyID=0;}
			if (!isset($BodyID)){$BodyID=0;}
			$WSDB=WS::$WSBase->WSDB;
			$Slot=null;
			$SQL = "SELECT * FROM ws_slots WHERE SiteID=".$_SESSION["SITE_ID"]." AND PageID=".$PageID." AND BodyID=".$BodyID." AND SlotID='".ConnectDB::FormatStr($SlotID)."' AND PgUID=".$PgUID." AND Lang='".$Lang."'";
			$rr = $WSDB->query($SQL);
			if($rr->num_rows == 1)
			{
				$Row = $rr->fetch_assoc();
				$Slot = WS_Slot::CreateFromDbRow($Row);
			}
			return $Slot;
		} catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	// GET A LIST OF SLOTS
	public static function GetSlots($PageID,$Lang=null,$BodyID=null,$SlotID=null,$PgUID=null)
	{
		$Slots=array();
		
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$SQL = "SELECT * FROM ws_slots WHERE SiteID=".$_SESSION["SITE_ID"];
			if (isset($PageID)) {$SQL .= " AND PageID=".$PageID;}
			if (isset($Lang)) {$SQL .= " AND Lang='".$Lang."'";}
			if (isset($PgUID)) {$SQL .= " AND PgUID=".$PgUID;}
			if (isset($BodyID)) {$SQL .= " AND BodyID=".$BodyID;}
			if (isset($SlotID)) {$SQL .= " AND SlotID='".$SlotID."'";}
			$SQL .= " ORDER BY SlotID,BodyID,PgUID";
			$res = $WSDB->query($SQL);
			if ($res !== false)
			{
				for ($M=0;$M<$res->num_rows;$M++)
				{
					$R = $res->fetch_assoc();
					$Slot= WS_Slot::CreateFromDbRow($R);
					array_push($Slots,$Slot);
				}
			}
		}
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
		return $Slots;
	}

	// CREATE A SLOT OBJ FROM DB ROW OBJ
	public static function CreateFromDbRow($DbRow)
	{
		$Slot = new WS_Slot();
		$Slot->PageID = $DbRow["PageID"];
		$Slot->BodyID = $DbRow["BodyID"];
		$Slot->SlotID = $DbRow["SlotID"];
		$Slot->PgUID = $DbRow["PgUID"];
		$Slot->MasterPgUID = $DbRow["MasterPgUID"];
		$Slot->Lang = $DbRow["Lang"];
		$Slot->ContType = $DbRow["ContType"];
		if (($Slot->PgUID  == 24) && ($Slot->ContType == "SLI") && ($Slot->SlotID == "Sub_ImageSlider"))
		{
			$a=1;
		}
		$Slot->Text = $DbRow["Text"];
		$Slot->Param = Array();
		for ($S=0;$S<self::$NumParams;$S++)
			{
			if (isset($DbRow["Param".$S]))
				{$Slot->Param[$S] = $DbRow["Param".$S];}
			else
				{$Slot->Param[$S] = "";}
			}
		$Slot->Link = $DbRow["Link"];
		
		return $Slot;
	}
	
	public static function GetMaxPgUID($PageID)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$PgUID = 0;
			$Sql = "SELECT max(MasterPgUID) as PgUID FROM ws_slots WHERE SiteID=" . $_SESSION["SITE_ID"] . " AND PageID=" . $PageID; 
			$resultRow = $WSDB->Query($Sql);
			if ($resultRow->num_rows>0)
			{
				$R = $resultRow->fetch_assoc();
				$PgUID=$R["PgUID"];
			}
			return $PgUID;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}

	public function UpdateMasterPgUID()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			if (WS_Slot::Exists($this->PageID,$this->BodyID,$this->SlotID,$this->PgUID=null,$this->UpdRow=null,$this->Lang=null))
			{
				$sql = "UPDATE ws_slots SET ";
				$sql .= "MasterPgUID=".$this->MasterPgUID;
				$sql .= " where SiteID=".$_SESSION["SITE_ID"]." AND PageID=".$this->PageID;
				$SQL .= " AND SlotID='".ConnectDB::FormatStr($this->SlotID)."'";
				if ($Lang!=null) {$SQL .= " AND Lang='".$this->Lang."'";}
				if ($Row!=null) {$SQL .= " AND Row=".$this->UpdRow;}
				if ($PgUID!=null) {$SQL .= " AND PgUID=".$this->PgUID;}
				if ($BodyID!=null) {$SQL .= " AND BodyID=".$this->BodyID;}
				$WSDB->query($sql);
			}
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Update()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			if (WS_Slot::Exists($this->PageID,$this->BodyID,$this->SlotID,$this->PgUID,$this->Lang))
			{
				$sql = "UPDATE ws_slots SET ";
				$sql .= "MasterPgUID=".$this->MasterPgUID.",";
				$sql .= "ContType='".ConnectDB::FormatStr($this->ContType)."',";
				$sql .= "Text='".ConnectDB::FormatStr($this->Text)."',";
				for ($N=0;$N<self::$NumParams;$N++)
					{$sql .= "Param".$N."='" .ConnectDB::FormatStr($this->Param[$N])."',";}
				$sql .= "Link='" . ConnectDB::FormatStr($this->Link) . "'";
				$sql .= " where SiteID=".$_SESSION["SITE_ID"]." and PageID=".$this->PageID." and BodyID=".$this->BodyID." and SlotID='".ConnectDB::FormatStr($this->SlotID)."' and PgUID=".$this->PgUID." and Lang='".$this->Lang."'";
				$WSDB->query($sql);
			}
			else
			{
				$sql = "INSERT INTO ws_slots (SiteID,PageID,BodyID,SlotID,PgUID,MasterPgUID,Lang,ContType,Text,";
				for ($N=0;$N<self::$NumParams;$N++) {$sql .= "Param".$N.",";}
				$sql .= "Link) values (";
				$sql .= $_SESSION["SITE_ID"] . ",";
				$sql .= $this->PageID . ",";
				$sql .= $this->BodyID . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->SlotID) . "',";
				$sql .= $this->PgUID . ",";
				$sql .= $this->MasterPgUID . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->Lang) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->ContType) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Text) . "',";
				for ($N=0;$N<self::$NumParams;$N++) 
					{$sql .= "'" . ConnectDB::FormatStr($this->Param[$N]) . "',";}
				$sql .= "'" . ConnectDB::FormatStr($this->Link)."')";
				$WSDB->query($sql);
			}
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Delete()
	{
		try
		{
			if ($this->ContType=="TEM")
			{
				$SubSlots = WS_Slot::GetSlots($this->PageID,null,$this->BodyID,null,$this->MasterPgUID);
				foreach ($SubSlots as $SubSlot){$SubSlot->Delete();}
			}

			$WSDB=WS::$WSBase->WSDB;
			$SQL = "delete from ws_slots where SiteID=".$_SESSION["SITE_ID"]." and  PageID=".$this->PageID." and BodyID=".$this->BodyID." and SlotID='".ConnectDB::FormatStr($this->SlotID)."' and PgUID=".$this->PgUID;
			if ($this->Lang != "") {$SQL .= " and Lang='".$this->Lang."'";}
			$WSDB->query($SQL);
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetLangs()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$resultRow = $WSDB->query('select distinct Lang from ws_slots');
			
			$Langs = "";
			for ($M=0;$M<$resultRow->num_rows;$M++)
			{
				$R = $resultRow->fetch_assoc();
				if($Langs!=""){$Langs.=",";}
				$Langs.=$R["Lang"];
			}
			if ($Langs=="") {$Langs="en";}
			return $Langs;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
}

class WS_ParamDef
{
	public $Name="";
	public $Text="";
	public $Width=0;
	public $Height=0;
	public $Type;
	public $Values=null;
	public $DefaultValue=null;
	
	public function __construct($Name,$Text,$Width,$Height,$Type,$Values,$DefaultValue="")
	{
		$this->Name=$Name;
		$this->Text=$Text;
		$this->Width=$Width;
		$this->Height=$Height;
		$this->Type=$Type;
		$this->Values=$Values;
		$this->DefaultValue=$DefaultValue;
	}
}

class WS_Property
{
	private $WSDB;
	public $Group = "";
	public $Name = "";
	public $Text = "";
	public $Num = 0;
	
	public function __construct($DB=null)
	{
		if (isset($DB))
			{$this->WSDB=$DB;}
		else
			{$this->WSDB=WS::$WSBase->WSDB;}
	}

	public function Update()
	{
		try
		{
			$Prop=WS_Property::Get($this->Group,$this->Name);
			if($this->Num==null){$this->Num=0;}
			if (!isset($Prop))
					{$SQL="INSERT INTO ws_properties(SiteID,Grp,Name,Text,Num) VALUES (".$_SESSION["SITE_ID"].",'" . $this->Group . "','" . $this->Name . "','" . $this->Text . "','" . $this->Num . "')";}
			else
					{$SQL="UPDATE ws_properties SET Text='".$this->Text."',Num=".$this->Num." where SiteID=".$_SESSION["SITE_ID"]." and Grp='" . $this->Group . "' and Name='" . $this->Name . "'";}

			$this->WSDB->query($SQL);
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Delete()
	{
		try
		{
			$SQL="DELETE FROM ws_properties where SiteID=".$_SESSION["SITE_ID"]." and Grp='" . $this->Group . "' and Name='" . $this->Name . "'";
			$this->WSDB->query($SQL);
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Load($Group,$Name)
	{
		try
		{
			$SQL="select * from ws_properties where SiteID=".$_SESSION["SITE_ID"]." and Grp='" . $Group . "' and Name='" . $Name . "'";
			$Res = $this->WSDB->query($SQL);
			if($Res->num_rows != 0)
			{
				$Row = $Res->fetch_assoc();
				$this->Group = $Row["Grp"];
				$this->Name = $Row["Name"];
				$this->Text = $Row["Text"];
				$this->Num = $Row["Num"];
			}
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function Get($Group,$Name,$DB=null)
	{
		$P=new WS_Property($DB);
		$P->Load($Group,$Name);
		if ($P->Group=="") {return null;}
		return $P;
	}
	
	public static function GetText($Group,$Name,$DB=null)
	{
		$P=WS_Property::Get($Group,$Name,$DB);
		if ($P==null) {return null;}
		return $P->Text;
	}
	
	public static function GetNum($Group,$Name,$DB=null)
	{
		$P=WS_Property::Get($Group,$Name,$DB);
		if ($P==null) {return null;}
		return $P->Num;
	}
	
	public static function SetText($Group,$Name,$Text,$DB=null)
	{
		$Prop=WS_Property::Get($Group,$Name);
		if (!isset($Prop))
		{
			$Prop=new WS_Property($DB);
			$Prop->Name=$Name;
			$Prop->Group=$Group;
		}
		$Prop->Text=$Text;
		$Prop->Update();
	}
	
	public static function SetNum($Group,$Name,$Num,$DB=null)
	{
		$Prop=WS_Property::Get($Group,$Name);
		if (!isset($Prop))
		{
			$Prop=new WS_Property($DB);
			$Prop->Name=$Name;
			$Prop->Group=$Group;
		}
		$Prop->Num=$Num;
		$Prop->Update();
	}
	
	public static function GetAll($DB=null)
	{
		try
		{
			if (!isset($DB))
				{$DB=WS::$WSBase->WSDB;}

			$Props = array();
			$SQL="select Grp,Name,Num,Text from ws_properties order by Grp,Name";
			$Res = $DB->query($SQL);
			for ($R=0;$R<$Res->num_rows;$R++)
			{
				$Row = $Res->fetch_assoc();
				$P = new WS_Property($DB);
				$P->Group = $Row["Grp"];
				$P->Name = $Row["Name"];
				$P->Text = $Row["Text"];
				$P->Num = $Row["Num"];
				array_push($Props,$P);
			}
			return $Props;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
}

class WS_Pay
{
	public $TransactionID="";
	public $PayAccount="";
	public $DT;
	public $UserID=0;
	public $Tag="";
	public $Quantity=0;
	public $Import=0;
	public $Shipping=0;
	public $Currency="";
	public $ItemName="";
	public $Description="";
	public $Success=-1;
	public $Ret_verify_sign="";
	public $Ret_txn_type="";
	public $Ret_txn_id="";
	public $Ret_shipping=0;
	public $Ret_residence_country="";
	public $Ret_quantity=0;
	public $Ret_protection_eligibility="";
	public $Ret_pending_reason="";
	public $Ret_payment_type="";
	public $Ret_payment_status="";
	public $Ret_payment_gross=0;
	public $Ret_payment_date="";
	public $Ret_payer_status="";
	public $Ret_payer_id="";
	public $Ret_payer_email="";
	public $Ret_notify_version="";
	public $Ret_mc_gross=0;
	public $Ret_mc_currency="";
	public $Ret_last_name="";
	public $Ret_first_name="";
	public $Ret_custom="";
	public $Ret_business="";
	public $Ret_address_zip="";
	public $Ret_address_street="";
	public $Ret_address_state="";
	public $Ret_address_name="";
	public $Ret_address_country_code="";
	public $Ret_address_city="";
	
	public static function GenerateTansactionID()
	{
		try
		{
			do
			{
				$WSDB=WS::$WSBase->WSDB;
				$ID=MD5(date("Y-m-d H:i:s").rand().rand().rand());
				$SQL = "SELECT * FROM ws_pay WHERE SiteID=".$_SESSION["SITE_ID"]." AND TransactionID='".$ID."'";
				$result = $WSDB->query($SQL);
			}
			while($result->num_rows > 0);
			return $ID;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetByTansactionID($TransactionID)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$Pay=null;
			$SQL = "SELECT * FROM ws_pay WHERE SiteID=".$_SESSION["SITE_ID"]." AND TransactionID='".$TransactionID."'";
			$result = $WSDB->query($SQL);
			if($result->num_rows == 1)
			{
				$row = $result->fetch_assoc();
				$Pay = new WS_Pay();
				$Pay->LoadRow($row);
			}
			return $Pay;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetByTag($Tag)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$Pay=null;
			$SQL = "SELECT * FROM ws_pay WHERE SiteID=".$_SESSION["SITE_ID"]." AND Tag='".$Tag."'";
			$result = $WSDB->query($SQL);
			if($result->num_rows == 1)
			{
				$row = $result->fetch_assoc();
				$Pay = new WS_Pay();
				$Pay->LoadRow($row);
			}
			return $Pay;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function GetByItemName($ItemName)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$Pay=null;
			$SQL = "SELECT * FROM ws_pay WHERE SiteID=".$_SESSION["SITE_ID"]." AND ItemName='".$ItemName."'";
			$result = $WSDB->query($SQL);
			if($result->num_rows == 1)
			{
				$row = $result->fetch_assoc();
				$Pay = new WS_Pay();
				$Pay->LoadRow($row);
			}
			return $Pay;
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	private function LoadRow($row)
	{
		$this->TransactionID=$row["TransactionID"];
		$this->PayAccount=$row["PayAccount"];
		$this->DT=$row["DT"];
		$this->UserID=$row["UserID"];
		$this->Tag=$row["Tag"];
		$this->Quantity=$row["Quantity"];
		$this->Import=$row["Import"];
		$this->Shipping=$row["Shipping"];
		$this->Currency=$row["Currency"];
		$this->ItemName=$row["ItemName"];
		$this->Description=$row["Description"];
		$this->Success=boolval($row["Success"]);
		
		$this->Ret_verify_sign=$row["Ret_verify_sign"];
		$this->Ret_txn_type=$row["Ret_txn_type"];
		$this->Ret_txn_id=$row["Ret_txn_id"];
		$this->Ret_shipping=$row["Ret_shipping"];
		$this->Ret_residence_country=$row["Ret_residence_country"];
		$this->Ret_quantity=$row["Ret_quantity"];
		$this->Ret_protection_eligibility=$row["Ret_protection_eligibility"];
		$this->Ret_pending_reason=$row["Ret_pending_reason"];
		$this->Ret_payment_type=$row["Ret_payment_type"];
		$this->Ret_payment_status=$row["Ret_payment_status"];
		$this->Ret_payment_gross=$row["Ret_payment_gross"];
		$this->Ret_payment_date=$row["Ret_payment_date"];
		$this->Ret_payer_status=$row["Ret_payer_status"];
		$this->Ret_payer_id=$row["Ret_payer_id"];
		$this->Ret_payer_email=$row["Ret_payer_email"];
		$this->Ret_notify_version=$row["Ret_notify_version"];
		$this->Ret_mc_gross=$row["Ret_mc_gross"];
		$this->Ret_mc_currency=$row["Ret_mc_currency"];
		$this->Ret_last_name=$row["Ret_last_name"];
		$this->Ret_first_name=$row["Ret_first_name"];
		$this->Ret_custom=$row["Ret_custom"];
		$this->Ret_business=$row["Ret_business"];
		$this->Ret_address_zip=$row["Ret_address_zip"];
		$this->Ret_address_street=$row["Ret_address_street"];
		$this->Ret_address_state=$row["Ret_address_state"];
		$this->Ret_address_name=$row["Ret_address_name"];
		$this->Ret_address_country_code=$row["Ret_address_country_code"];
		$this->Ret_address_city=$row["Ret_address_city"];
	}
	
	public function Update()
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$Upd=false;
			if ($this->TransactionID!="")
			{
				if(WS_Pay::Exists($this->TransactionID)){$Upd=true;}
			}	

			if($Upd)
			{
				if (empty($this->Import)) {$this->Import=0;}
				if (empty($this->Ret_shipping)) {$this->Ret_shipping=0;}
				if (empty($this->Ret_quantity)) {$this->Ret_quantity=0;}
				if (empty($this->Ret_payment_gross)) {$this->Ret_payment_gross=0;}
				if (empty($this->Ret_mc_gross)) {$this->Ret_mc_gross=0;}

				$sql = "UPDATE ws_pay SET ";
				$sql .= "PayAccount='".ConnectDB::FormatStr($this->PayAccount)."',";
				$sql .= "DT='".$this->DT."',";
				$sql .= "UserID=".$this->UserID.",";
				$sql .= "Tag='".ConnectDB::FormatStr($this->Tag)."',";
				$sql .= "Quantity=" .$this->Quantity.",";
				$sql .= "Import=".$this->Import.",";
				$sql .= "Shipping=".$this->Shipping.",";
				$sql .= "Currency='".ConnectDB::FormatStr($this->Currency)."',";
				$sql .= "ItemName='".ConnectDB::FormatStr($this->ItemName)."',";
				$sql .= "Description='".ConnectDB::FormatStr($this->Description)."',";
				$sql .= "Success=".$this->Success.",";

				$sql.="Ret_verify_sign='".ConnectDB::FormatStr($this->Ret_verify_sign)."',";
				$sql.="Ret_txn_type='".ConnectDB::FormatStr($this->Ret_txn_type)."',";
				$sql.="Ret_txn_id='".ConnectDB::FormatStr($this->Ret_txn_id)."',";
				$sql.="Ret_shipping=".$this->Ret_shipping.",";
				$sql.="Ret_residence_country='".ConnectDB::FormatStr($this->Ret_residence_country)."',";
				$sql.="Ret_quantity=".$this->Ret_quantity.",";
				$sql.="Ret_protection_eligibility='".ConnectDB::FormatStr($this->Ret_protection_eligibility)."',";
				$sql.="Ret_pending_reason='".ConnectDB::FormatStr($this->Ret_pending_reason)."',";
				$sql.="Ret_payment_type='".ConnectDB::FormatStr($this->Ret_payment_type)."',";
				$sql.="Ret_payment_status='".ConnectDB::FormatStr($this->Ret_payment_status)."',";
				$sql.="Ret_payment_gross=".$this->Ret_payment_gross.",";
				$sql.="Ret_payment_date='".ConnectDB::FormatStr($this->Ret_payment_date)."',";
				$sql.="Ret_payer_status='".ConnectDB::FormatStr($this->Ret_payer_status)."',";
				$sql.="Ret_payer_id='".ConnectDB::FormatStr($this->Ret_payer_id)."',";
				$sql.="Ret_payer_email='".ConnectDB::FormatStr($this->Ret_payer_email)."',";
				$sql.="Ret_notify_version='".ConnectDB::FormatStr($this->Ret_notify_version)."',";
				$sql.="Ret_mc_gross=".$this->Ret_mc_gross.",";
				$sql.="Ret_mc_currency='".ConnectDB::FormatStr($this->Ret_mc_currency)."',";
				$sql.="Ret_last_name='".ConnectDB::FormatStr($this->Ret_last_name)."',";
				$sql.="Ret_first_name='".ConnectDB::FormatStr($this->Ret_first_name)."',";
				$sql.="Ret_custom='".ConnectDB::FormatStr($this->Ret_custom)."',";
				$sql.="Ret_business='".ConnectDB::FormatStr($this->Ret_business)."',";
				$sql.="Ret_address_zip='".ConnectDB::FormatStr($this->Ret_address_zip)."',";
				$sql.="Ret_address_street='".ConnectDB::FormatStr($this->Ret_address_street)."',";
				$sql.="Ret_address_state='".ConnectDB::FormatStr($this->Ret_address_state)."',";
				$sql.="Ret_address_name='".ConnectDB::FormatStr($this->Ret_address_name)."',";
				$sql.="Ret_address_country_code='".ConnectDB::FormatStr($this->Ret_address_country_code)."',";
				$sql.="Ret_address_city='".ConnectDB::FormatStr($this->Ret_address_city)."'";

				$sql .= " WHERE SiteID=".$_SESSION["SITE_ID"]." and TransactionID='".$this->TransactionID."'";
				$WSDB->query($sql);	
			}
			else
			{
				if ($this->TransactionID=="")
					{$this->TransactionID=GenerateTansactionID();}

				$sql = "INSERT INTO ws_pay (SiteID,TransactionID,PayAccount,DT,UserID,Tag,Quantity,Import,Shipping,Currency,ItemName,Description,Success,";
				$sql .= "Ret_verify_sign,Ret_txn_type,Ret_txn_id,";
				$sql .= "Ret_shipping,Ret_residence_country,Ret_quantity,";
				$sql .= "Ret_protection_eligibility,Ret_pending_reason,";
				$sql .= "Ret_payment_type,Ret_payment_status,Ret_payment_gross,";
				$sql .= "Ret_payment_date,Ret_payer_status,Ret_payer_id,";
				$sql .= "Ret_payer_email,Ret_notify_version,Ret_mc_gross,";
				$sql .= "Ret_mc_currency,Ret_last_name,Ret_first_name,Ret_custom,Ret_business,";
				$sql .= "Ret_address_zip,Ret_address_street,Ret_address_state,";
				$sql .= "Ret_address_name,Ret_address_country_code,Ret_address_city";
				$sql .= ") values (";
				$sql .= $_SESSION["SITE_ID"] . ",";
				$sql .= "'" . $this->TransactionID . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->PayAccount)."',";
				$sql .= "'" . $this->DT->format('Y\-m\-d\ h:i:s') . "',";
				$sql .= $this->UserID.",";
				$sql .= "'" . ConnectDB::FormatStr($this->Tag) . "',";
				$sql .= $this->Quantity . ",";
				$sql .= $this->Import . ",";
				$sql .= $this->Shipping . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->Currency) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->ItemName). "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Description) . "',";
				$sql .= $this->Success . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_verify_sign) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_txn_type) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_txn_id) . "',";
				$sql .= $this->Ret_shipping . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_residence_country) . "',";
				$sql .= $this->Ret_quantity . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_protection_eligibility) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_pending_reason) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_payment_type) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_payment_status) . "',";
				$sql .= $this->Ret_payment_gross . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_payment_date) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_payer_status) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_payer_id) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_payer_email) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_notify_version) . "',";
				$sql .= $this->Ret_mc_gross . ",";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_mc_currency) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_last_name) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_first_name) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_custom). "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_business) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_address_zip) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_address_street) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_address_state) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_address_name) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_address_country_code) . "',";
				$sql .= "'" . ConnectDB::FormatStr($this->Ret_address_city) . "')";

				$WSDB->query($sql);	
			}
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public function Delete()
	{
		try
		{
			if ($this->TransactionID=="") {return;}
			$WSDB=WS::$WSBase->WSDB;
			$SQL = "delete from ws_pay WHERE SiteID=".$_SESSION["SITE_ID"]." AND TransactionID=".$this->TransactionID;
			$WSDB->query($SQL);
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
	
	public static function Exists($TransactionID)
	{
		try
		{
			$WSDB=WS::$WSBase->WSDB;
			$sql = "select TransactionID from ws_pay WHERE SiteID=".$_SESSION["SITE_ID"]." and TransactionID='".$TransactionID."'";
			$result = $WSDB->query($sql); 
			if($result->num_rows == 1)
				{return true;}
			else
				{return false;}
		} 
		catch (Exception $e)
		{
			echo 'ERROR: ', $e->getMessage(), "\n";
		}
	}
}

class WS_Cookie
 {
	public static function Get($Name)
	{
		if (isset($_COOKIE["WS_".$Name])) {return $_COOKIE["WS_".$Name];}
		if (isset($_SESSION["WS_COOKIE_".$Name])) {return $_SESSION["WS_COOKIE_".$Name];}
	}
	
	public static function Is_Set($Name)
	{
		if ( isset($_COOKIE["WS_".$Name]) || isset($_SESSION["WS_COOKIE_".$Name])) {return true;}
		return false;
	}
	
	public static function Set($Name,$Value,$Timeout=150)
	{
		$Timeout *= 86400; /* DAYS CALC */ 
		
//		$arr_cookie_options = array (
//                'expires' => time() + $Timeout,
//                'path' => '/',
//                'domain' => $_SERVER["HTTP_HOST"], // leading dot for compatibility or use subdomain
//                'secure' => false,     // or false
//                'httponly' => false,    // or false
//                'samesite' => 'None' // None || Lax  || Strict
//                );
		
		$_SESSION["WS_COOKIE_".$Name] = $Value;
		setcookie("WS_".$Name, $Value, time() + $Timeout,"/");
		
	}
}