<?php

class WS_SearchEngine
{
	private $DB;
	public $Lang=null;
	private $Exclusion = array();
	private $unwanted_array;
	
	public function __construct($DB)
	{
		$this->DB = $DB;
		$this->unwanted_array = array('Š'=>'S', 'š'=>'s', 'Ž'=>'Z', 'ž'=>'z', 'À'=>'A', 'Á'=>'A', 'Â'=>'A', 'Ã'=>'A', 'Ä'=>'A', 'Å'=>'A', 'Æ'=>'A', 'Ç'=>'C', 'È'=>'E', 'É'=>'E',
		'Ê'=>'E', 'Ë'=>'E', 'Ì'=>'I', 'Í'=>'I', 'Î'=>'I', 'Ï'=>'I', 'Ñ'=>'N', 'Ò'=>'O', 'Ó'=>'O', 'Ô'=>'O', 'Õ'=>'O', 'Ö'=>'O', 'Ø'=>'O', 'Ù'=>'U',
		'Ú'=>'U', 'Û'=>'U', 'Ü'=>'U', 'Ý'=>'Y', 'Þ'=>'B', 'ß'=>'Ss', 'à'=>'a', 'á'=>'a', 'â'=>'a', 'ã'=>'a', 'ä'=>'a', 'å'=>'a', 'æ'=>'a', 'ç'=>'c',
		'è'=>'e', 'é'=>'e', 'ê'=>'e', 'ë'=>'e', 'ì'=>'i', 'í'=>'i', 'î'=>'i', 'ï'=>'i', 'ð'=>'o', 'ñ'=>'n', 'ò'=>'o', 'ó'=>'o', 'ô'=>'o', 'õ'=>'o',
		'ö'=>'o', 'ø'=>'o', 'ù'=>'u', 'ú'=>'u', 'û'=>'u', 'ý'=>'y', 'ý'=>'y', 'þ'=>'b', 'ÿ'=>'y', 
		','=>' ',';'=>' ',':'=>' ','.'=>' ','-'=>' ','+'=>' ',
		'?'=>' ','\''=>' ','^'=>' ','='=>' ','/'=>' ','!'=>' ',
		'\\'=>' ','|'=>' ','<'=>' ','>'=>' ','>'=>'\"','*'=>' ',
		'['=>' ',']'=>' ','('=>' ' ,')'=>' ','"'=>' ','\n'=>' ','\r'=>' ','\t'=>' ');
	}
	
	public function TextEscape($Text)
	{
		foreach($this->unwanted_array as $K => $V)
		{
			$Text = str_replace($K, $V, $Text);
		}
		return $Text;
	}
	
	public function TextToWords($Text,$Limit=0)
	{
		$Text = $this->TextEscape($Text);
		
		while (strpos($Text,"  ")!==false)
		{
			$Text = str_replace("  ", " ", $Text);
		}
		
		$Words = explode(' ',strtolower($Text));
		
		for($N=0;$N<count($Words);$N++)
		{
			if (strlen($Words[$N])>25)
				{$Words[$N]=substr($Words[$N],0,25);}
				
			if (strlen($Words[$N])<4) 
				{unset($Words[$N]);}
		}
		
		if ($Limit>0)
			{array_splice($Words,$Limit);}
		
		return $Words;
	}
	
	public function GetKeyWordID($KeyType,$Lang,$KeyWord)
	{
		$Sql="select ID_Dictionary from ws_search_dictionary where KeyType='".$KeyType."' and Lang='".$Lang."' and KeyWord='".$KeyWord."'";
		$Result=$this->DB->query($Sql);
		if ($Result->num_rows>0)
		{
			$Row = $Result->fetch_assoc();
			return $Row["ID_Dictionary"];
		}
		else
		{
			$ID = 0;
			$Sql="select MAX(ID_Dictionary) as M from ws_search_dictionary";
			$Result=$this->DB->query($Sql);
			if ($Result->num_rows>0)
			{
				$Row = $Result->fetch_assoc();
				$ID = $Row["M"]+1;
			}
			$Sql="insert into ws_search_dictionary (ID_Dictionary,KeyType,Lang,KeyWord,SearchCount) values (".$ID.",'".$KeyType."','".$Lang."','".$KeyWord."',0)";
			$Result=$this->DB->query($Sql);
			
			return $ID;
		}
	}
	
	public function AddKeyWord($ID_Data,$KeyType,$Lang,$KeyWord)
	{
		$ID = $this->GetKeyWordID($KeyType,$Lang,$KeyWord);
		$Sql = "select ID_Dictionary from ws_search_keys where ID_Data=".$ID_Data." and ID_Dictionary=".$ID;
		$Result=$this->DB->query($Sql);
		if ($Result->num_rows==0)
		{
			$Sql = "insert into ws_search_keys (ID_Data,ID_Dictionary) values (".$ID_Data.",".$ID.")";
			$this->DB->query($Sql);
		}
	}
	
	public function ClearKeyWords($ID_Data)
	{
		$Sql = "delete from ws_search_keys where ID_Data=".$ID_Data;
		$this->DB->query($Sql);
	}
	
	public function IndexingText($ID_Insertion,$KeyType,$Lang,$Text,$Limit=0)
	{
		$Words = $this->TextTOWords($Text,$Limit);
		foreach ($Words as $W)
		{
			$this->AddKeyWord($ID_Insertion,$KeyType,$Lang,$W);
		}
	}
	
	public function SearchBuilder($Text="",$DataTableName,$OrderBy="")
	{
		if ($FilterW=="") {return "";}
	
		// SELECT THE KEY
		$FilterW = "";
		$Words = $this->TextTOWords($Text);
		foreach ($Words as $W) 
		{
			if ($FilterW!= "") {$FilterW.=" or ";}
			$FilterW .= "d.KeyWord='".$W."'";
		}
		
		$Sql = "select ".DataTableName.".*";
		$SqlFrom=" from ".DataTableName." ";

		if ($FilterW=="") {return "";}
		
		$SqlFrom .= " inner join ws_search_keys k on i.ID_Insertion = k.ID_Data";
		$SqlFrom .= " inner join ws_search_dictionary d on d.ID_Dictionary = k.ID_Dictionary";
	
		$Filter="";
		if ($FilterW!="")
		{
			$KeysSql = "select k.ID_Data from ws_search_keys k ";
			$KeysSql .= " inner join ws_search_dictionary d on d.ID_Dictionary = k.ID_Dictionary ";
			$KeysSql .= " where (".$FilterW.")";
			$KeysSql .= " group by k.ID_Data order by count(ID_Data)";
		}
		
		$Filter .= " i.ID_Data in (".$KeysSql.")";
		
		// GROUP AND ORDER
		$Ret = $Sql . $SqlFrom." where ".$Filter;
			
		$a = strlen($Ret);
		
		return $Ret;
	}
}

?>

