<?php

class WS_Translator
{
	public static $Content;
	public $SourceLang = "EN";
	public $Dictionary = array();
	public $DictionaryFile="Dictionary.txt";
	public $BaseLang;
	public $Lang;
	private $BTranslationKey = '6A51E9392D438BB92362A35996007D776ADE7B65';
	
	public static function Init($DictionaryFile,$BaseLang="en")
	{
		$Key = WS_Property::Get("Translator", "BingKey");
		if (isset($Key)) {$this->BTranslationKey=$Key;}
		if (!isset($_SESSION["LANG"])) {$_SESSION["LANG"] = $BaseLang;}
		if (isset($_GET["Lang"])) {$_SESSION["LANG"] = $_GET["Lang"];}
		$T = new WS_Translator();
		$T->DictionaryFile = $DictionaryFile;
		$T->BaseLang = $BaseLang;
		$T->LoadDictionary();
		
		return $T;
	}
	
	public function LoadDictionary()
	{
		if (file_exists($this->DictionaryFile))
		{
			$Content=file_get_contents($this->DictionaryFile);
			$Content= str_replace("\r\n","\n",$Content);
			$Row=explode("\n",$Content);

			foreach ($Row as $R)
			{
				$Val = explode("\0",$R);
				if ($Val[0] == strtolower($_SESSION["LANG"]))
				{
					try
					{
						$Val[1] = str_replace("\\n", "\n",$Val[1]);
						$Val[1] = str_replace("\\\\", "\\",$Val[1]);
						$Val[2] = str_replace("\\n", "\n",$Val[2]);
						$Val[2] = str_replace("\\\\", "\\",$Val[2]);
						$this->Dictionary[$Val[1]] = $Val[2];
					}
					catch(Exception $e) 
					{
					}
				}
			}
		}
	}
	
	public function TranslReqBing($InLang, $OutLang, $Text)
	{
		if ($InLang == $OutLang) {return $Text;}
		$UrlText = str_replace(" ", "%20", $Text);
		$uri = "http://api.microsofttranslator.com/V2/Http.svc/Translate?appId=" . $this->BTranslationKey . "&text=" . $UrlText . "&from=" . $InLang . "&to=" . $OutLang;

		ini_set('default_socket_timeout', 30000);
		
		try
		{
			$dh = fopen($uri,'r');
			$Result = fread($dh,8192);
			if($Result !== False)
			{
				if (substr($Result,0,68) != "<string xmlns=\"http://schemas.microsoft.com/2003/10/Serialization/\">") return "";
				$Result = substr($Result, 68, strlen($Result)-68);
				$Result = substr($Result, 0, strlen($Result)-9);
				if ($Result != "") {return $Result;}
			}
		}
		catch(MalformedURLException $Ex){}
		
		return "";
	}
	
	public function TranslReqYandex($InLang, $OutLang, $Text)
	{
		return "";
		if ($InLang == $OutLang) {return $Text;}
		$UrlText = str_replace(" ", "%20", $Text);
		$BTranslationKey = 'trnsl.1.1.20161115T232059Z.848ddbd9244b01ab.ac1989f10e04cc1b8a3cc339db58da724fd24894';
		$uri = "https://translate.yandex.net/api/v1.5/tr.json/translate?key=" . $BTranslationKey . "&text=" . $UrlText . "&hint=" . $InLang . "&lang=" . $OutLang;

		ini_set('default_socket_timeout', 30000);
		
		try
		{
			$dh = fopen($uri,'r');
			$Result = fread($dh,8192);
			if($Result !== False)
			{
				$Json = json_decode ($Result);
				return $Json->text;
			}
		}
		catch(MalformedURLException $Ex){}
		
		return "";
	}
	
	public function TranslReq($InLang, $OutLang, $Text)
	{
		if ($InLang == $OutLang) {return $Text;}
		$UrlText = str_replace(" ", "%20", $Text);
		ini_set('default_socket_timeout', 30000);
		
		for($N=0;$N<3;$N++)
		{
			try
			{
				$Result = $this->TranslReqBing($InLang, $OutLang, $Text);

				if($Result != "")
				{
			 		return $Result;
				}
				else
				{
					$Result = $this->TranslReqYandex($InLang, $OutLang, $Text);
					if($Result != "")
					{
						return $Result;
					}
				}
			}
			catch(MalformedURLException $Ex){}
		}
		return "";
	}
	
	public function Translate($OriginalText,$OriginalLang="",$DestinationLang="",$Cacheing=true)
	{
		if($OriginalLang=="") {$OriginalLang=$this->BaseLang;}
		if($DestinationLang=="") {$DestinationLang=$_SESSION["LANG"];}
		
		if ($OriginalLang == $DestinationLang) return $OriginalText;
		
		if (isset($this->Dictionary[$OriginalText]))
		{
			if (empty($this->Dictionary[$OriginalText]) == true)
				{return $OriginalText;}
			else
				{return $this->Dictionary[$OriginalText];}
		}
		else
		{
			$TransText = $this->TranslReq(strtolower($OriginalLang), $DestinationLang, $OriginalText);
			if ($TransText != "") 
			{
				if ($Cacheing)
				{
					$Sep="";
					if (file_exists($this->DictionaryFile)) {$Sep = "\n";}
					$myfile = fopen($this->DictionaryFile, "a+");
					
					$OriginalText = str_replace("\\\\n", "\n",$OriginalText);
					$OriginalText = str_replace("\\", "\\\\",$OriginalText);
					$OriginalText = str_replace("\n", "\\n",$OriginalText);
					
					$TransText = str_replace("\\\\n", "\n",$TransText);
					$TransText = str_replace("\\", "\\\\",$TransText);
					$TransText = str_replace("\n", "\\n",$TransText);
					
					fwrite($myfile,$Sep.strtolower($_SESSION["LANG"])."\0".$OriginalText."\0".$TransText);
					fclose($myfile);
					$this->Dictionary[$OriginalText] = $TransText;
					WS_Translator::$Content=null;
				}
				return $TransText;
			}
			else
			{
				return $OriginalText;
			}
			
		}
	}
	
	public function Write($OriginalText)
	{
		echo $this->Translate($OriginalText);
	}
}
?>
