<?php

class WS_TreeView
{

	// PRIVATE
	private $Script = "";
	private static $WS_TreeViewCss = false;
	// PUBLIC
	public $CssFile = "WS_TreeView.css";
	public $PageID = "0";
	public $SlotID = "TREE_VIEW";
	
	// CAN REGISTER ON FILE OR ON DB
	public $DataFile = "";				// DATA REGISTRATION FILE 
	public $DB;					// DATA REGISTRATION DB 
	public $TableName = "ws_treeview";		// DATA REGISTRATION DB TABLE 
	public $RootName = "Root";			// ROOT NODE NAME
	public $TreeRows = array();			// NODE STRUCTURE LIST
	public $SelectedPath = "";			// SELECTED LEAF ON START
	
	// CSS STYLES
	public $SelectedBackgroundColor = "silver";			 // OBSOLETE (TO REMOVE)
	public $CssStyle = "";								  // OBSOLETE (TO REMOVE)
	public $TreeButtonCssStyle = "";						// OBSOLETE (TO REMOVE)
	public $EditButtonCssStyle = "";						// OBSOLETE (TO REMOVE)
	public $LabelCssStyle = "";							 // OBSOLETE (TO REMOVE)
        
	public $PostValueID = "WS_SubimtTreeView_Path";		 // THE POST FIELD ID WITH SELECTES NODE PATH
    public $OnClickSubmit = false;		                // SUBMIT ON LEEF CLICK
    public $OnClickJSFunction = "";		                // ON CLICK JAVASCRIPT FUNCTION
        
	public $User = "guest";				        // THE CURRENT USER (admin can aloways edit)
	public $EditMode = false;				// IN ADMIN MODE IS ALLWAYS EDITABLE

	public $OpenSimbol = "+";				// TREE OPEN SIMPOL
	public $CloseSimbol = "-";				// TREE CLOSE SIMPOL
	public $CurrentLang = "en";                             // DEFAULT LANGUAGE

	public function __construct()
	{
		//echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . $this->CssFile . "\"/>";

		$this->Script = "<input type=\"hidden\" value=\"\" id=\"WS_SubimtTreeView_SlotID\" name=\"WS_TreeView_SlotID\">\n";
		$this->Script .= "<input type=\"hidden\" value=\"\" id=\"" . $this->PostValueID . "\"name=\"" . $this->PostValueID . "\" value=\"" . $this->SelectedPath . "\">\n";

		$this->Script .= "<script>\n";
		$this->Script .= "function WsTreeSubmit(SlotID,Path)\n";
		$this->Script .= "{\n";
		$this->Script .= "document.getElementById('WS_SubimtTreeView_SlotID').value=SlotID;\n";
		$this->Script .= "document.getElementById('" . $this->PostValueID . "').value=Path;\n";
		$this->Script .= "document.forms[0].submit();\n";
		$this->Script .= "}\n\n";

		$this->Script .= "function WsTreeOnClick(obj,OBJ_ID,Path,NodeType,Link,AdminPermisions,ViewPermisions,Text,Expanded)\n";
		$this->Script .= "{\n";
		$this->Script .= "document.getElementById(OBJ_ID+'NodePath').value=Path;\n";
		$this->Script .= "document.getElementById(OBJ_ID+'NodeLink').value=Link;\n";
		$this->Script .= "document.getElementById(OBJ_ID+'NodeType').value=NodeType;\n";
		$this->Script .= "document.getElementById(OBJ_ID+'NodeAdminPermisions').value=AdminPermisions;\n";
		$this->Script .= "document.getElementById(OBJ_ID+'NodeViewPermisions').value=ViewPermisions;\n";
		$this->Script .= "document.getElementById(OBJ_ID+'NodeText').value=Text;\n";
		$this->Script .= "document.getElementById(OBJ_ID+'NodeExpanded').checked=Expanded;\n";
		$this->Script .= "if (NodeType=='L') {WsTreeSetCookieSelected(Path);}\n";
		$this->Script .= "if (NodeType=='F')\n{\n";
		$this->Script .= "document.getElementById(OBJ_ID+'NodeLink').style.display='none';\n";
		$this->Script .= "document.getElementById(OBJ_ID+'NodeLink').value='';\n";
		$this->Script .= "}\n\n";

		$this->Script .= "if (NodeType=='L'){\n";
		$this->Script .= "var Elems = document.getElementsByClassName('TreeView_Leaf');\n";
		//$this->Script .= "for(N=0;N<Elems.length;N++) Elems[N].style.backgroundColor='transparent';";
		$this->Script .= "for(N=0;N<Elems.length;N++) Elems[N].classList.remove('TreeView_SelectedNode');";
		$this->Script .= "if (obj.tagName=='div')obj.style.backgroundColor='" . $this->SelectedBackgroundColor . "';\n}\n";
		$this->Script .= "obj.classList.add('TreeView_SelectedNode');\n";
		$this->Script .= "document.getElementById('" . $this->PostValueID . "').value=Path;\n";
		$this->Script .= "}\n\n";

		$this->Script .= "function WsTreeShowPopup(OBJ_ID)\n";
		$this->Script .= "{\n";
		$this->Script .= "document.getElementById(OBJ_ID+'WS_TreeView_Popup').style.display='inline';\n";
		$this->Script .= "}\n";

		$this->Script .= "function WsTreeSetCookieExpand(OBJ_ID,Expanded)\n{\n";
		$this->Script .= "d = new Date();";
		$this->Script .= "d.setTime(d.getTime() + (24*60*60*1000));\n";
		$this->Script .= "let expires = 'expires'+ d.toUTCString();\n";
		$this->Script .= "document.cookie = OBJ_ID + \"=\" + Expanded + \";\" + expires + \";path='/';\"\n";
		$this->Script .= "}\n\n";
		
		$this->Script .= "function WsTreeSetCookieSelected(Path)\n{\n";
		$this->Script .= "d = new Date();";
		$this->Script .= "d.setTime(d.getTime() + (10*60*1000));\n";  // DURA SOLO 10'
		$this->Script .= "let expires = 'expires'+ d.toUTCString();\n";
		$this->Script .= "document.cookie = \"TREEWIEW_SELECT_PATH=\" + Path + \";\" + expires + \";path='/';\"\n";
		$this->Script .= "}\n\n";
		
		$this->Script .= "</script>\n";

		if (isset(WS::$WSBase))
		{
			if (isset(WS::$WSBase->WSDB))
			{
				$this->DB = WS::$WSBase->WSDB;
			}
		}
	}

	public function CreateRoot($RootName = "Root")
	{
		if (count($this->TreeRows) == 0)
		{
			$Row = new WS_TreeViewRow();
			$Row->RecID = 0;
			$Row->PageID = $this->PageID;
			$Row->SlotID = $this->SlotID;
			$Row->Path = $RootName;
			$Row->ViewPermisions = "all";
			$Row->AdminPermisions = "admin";
			$Row->Text = "";
			$Row->Lang = $this->CurrentLang;
			$Row->Expanded = false;
			array_push($this->TreeRows, $Row);

			if (isset($this->DB))
			{
				$this->SaveToDB();
			}
			if ($this->DataFile != "")
			{
				SaveToFile();
			}
		}
	}

	public function CreateDataTable()
	{
		if (!isset($this->DB))
		{
			echo "Database not set<br/>";
			return;
		}

		if (!$this->TableExists($this->TableName))
		{
			$Sql = "CREATE TABLE `" . $this->TableName . "` (";
			$Sql .= "`RecID` int(11) NOT NULL AUTO_INCREMENT,";
			$Sql .= "`SiteID` int(11) NOT NULL DEFAULT 1,";
			$Sql .= "`PageID` int(11) NOT NULL DEFAULT 0,";
			$Sql .= "`SlotID` varchar(20) NOT NULL DEFAULT '',";
			$Sql .= "`Path` varchar(500) NOT NULL DEFAULT '',";
			$Sql .= "`NodeType` varchar(1) NOT NULL DEFAULT 'F',";
			$Sql .= "`Link` varchar(200) NOT NULL DEFAULT '',";
			$Sql .= "`AdminPermisions` varchar(1000) DEFAULT 'admin',";
			$Sql .= "`ViewPermisions` varchar(5000) DEFAULT 'all',";
			$Sql .= "`Text` varchar(100) NOT NULL DEFAULT '',";
			$Sql .= "`Lang` varchar(2) NOT NULL DEFAULT '',";
			$Sql .= "`Expanded` bit DEFAULT false,";
			$Sql .= "PRIMARY KEY (`RecID`)";
			$Sql .= ") ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";
			$this->DB->query($Sql);

			$Sql = "ALTER TABLE `WS_TreeView` ADD INDEX( `SiteID`, `PageID`, `SlotID`, `Path`)";
			$this->DB->query($Sql);
		}
	}

	public function LoadFromDB()
	{
		if (!isset($this->DB))
		{
			echo "LoadFromDB: Database not set<br/>";
			return;
		}

		$this->CreateDataTable($this->GetRootNode());

		$SiteID = 1;
		if (isset($_SESSION["SITE_ID"]))
		{
			$SiteID = $_SESSION["SITE_ID"];
		}

		$Sql = "select * from " . $this->TableName . " where SiteID=" . $SiteID . " and PageID=" . $this->PageID . " and SlotID='" . $this->SlotID . "'";
		$result = $this->DB->query($Sql);
		$this->TreeRows = array();
		if ($result->num_rows == 0)
		{
			$this->CreateRoot($this->RootName);
		}
		else
		{
			for ($N = 0; $N < $result->num_rows; $N++)
			{
				$R = $result->fetch_assoc();
				$Row = new WS_TreeViewRow();
				$Row->PageID = $R["PageID"];
				$Row->SlotID = $R["SlotID"];
				$Row->Path = $R["Path"];
				$Row->RecID = $R["RecID"];
				$Row->NodeType = $R["NodeType"];
				$Row->Link = $R["Link"];
				$Row->AdminPermisions = $R["AdminPermisions"];
				$Row->ViewPermisions = $R["ViewPermisions"];
				$Row->Text = $R["Text"];
				$Row->Lang = $R["Lang"];
				$Row->Expanded = $R["Expanded"];
				array_push($this->TreeRows, $Row);
			}
		}
	}

	public function SaveToDB()
	{
		if (!isset($this->DB))
		{
			echo "SaveToDB: Database not set<br/>";
			return;
		}

		$this->CreateDataTable($this->GetRootNode());
		$this->CreateRoot($this->RootName);

		$SiteID = 1;
		if (isset($_SESSION["SITE_ID"]))
		{
			$SiteID = $_SESSION["SITE_ID"];
		}

		foreach ($this->TreeRows as $Row)
		{
			if ($Row->RecID < 0)
			{
				$Sql = "delete from " . $this->TableName . " where RecID=" . ($Row->RecID * (-1));
				$this->DB->query($Sql);
				foreach (array_keys($this->TreeRows) as $K)
				{
					if ($this->TreeRows[$K]->Path == $Row->Path)
					{
						unset($this->TreeRows[$K]);
					}
				}
				continue;
			}

			if ($Row->Expanded)
			{
				$Expanded = "true";
			}
			else
			{
				$Expanded = "false";
			}

			if ($Row->RecID > 0)
			{
				$Sql = "update " . $this->TableName . " set Link='" . $Row->Link . "',AdminPermisions='" . $Row->AdminPermisions . "',ViewPermisions='" . $Row->ViewPermisions . "',Text='" . $Row->Text . "',Lang='" . $Row->Lang . "',Expanded=" . $Expanded . " where RecID=" . $Row->RecID;
				$this->DB->query($Sql);
			}

			if ($Row->RecID == 0)
			{
				$Sql = "insert into " . $this->TableName . " (SiteID,PageID,SlotID,Path,NodeType,Link,AdminPermisions,ViewPermisions,Text,Lang,Expanded) values (";
				$Sql .= $SiteID . "," . $Row->PageID . ",'" . $Row->SlotID . "','" . $Row->Path . "','" . $Row->NodeType . "','" . $Row->Link . "','" . $Row->AdminPermisions . "','" . $Row->ViewPermisions . "','" . $Row->Text . "','" . $Row->Lang . "'," . $Expanded . ")";
				$this->DB->query($Sql);
				$Row->RecID = $this->DB->insert_id;
			}
		}
	}

	public function TableExists($Table)
	{
		$Result = $this->DB->query("SHOW TABLES LIKE '" . $Table . "'");
		if ($Result->num_rows == 1)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	public function LoadFromFile()
	{
		if ($this->DataFile == "")
		{
			echo "Missing DataFile proprtty, can't load";
			exit();
		}

		if (file_exists($this->DataFile))
		{
			$Dat = file_get_contents($this->DataFile);
			$DataRows = explode("\n", $Dat);
			$this->TreeRows = array();
			foreach ($DataRows as $DataRow)
			{
				$Row = new WS_TreeViewRow();
				$Row->LoadFromString($DataRow);
				if (($Row->PageID == $this->PageID) && ($Row->SlotID == $this->SlotID))
					array_push($this->TreeRows, $Row);
			}
		}
	}

	public function SaveToFile()
	{
		$Rows = array();
		if (file_exists($this->DataFile))
		{
			$Dat = file_get_contents($this->DataFile);
			$StrRows = explode("\n", $Dat);

			foreach ($StrRows as $StrRow)
			{
				$Row = new WS_TreeViewRow();
				$Row->LoadFromString($StrRow);
				if (($Row->PageID != $this->PageID) || ($Row->SlotID != $this->SlotID))
				{
					array_push($Rows, $Row);
				}
			}
		}

		foreach ($this->TreeRows as $Row)
		{
			if ($Row->RecID >= 0)
			{
				array_push($Rows, $Row);
			}
		}

		$StrRows = "";
		foreach ($Rows as $Row)
		{
			if ($StrRows != "")
			{
				$StrRows .= "\n";
			}
			$StrRows .= $Row->ToString();
		}
		file_put_contents($this->DataFile, $StrRows);
	}

	public function UpdateNode($NodePath, $NodeType, $NodeLink = "", $AdminPermisions = "admin", $ViewPermisions = "all", $Text = "", $Expanded = false)
	{
		foreach ($this->TreeRows as $Row)
		{
			if ($NodePath == $Row->Path)
			{
				if ($Row->NodeType == "L")
				{
					$Row->NodeType = $NodeType;
				}
				$Row->Link = $NodeLink;
				$Row->AdminPermisions = $AdminPermisions;
				$Row->ViewPermisions = $ViewPermisions;
				$Row->Text = $Text;
				$Row->Lang = $this->CurrentLang;
				$Row->Expanded = $Expanded;
				return true;
			}
		}

		$P = strrchr($NodePath, "/");
		$BasePath = str_replace($P, "", $NodePath);
		foreach ($this->TreeRows as $Row)
		{
			if ($BasePath == $Row->Path)
			{
				$Row = new WS_TreeViewRow();
				$Row->PageID = $this->PageID;
				$Row->SlotID = $this->SlotID;
				$Row->Path = $NodePath;
				$Row->NodeType = $NodeType;
				$Row->NodeLink = $NodeLink;
				$Row->AdminPermisions = $AdminPermisions;
				$Row->ViewPermisions = $ViewPermisions;
				$Row->Text = $Text;
				$Row->Link = $NodeLink;
				$Row->Expanded = $Expanded;

				array_push($this->TreeRows, $Row);
				sort($this->TreeRows);
				return true;
			}
		}

		return false;
	}

	public function DeleteNode($NodeName)
	{
		foreach ($this->TreeRows as $Row)
		{
			if ((strpos($Row->Path, $NodeName) !== false) && ($Row->Path != $NodeName))
			{
				return;
			}
		}
		foreach ($this->TreeRows as $Row)
		{
			if ($Row->Path == $NodeName)
			{
				$Row->RecID *= (-1);
			}
		}
	}

	public function DrawTree($Width = "", $Height = "", $SelectedPath = "")
	{
		echo $this->BuildTreeHtmlCode($Width, $Height, $SelectedPath);
		
		echo "<script>";
		echo "document.getElementById('" . $this->PostValueID . "').value='".$SelectedPath."';\n";
		echo "</script>";
	}

	public function BuildTreeHtmlCode($Width = "", $Height = "", $SelectedPath = "")
	{
		if ($SelectedPath != "")
		{
			$this->SelectedPath = $SelectedPath;
		}

		if (!file_exists($this->CssFile))
		{
			echo "CSS File '" . $this->CssFile . "' not found";
			return;
		}

		$OBJ_ID = $this->PageID . "_" . $this->SlotID . "_";

		// EDIT DIV
		if (isset($_POST[$OBJ_ID . "btnDelNode"]))
		{
			$this->DeleteNode($_POST[$OBJ_ID . "NodePath"]);
			if ((isset($this->DB)) && ($this->TableName != ""))
			{
				$this->SaveToDB();
			}
			if ($this->DataFile != "")
				$this->SaveToFile();
		}

		if (isset($_POST[$OBJ_ID . "btnSaveNode"]))
		{
			$Expanded = false;
			if (isset($_POST[$OBJ_ID . "NodeExpanded"]))
			{
				$Expanded = true;
			}
			$this->UpdateNode($_POST[$OBJ_ID . "NodePath"], $_POST[$OBJ_ID . "NodeType"], $_POST[$OBJ_ID . "NodeLink"], $_POST[$OBJ_ID . "NodeAdminPermisions"], $_POST[$OBJ_ID . "NodeViewPermisions"], $_POST[$OBJ_ID . "NodeText"], $Expanded);
			if ((isset($this->DB)) && ($this->TableName != ""))
				$this->SaveToDB();
			if ($this->DataFile != "")
				$this->SaveToFile();
		}

		if (!WS_TreeView::$WS_TreeViewCss)
		{
			echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . $this->CssFile . "\">";
			echo $this->Script;
			WS_TreeView::$WS_TreeViewCss = true;
		}

		if (isset($_POST[$OBJ_ID . "btnSaveCss"]))
		{
			$CssTxt = $_POST[$OBJ_ID . "EditCssText"];
			file_put_contents(realpath($this->CssFile), $CssTxt);
		}

		if (isset($_POST[$OBJ_ID . "EditCss"]))
		{
			if (file_exists(realpath($this->CssFile)))
			{
				// CSS Popup
				echo "<div id=\"" . $OBJ_ID . "WS_TreeView_Popup\" class=\"TreeView_popup_div\">";
				echo "<table style=\"margin:0px;padding:0px\"><tr><td class=\"TreeView_popup_head\" style=\"width:1%;padding-left:93px\">";
				echo "<input type=\"submit\" value=\"X\" class=\"TreeView_popup_btn_close\" >";
				echo "</td></tr></table>";
				echo "<div id=\"" . $OBJ_ID . "DivEditCss\">";
				$CssTxt = file_get_contents(realpath($this->CssFile));
				echo "<textarea scroll=\"both\" class=\"TreeView_popup_textarea\" id=\"" . $OBJ_ID . "EditCssText\" name=\"" . $OBJ_ID . "EditCssText\">" . $CssTxt . "</textarea>";
				echo "<input id=\"" . $OBJ_ID . "btnSavCss\" name=\"" . $OBJ_ID . "btnSaveCss\" type=\"submit\" value=\"Save\">";
				echo "</div>";
				echo "</div>";
			}
		}

		
		
		
		// POPUP DIV
		echo "<div style=\"display:none;\" id=\"" . $OBJ_ID . "WS_TreeView_Popup\" class=\"TreeView_popup_div\" >";
		echo "<table style=\"margin:0px;padding:0px\"><tr><td class=\"TreeView_popup_head\" style=\"width:1%;padding-left:93px\">";
		echo "<input type=\"button\" value=\"X\" class=\"TreeView_popup_btn_close\" onclick=\"document.getElementById('" . $OBJ_ID . "WS_TreeView_Popup').style.display='none';\">";
		echo "</td></tr></table>";
		echo "<div id=\"" . $OBJ_ID . "DivAddNode\"><table>";
		echo "<tr><td>Path: </td><td><input style=\"width:300px\" id=\"" . $OBJ_ID . "NodePath\" name=\"" . $OBJ_ID . "NodePath\" type=\"text\" value=\"\"></td></tr>";

		echo "<tr><td>Type (F/L): </td><td><select id=\"" . $OBJ_ID . "NodeType\" name=\"" . $OBJ_ID . "NodeType\" onchange=\"if (this.options[this.selectedIndex].value=='F') {document.getElementById('" . $OBJ_ID . "NodeLink').style.display='none';document.getElementById('" . $OBJ_ID . "NodePgList').style.display='none';} else {document.getElementById('" . $OBJ_ID . "NodeLink').style.display='inline';document.getElementById('" . $OBJ_ID . "NodePgList').style.display='inline';}\">";
		echo "<option value=\"F\">Folder</option><option value=\"L\">Leaf</option></select></td></tr>";

		echo "<tr><td>Link: </td><td><input id=\"" . $OBJ_ID . "NodeLink\" name=\"" . $OBJ_ID . "NodeLink\" type=\"text\" value=\"\">";
		$Pages = WS_Page::GetPagesNames();
		echo"<select id=\"" . $OBJ_ID . "NodePgList\" onchange=\"document.getElementById('" . $OBJ_ID . "NodeLink').value=this.options[this.selectedIndex].text + '.php';\">";
		echo "<option value=\"\"></option>";
		foreach ($Pages as $P)
		{
			echo "<option value=\"" . $P . ".php\">" . $P . "</option>";
		}
		echo "</select></td></tr>";

		echo "<tr><td>Admins: </td><td><input id=\"" . $OBJ_ID . "NodeAdminPermisions\" name=\"" . $OBJ_ID . "NodeAdminPermisions\" type=\"text\" value=\"\"></td></tr>";
		echo "<tr><td>Visibility: </td><td><input id=\"" . $OBJ_ID . "NodeViewPermisions\" name=\"" . $OBJ_ID . "NodeViewPermisions\" type=\"text\" value=\"\"></td></tr>";
		echo "<tr><td>View Descr.: </td><td><input id=\"" . $OBJ_ID . "NodeText\" name=\"" . $OBJ_ID . "NodeText\" type=\"text\" value=\"\"></td></tr>";
		echo "<tr><td>Expanded: </td><td><input id=\"" . $OBJ_ID . "NodeExpanded\" name=\"" . $OBJ_ID . "NodeExpanded\" type=\"checkbox\" value=\"\"></td></tr>";
		echo "<tr><td></td><td><input id=\"" . $OBJ_ID . "btnSaveNode\" name=\"" . $OBJ_ID . "btnSaveNode\" type=\"submit\" value=\"Save\">";
		echo "<input id=\"" . $OBJ_ID . "btnDelNode\" name=\"" . $OBJ_ID . "btnDelNode\" type=\"submit\" value=\"Remove\"></td></tr>";
		echo "</table></div>";
		echo "</div>";


		$Style = "";
		if (($Width != "") || ($Height != "") || ($this->CssStyle != ""))
		{
			$Style = " style=\"";
		}
		if ($Width <> "")
		{
			$Style .= "width:" . $Width . ";";
		}
		if ($Height != "")
		{
			$Style .= "height:" . $Height . ";";
		}
		if ($this->CssStyle)
		{
			$Style .= $this->CssStyle . ";";
		}

		if (($Width != "") || ($Height != "") || ($this->CssStyle != ""))
		{
			$Style .= "\" ";
		}

		echo "<div class=\"TreeView_container_div\" " . $Style . " id=\"" . $OBJ_ID . "DivContainer\">";

		if (($this->User == "admin") ||
				$this->EditMode)
		{
			echo "<input id=\"" . $OBJ_ID . "EditCss\" name=\"" . $OBJ_ID . "EditCss\" type=\"submit\" value=\"css\">";
		}

		$this->BuildNodeHtmlCode($this->TreeRows[0]->Path);
		echo "</div>";
	}

	private function BuildNodeHtmlCode($Node)
	{
		if($this->User == "") $this->User="guest";
		$ButtonStyle = "";
		if ($this->TreeButtonCssStyle)
		{
			$Style .= "style=\"" . $this->TreeButtonCssStyle . "\"";
		}
		$EditButtonStyle = "";
		if ($this->EditButtonCssStyle)
		{
			$Style .= "style=\"" . $this->EditButtonCssStyle . "\"";
		}

		$OBJ_ID = $this->PageID . "_" . $this->SlotID . "_";
		$NodeDeep = count(explode("/", $Node));
		

		foreach ($this->TreeRows as $TreeRow)
		{
			if ($TreeRow->Path == $Node)
			{
				if ($this->User != "")
				{
					if (($this->User == "admin") ||
						(strpos($TreeRow->ViewPermisions, $this->User) !== false) ||
						(strpos($TreeRow->ViewPermisions, "all") !== false) ||
							$this->EditMode)
					{
						$Nome = $this->GetNodeName($TreeRow);
						if ($TreeRow->Text != "")
						{
							$Nome = $TreeRow->Text;

							if (isset(WS_Translator::$TranslatorBase))
							{
								$Nome = WS_Translator::$TranslatorBase->Translate($Nome, $TreeRow->Lang, $this->CurrentLang, true);
							}
						}
						$Nome = $TreeRow->TextPrec . $Nome . $TreeRow->TextPost;

						$ID = $OBJ_ID . "WS_TREE-" . str_replace("/", "-", $TreeRow->Path);

						// PRESERVE STATE
						if (!isset($_COOKIE[$ID])) 
							{setcookie($ID, $TreeRow->Expanded, time() + (86400 * 1), "/");}
						else
							$TreeRow->Expanded = intval($_COOKIE[$ID]);
								
						if ($TreeRow->Expanded)
						{
							$Cass = "TreeView_ul_open";
							$Simb = $this->CloseSimbol;
						}
						else
						{
							$Cass = "TreeView_ul_close";
							$Simb = $this->OpenSimbol;
						}

						if (isset($_POST[$ID . "-STAT"]))
						{
							$Simb = $_POST[$ID . "-STAT"];
							if ($_POST[$ID . "-STAT"] == $this->CloseSimbol)
							{
								$Cass = "TreeView_ul_open";
							}
						}
						echo "<input name=\"" . $ID . "-STAT\" id=\"" . $ID . "-STAT\" type=\"hidden\" value=\"" . $Simb . "\">\n";

						$Edit = "";
						if (($this->User == "admin") ||
								(strpos($TreeRow->AdminPermisions, $this->User) !== false) ||
								(strpos($TreeRow->AdminPermisions, "all") !== false) ||
								$this->EditMode)
						{
							$Edit = "<input " . $EditButtonStyle . " class=\"TreeView_edit_btn\" type=\"button\" value=\"...\" "
									. "onclick=\"WsTreeOnClick(this,'" . $OBJ_ID . "',"
									. "'" . $TreeRow->Path . "',"
									. "'" . $TreeRow->NodeType . "',"
									. "'" . $TreeRow->Link . "',"
									. "'" . $TreeRow->AdminPermisions . "',"
									. "'" . $TreeRow->ViewPermisions . "',"
									. "'" . $TreeRow->Text . "',"
									. "'" . $TreeRow->Expanded . "');"
									. "WsTreeShowPopup('" . $OBJ_ID . "');"
									. "\">";
						}

						echo "<li style=\"list-style-type: none;\">";
						echo "<input id=\"" . $ID . "_btnopen\" " . $ButtonStyle . " class=\"TreeView_tree_btn\" type=\"button\" value=\"" . $Simb . "\" "
							."onclick=\"if (this.value=='" . $this->OpenSimbol . "') {"
							."document.getElementById('" . $ID . "-STAT').value='" . $this->CloseSimbol . "';"
							."document.getElementById('" . $ID . "').style.display='inline';"
							."this.value='" . $this->CloseSimbol . "';"
							."WsTreeSetCookieExpand('".$ID."','1');"
							."}else{"
							."document.getElementById('" . $ID . "-STAT').value='" . $this->OpenSimbol . "';"
							."document.getElementById('" . $ID . "').style.display='none';"
							. "this.value='" . $this->OpenSimbol . "';"
							."WsTreeSetCookieExpand('".$ID."','0');"
							. "};\">" . $Edit;
						
						echo "&nbsp;<span style=\"cursor:pointer\" "
							."onclick=\"if (document.getElementById('" . $ID . "_btnopen').value=='" . $this->OpenSimbol . "') {"
							."document.getElementById('" . $ID . "-STAT').value='" . $this->CloseSimbol . "';"
							."document.getElementById('" . $ID . "').style.display='inline';"
							."document.getElementById('" . $ID . "_btnopen').value='" . $this->CloseSimbol . "';"
							."WsTreeSetCookieExpand('".$ID."','1');"
							."}else{"
							."document.getElementById('" . $ID . "-STAT').value='" . $this->OpenSimbol . "';"
							."document.getElementById('" . $ID . "').style.display='none';"
							."document.getElementById('" . $ID . "_btnopen').value='" . $this->OpenSimbol . "';"
							."WsTreeSetCookieExpand('".$ID."','0');"
							. "};"
							. "\"  >" . $Nome . "</span>\n";
						echo "<ul id=\"" . $ID . "\" class=\"TreeView_ul " . $Cass . " \">\n";
					}
				}
			}
			else
			{
				$Deep = $this->GetNodeDeep($TreeRow);
				if ((strpos($TreeRow->Path, $Node . "/") !== false) && ($Deep == $NodeDeep + 1))
				{
					$Nome = $this->GetNodeName($TreeRow);
					if ($TreeRow->Text != "")
					{
						$Nome = $TreeRow->Text;

						if (isset(WS_Translator::$TranslatorBase))
						{
							$Nome = WS_Translator::$TranslatorBase->Translate($Nome, $TreeRow->Lang, $this->CurrentLang, true);
						}
					}
					$Nome = $TreeRow->TextPrec . $Nome . $TreeRow->TextPost;

					if ($TreeRow->NodeType == "F") // FOLDER
					{
						$Param = $TreeRow->Path;
						$this->BuildNodeHtmlCode($Param);
					}
					if ($TreeRow->NodeType == "L") //LAEF
					{
						$Edit = "";

						if (($this->User == "admin") || (strpos($TreeRow->AdminPermisions, $this->User) !== false) || $this->EditMode)
						{
							$Edit = "<input " . $EditButtonStyle . " class=\"TreeView_edit_btn\" type=\"button\" value=\"...\" "
									. "onclick=\"WsTreeOnClick(this,'" . $OBJ_ID . "',"
									. "'" . $TreeRow->Path . "',"
									. "'" . $TreeRow->NodeType . "',"
									. "'" . $TreeRow->Link . "',"
									. "'" . $TreeRow->AdminPermisions . "',"
									. "'" . $TreeRow->ViewPermisions . "',"
									. "'" . $TreeRow->Text . "',"
									. "'" . $TreeRow->Expanded . "');"
									. "WsTreeShowPopup('" . $OBJ_ID . "');"
									. "\">&nbsp;";
						}

                        $OnClick = "";
						$OnClick .= "onclick=\"WsTreeOnClick(this,'" . $OBJ_ID . "',"
								. "'" . $TreeRow->Path . "',"
								. "'" . $TreeRow->NodeType . "',"
								. "'" . $TreeRow->Link . "',"
								. "'" . $TreeRow->AdminPermisions . "',"
								. "'" . $TreeRow->ViewPermisions . "',"
								. "'" . $TreeRow->Text . "',"
								. "'" . $TreeRow->Expanded . "'); ";
                                                              
						if ($this->OnClickJSFunction != "") 
						{
							$OnClick .= $this->OnClickJSFunction.";";
						}

						if ($this->OnClickSubmit)
						{
							$OnClick .= "WsTreeSubmit('" . $TreeRow->SlotID . "','" . $TreeRow->Path . "');";                   
						}

						$OnClick .= "\" ";

						// SELECTED NODE
						$Selected = "";

						if ($this->SelectedPath == $TreeRow->Path)
						{
							$Selected = " TreeView_SelectedNode";
						}

						if ($Selected == "");
						{
							if (isset($_POST[$OBJ_ID . "NodePath"]))
							{		
								if ($TreeRow->Path == $_POST[$OBJ_ID . "NodePath"])
								{
									$Selected = " TreeView_SelectedNode";
									$this->SelectedPath = $_POST[$OBJ_ID . "NodePath"];
								}
							}
						}

						if ($Selected == "");
						{
							if (isset($_COOKIE["TREEWIEW_SELECT_PATH"]))
							{
								if ($TreeRow->Path == $_COOKIE["TREEWIEW_SELECT_PATH"])
								{
									$Selected = " TreeView_SelectedNode";
									$this->SelectedPath = $_COOKIE["TREEWIEW_SELECT_PATH"];
								}
							}
						}
						


						if ($TreeRow->Link != "")
						{
							echo "<li class=\"TreeView_li\">" . $Edit . "<div class=\"TreeView_Leaf" . $Selected . "\" " . $OnClick . "><a href=\"" . $TreeRow->Link . "\">" . $Nome . "</a>";
						}
						else
						{
							echo "<li class=\"TreeView_li\">" . $Edit . "<div class=\"TreeView_Leaf" . $Selected . "\" " . $OnClick . ">&nbsp;" . $Nome;
						}

						echo "</div></li>";
					}
				}
			}
		}
		echo "</ul>\n";
	}

	public function GetNodeName($TreeRow)
	{
		$Fld = explode("/", $TreeRow->Path);
		return $Fld[count($Fld) - 1];
	}

	public function GetNodePath($TreeRow)
	{
		$Path = "";
		$P = strrchr($TreeRow->Path, "/");
		return str_replace("", $P, $TreeRow->Path);
	}

	public function GetNodeDeep($TreeRow)
	{
		$Fld = explode("/", $TreeRow->Path);
		return count($Fld);
	}

	public function GetRootNode()
	{
		if (count($this->TreeRows) == 0)
		{
			return("Root");
		}
		return $this->TreeRows[0]->Path;
	}

}

class WS_TreeViewRow
{

	public $PageID = 0;
	public $SlotID = "";
	public $Path = "Root";
	public $RecID = 0;
	public $NodeType = "F";
	public $Link = "";
	public $AdminPermisions = "admin";
	public $ViewPermisions = "all";
	public $TextPrec = "";
	public $Text = "";
	public $TextPost = "";
	public $Lang = "";
	public $Expanded = false;

	public function ToString()
	{
		return $this->PageID . "§" . $this->SlotID . "§" . $this->Path . "§" . $this->NodeType . "§" . $this->Link . "§" . $this->AdminPermisions . "§" . $this->ViewPermisions . "§" . $this->Text . "§" . $this->Expanded;
	}

	public function LoadFromString($Str)
	{
		$S = explode("§", $Str);
		$this->PageID = $S[0];
		$this->SlotID = $S[1];
		$this->Path = $S[2];
		$this->NodeType = $S[3];
		$this->Link = $S[4];
		$this->AdminPermisions = $S[5];
		$this->ViewPermisions = $S[6];
		$this->Text = $S[7];
		$this->Expanded = $S[7];
	}

}
?>
